/**
 * @ngdoc service
 * @name     aml.customer:alertsService
 *
 * @restrict E
 *
 * @description
 * The customers service is used to retrieve customers
 *
 * @element ANY
 * @required on-click
 *
 * @example
 */
(function() {
    'use strict';

    riskFactorsService.$inject = ["$resource", "amlConfig", "_", "exceptionResourceHandler", "$state"];
    angular
        .module('aml.customer.details')
        .factory('riskFactorsService', riskFactorsService);

    /* @ngInject */
    function riskFactorsService($resource, amlConfig, _, exceptionResourceHandler, $state) {

        /**
         * Resources
         */
        var riskFactorResource = $resource(amlConfig.baseUrl + '/alerts/:id/riskFactors',
            {
                id: '@id'
            }, { get: {
                method: 'GET', interceptor: {responseError: exceptionResourceHandler.resourceErrorHandler}}
            });

        var service = {
            getRiskFactors: getRiskFactors
        };

        return service;

        /////////////////////

        function getRiskFactors(alertid) {
            return riskFactorResource.get({
                id: alertid
            }).$promise;
        }



    }
})();
