-- Update FSK_RC_FORM_CONFIG 

ALTER TABLE FCFKC.FSK_RC_FORM_CONFIG
      ADD  IMPLEMENTATION_TYPE_CODE VARCHAR(32) NULL ;

CREATE OR REPLACE VIEW FCFBU1.FSK_RC_FORM_CONFIG AS SELECT * FROM FCFKC.FSK_RC_FORM_CONFIG; 

-- Recreate CDD Rule Tables

DROP VIEW FCFBU1.FSK_CDD_RULE;

DROP VIEW FCFBU1.FSK_CDD_RULE_PARAMETER;

DROP VIEW FCFBU1.FSK_CDD_RULE_GROUP;

DROP VIEW FCFBU1.FSK_CDD_SCORING_EVENT;

DROP TABLE FCFKC.FSK_CDD_RULE_PARAMETER;

DROP TABLE FCFKC.FSK_CDD_RULE;

DROP TABLE FCFKC.FSK_CDD_RULE_GROUP;

DROP TABLE FCFKC.FSK_CDD_SCORING_EVENT;

CREATE TABLE FCFKC.FSK_CDD_RULE
(
	cdd_rule_id          VARCHAR(32) NOT NULL ,
	version_no           NUMERIC(10) NOT NULL ,
	current_ind          CHAR(1)  ,
	cdd_update_date      TIMESTAMP NOT NULL ,
	cdd_create_date      TIMESTAMP NOT NULL ,
	cdd_rule_name        VARCHAR(100) NOT NULL ,
	cdd_rule_description VARCHAR(100) NOT NULL ,
	cdd_rule_status_code VARCHAR(32) NOT NULL ,
	cdd_rule_type_code   VARCHAR(32) NOT NULL ,
	cdd_rule_save_id_flg CHAR(1)  ,
	cdd_rule_order_in_group NUMERIC(12) NOT NULL ,
	cdd_rule_group_id    VARCHAR(32)  ,
	logical_delete_ind   CHAR(1)  ,
	create_user_id       VARCHAR(60)  ,
	lstupdate_user_id    VARCHAR(60)  ,
	CONSTRAINT  XPKFSK_CDD_RULE PRIMARY KEY (cdd_rule_id,version_no)
)
	IN KC_DATA36
	INDEX IN KC_INDEX36;

CREATE  INDEX FCFKC.XIF1FSK_CDD_RULE ON FCFKC.FSK_CDD_RULE
(cdd_rule_group_id   ASC);

CREATE TABLE FCFKC.FSK_CDD_RULE_GROUP
(
	cdd_rule_group_id    VARCHAR(32) NOT NULL ,
	version_no           NUMERIC(10) NOT NULL ,
	current_ind          CHAR(1)  ,
	cdd_update_date      TIMESTAMP NOT NULL ,
	cdd_create_date      TIMESTAMP NOT NULL ,
	cdd_rule_group_file_name VARCHAR(128)  ,
	cdd_rule_group_type  VARCHAR(32) NOT NULL ,
	cdd_rule_group_category_code VARCHAR(32)  ,
	cdd_rule_group_description VARCHAR(100) NOT NULL ,
	cdd_rule_group_name  VARCHAR(100) NOT NULL ,
	cdd_rule_group_input_ds_name VARCHAR(32)  ,
	cdd_rule_group_by_var_1_name VARCHAR(32)  ,
	cdd_rule_group_by_var_2_name VARCHAR(32)  ,
	cdd_rule_group_level NUMERIC(10)  ,
	cdd_rule_group_order_in_level NUMERIC(10)  ,
	cdd_rule_group_save_to_kc_flg CHAR(1)  ,
	cdd_rule_group_save_trig_v_flg CHAR(1)  ,
	lstupdate_user_id    VARCHAR(60)  ,
	logical_delete_ind   CHAR(1)  ,
	create_user_id       VARCHAR(60)  ,
	CONSTRAINT  XPKFSK_CDD_RULE_GROUP PRIMARY KEY (cdd_rule_group_id,version_no)
)
	IN KC_DATA40
	INDEX IN KC_INDEX40;

CREATE TABLE FCFKC.FSK_CDD_RULE_PARAMETER
(
	cdd_rule_version_no  NUMERIC(10) NOT NULL ,
	cdd_rule_parm_name   VARCHAR(100) NOT NULL ,
	cdd_rule_id          VARCHAR(32) NOT NULL ,
	cdd_rule_parm_description VARCHAR(100) NOT NULL ,
	cdd_rule_parm_type_code VARCHAR(32) NOT NULL ,
	cdd_rule_parm_val    VARCHAR(1024) NOT NULL ,
	CONSTRAINT  XPKFSK_CDD_RULE_PARAMETER PRIMARY KEY (cdd_rule_version_no,cdd_rule_parm_name,cdd_rule_id)
)
	IN KC_DATA41
	INDEX IN KC_INDEX41;

CREATE  INDEX FCFKC.XIF1FSK_CDD_RULE_PARAMETER ON FCFKC.FSK_CDD_RULE_PARAMETER
(cdd_rule_id   ASC);

CREATE TABLE FCFKC.FSK_CDD_SCORING_EVENT
(
	cdd_scoring_event_key NUMERIC(12) NOT NULL ,
	primary_entity_key   NUMERIC(12) NOT NULL ,
	primary_entity_number VARCHAR(50) NOT NULL ,
	primary_entity_level_code CHAR(3) NOT NULL ,
	cdd_rule_id          VARCHAR(32) NOT NULL ,
	version_no           NUMERIC(10)  ,
	rule_score           NUMERIC(10)  ,
	score_classification_code VARCHAR(32)  ,
	event_date           TIMESTAMP NOT NULL ,
	auto_high_ind        CHAR(1)  ,
	investigation_ind    CHAR(1)  ,
	category_code        VARCHAR(32)  ,
	score_type_code      VARCHAR(32)  ,
	CONSTRAINT  XPKFSK_CDD_SCORING_EVENT PRIMARY KEY (cdd_scoring_event_key)
)
	IN KC_DATA37
	INDEX IN KC_INDEX37;

CREATE UNIQUE INDEX FCFKC.XAK1FSK_CDD_SCORING_EVENT ON FCFKC.FSK_CDD_SCORING_EVENT
(cdd_scoring_event_key   ASC);

CREATE UNIQUE INDEX FCFKC.XAK2FSK_CDD_SCORING_EVENT ON FCFKC.FSK_CDD_SCORING_EVENT
(cdd_rule_id   ASC,primary_entity_key   ASC,event_date   ASC);

CREATE  INDEX FCFKC.XIE2FSK_CDD_SCORING_EVENT ON FCFKC.FSK_CDD_SCORING_EVENT
(primary_entity_number   ASC);

CREATE  INDEX FCFKC.XIF1FSK_CDD_SCORING_EVENT ON FCFKC.FSK_CDD_SCORING_EVENT
(cdd_rule_id   ASC,version_no   ASC);

GRANT SELECT, INSERT, DELETE, UPDATE on FCFKC.FSK_CDD_RULE to FCFBU1;

GRANT SELECT, INSERT, DELETE, UPDATE on FCFKC.FSK_CDD_RULE_GROUP to FCFBU1;

GRANT SELECT, INSERT, DELETE, UPDATE on FCFKC.FSK_CDD_RULE_PARAMETER to FCFBU1;

GRANT SELECT, INSERT, DELETE, UPDATE on FCFKC.FSK_CDD_SCORING_EVENT to FCFBU1;


CREATE OR REPLACE VIEW FCFBU1.FSK_CDD_RULE AS SELECT * FROM FCFKC.FSK_CDD_RULE;

CREATE OR REPLACE VIEW FCFBU1.FSK_CDD_RULE_GROUP AS SELECT * FROM FCFKC.FSK_CDD_RULE_GROUP;

CREATE OR REPLACE VIEW FCFBU1.FSK_CDD_RULE_PARAMETER AS SELECT * FROM FCFKC.FSK_CDD_RULE_PARAMETER;

CREATE OR REPLACE VIEW FCFBU1.FSK_CDD_SCORING_EVENT AS SELECT * FROM FCFKC.FSK_CDD_SCORING_EVENT;

-- update existing CDD view

CREATE OR REPLACE VIEW FCFBU1.FSK_CDD_TRIGGERING_VALUES AS SELECT * FROM FCFKC.FSK_CDD_TRIGGERING_VALUES;


-- Add CDD Review Tables


CREATE TABLE FCFKC.FSK_CDD_REVIEW
(
	review_key           NUMERIC(12) NOT NULL ,
	version_number       NUMERIC(10) NOT NULL ,
	primary_entity_number VARCHAR(50) NOT NULL ,
	primary_entity_level_code CHAR(3) NOT NULL ,
	employee_ind         CHAR(1)  ,
	status_code          VARCHAR(10)  ,
	owner_user_long_id   VARCHAR(60)  ,
	initial_scoring_event_key NUMERIC(12)  ,
	initial_risk_score   NUMERIC(10)  ,
	initial_risk_rating  VARCHAR(32)  ,
	initial_auto_high_ind CHAR(1)  ,
	periodic_review_date TIMESTAMP  ,
	last_review_date     TIMESTAMP  ,
	next_review_date     TIMESTAMP  ,
	review_due_date      TIMESTAMP  ,
	final_disposition_code VARCHAR(32)  ,
	rating_override      VARCHAR(32)  ,
	create_date          TIMESTAMP NOT NULL ,
	create_user_id       VARCHAR(60)  ,
	lstupdate_user_id    VARCHAR(60)  ,
	lstupdate_date       TIMESTAMP NOT NULL ,
	CONSTRAINT  XPKFSK_CDD_REVIEW PRIMARY KEY (review_key)
)
	IN KC_DATA40
	INDEX IN KC_INDEX40;

CREATE  INDEX FCFKC.XIE1FSK_CDD_REVIEW ON FCFKC.FSK_CDD_REVIEW
(primary_entity_number   ASC);

CREATE  INDEX FCFKC.XIE2FSK_CDD_REVIEW ON FCFKC.FSK_CDD_REVIEW
(primary_entity_level_code   ASC);

CREATE  INDEX FCFKC.XIE3FSK_CDD_REVIEW ON FCFKC.FSK_CDD_REVIEW
(owner_user_long_id   ASC);

CREATE  INDEX FCFKC.XIE4FSK_CDD_REVIEW ON FCFKC.FSK_CDD_REVIEW
(status_code   ASC);

CREATE  INDEX FCFKC.XIE5FSK_CDD_REVIEW ON FCFKC.FSK_CDD_REVIEW
(final_disposition_code   ASC);

CREATE TABLE FCFKC.FSK_CDD_REVIEW_EVENT
(
	event_id             NUMERIC(12) NOT NULL ,
	event_type_code      VARCHAR(3) NOT NULL ,
	event_description    VARCHAR(255)  ,
	create_user_id       VARCHAR(60) NOT NULL ,
	create_date          TIMESTAMP NOT NULL ,
	review_key           NUMERIC(12) NOT NULL ,
	CONSTRAINT  XPKFSK_CDD_REVIEW_EVENT PRIMARY KEY (event_id)
)
	IN KC_DATA40
	INDEX IN KC_INDEX40;

CREATE  INDEX FCFKC.XIF1FSK_CDD_REVIEW_EVENT ON FCFKC.FSK_CDD_REVIEW_EVENT
(review_key   ASC);

CREATE TABLE FCFKC.FSK_CDD_EDD_REVIEW
(
	review_key           NUMERIC(12) NOT NULL ,
	edd_step_code        VARCHAR(10) NOT NULL ,
	edd_step_sort_position_number INTEGER  ,
	edd_step_required    CHAR(1)  ,
	edd_step_completed   CHAR(1)  ,
	edd_step_notes       VARCHAR(100)  ,
	CONSTRAINT  XPKFSK_CDD_EDD_REVIEW PRIMARY KEY (review_key,edd_step_code)
)
	IN KC_DATA40
	INDEX IN KC_INDEX40;

CREATE  INDEX FCFKC.XIF1FSK_CDD_EDD_REVIEW ON FCFKC.FSK_CDD_EDD_REVIEW
(review_key   ASC);

ALTER TABLE FCFKC.FSK_CDD_REVIEW_EVENT
	ADD CONSTRAINT FK_CDD_REVIEW_EVENT_CDD_REVIEW FOREIGN KEY (review_key) REFERENCES FCFKC.FSK_CDD_REVIEW (review_key);

ALTER TABLE FCFKC.FSK_CDD_EDD_REVIEW
	ADD CONSTRAINT FK_CDD_EDD_REVIEW_CDD_REVIEW FOREIGN KEY (review_key) REFERENCES FCFKC.FSK_CDD_REVIEW (review_key);



GRANT SELECT, INSERT, DELETE, UPDATE on FCFKC.FSK_CDD_REVIEW to FCFBU1;

GRANT SELECT, INSERT, DELETE, UPDATE on FCFKC.FSK_CDD_EDD_REVIEW to FCFBU1;

GRANT SELECT, INSERT, DELETE, UPDATE on FCFKC.FSK_CDD_REVIEW_EVENT to FCFBU1;

CREATE OR REPLACE VIEW FCFBU1.FSK_CDD_REVIEW AS SELECT * FROM FCFKC.FSK_CDD_REVIEW;

CREATE OR REPLACE VIEW FCFBU1.FSK_CDD_EDD_REVIEW AS SELECT * FROM FCFKC.FSK_CDD_EDD_REVIEW;

CREATE OR REPLACE VIEW FCFBU1.FSK_CDD_REVIEW_EVENT AS SELECT * FROM FCFKC.FSK_CDD_REVIEW_EVENT;



