--------------------------------------------------------------
--------------------------------------------------------------
-- Scripts to update the object ID on comments in FSK_COMMENT
-- before HF4
--------------------------------------------------------------
--
-- Prior to HF4 the object id for EXT entities was the entity key
-- Post HF4 it is the entity number
--
-- The date in the where clause must be set to the date when
-- the hot fix was applied
--
--------------------------------------------------------------
--------------------------------------------------------------

update FCFKC.fsk_comment com set object_id =
    (select external_party_number from FCFCORE.fsc_ext_party_account_dim ext
    where com.object_id = to_char(ext.ext_party_account_key))
where   com.object_type_cd = 'EXT' and
        com.create_date < TIMESTAMP('2001-06-23 19:52:00') -- date of applying HF4
