-- Update FSK_RC_FORM_CONFIG 

ALTER TABLE FCFKC.FSK_RC_FORM_CONFIG
      ADD  IMPLEMENTATION_TYPE_CODE VARCHAR(32) NULL ;
      
CREATE OR REPLACE VIEW FCFBU1.FSK_RC_FORM_CONFIG AS SELECT * FROM FCFKC.FSK_RC_FORM_CONFIG; 


-- Recreate CDD Tables


DROP VIEW FCFBU1.FSK_CDD_RULE CASCADE CONSTRAINTS;

DROP VIEW FCFBU1.FSK_CDD_RULE_PARAMETER CASCADE CONSTRAINTS;

DROP VIEW FCFBU1.FSK_CDD_RULE_GROUP CASCADE CONSTRAINTS;

DROP VIEW FCFBU1.FSK_CDD_SCORING_EVENT CASCADE CONSTRAINTS;

DROP TABLE FCFKC.FSK_CDD_RULE_PARAMETER CASCADE CONSTRAINTS PURGE;

DROP TABLE FCFKC.FSK_CDD_RULE CASCADE CONSTRAINTS PURGE;

DROP TABLE FCFKC.FSK_CDD_RULE_GROUP CASCADE CONSTRAINTS PURGE;

DROP TABLE FCFKC.FSK_CDD_SCORING_EVENT CASCADE CONSTRAINTS PURGE;

CREATE TABLE FCFKC.FSK_CDD_RULE
(
	cdd_rule_id          VARCHAR2(32) NOT NULL ,
	version_no           NUMBER(10) NOT NULL ,
	current_ind          CHAR(1) NULL ,
	cdd_update_date      DATE NOT NULL ,
	cdd_create_date      DATE NOT NULL ,
	cdd_rule_name        VARCHAR2(100) NOT NULL ,
	cdd_rule_description VARCHAR2(100) NOT NULL ,
	cdd_rule_status_code VARCHAR2(32) NOT NULL ,
	cdd_rule_type_code   VARCHAR2(32) NOT NULL ,
	cdd_rule_save_id_flg CHAR(1) NULL ,
	cdd_rule_order_in_group NUMBER(12) NOT NULL ,
	cdd_rule_group_id    VARCHAR2(32) NULL ,
	logical_delete_ind   CHAR(1) NULL ,
	create_user_id       VARCHAR2(60) NULL ,
	lstupdate_user_id    VARCHAR2(60) NULL 
)
	 TABLESPACE KC_DATA01;

CREATE UNIQUE INDEX FCFKC.XPKFSK_CDD_RULE ON FCFKC.FSK_CDD_RULE
(cdd_rule_id   ASC,version_no   ASC)
	TABLESPACE KC_INDEX01;

ALTER TABLE FCFKC.FSK_CDD_RULE
	ADD CONSTRAINT  XPKFSK_CDD_RULE PRIMARY KEY (cdd_rule_id,version_no);

CREATE  INDEX FCFKC.XIF1FSK_CDD_RULE ON FCFKC.FSK_CDD_RULE
(cdd_rule_group_id   ASC)
	TABLESPACE KC_INDEX01;

CREATE TABLE FCFKC.FSK_CDD_RULE_GROUP
(
	cdd_rule_group_id    VARCHAR2(32) NOT NULL ,
	version_no           NUMBER(10) NOT NULL ,
	current_ind          CHAR(1) NULL ,
	cdd_update_date      DATE NOT NULL ,
	cdd_create_date      DATE NOT NULL ,
	cdd_rule_group_file_name VARCHAR2(128) NULL ,
	cdd_rule_group_type  VARCHAR2(32) NOT NULL ,
	cdd_rule_group_category_code VARCHAR2(32) NULL ,
	cdd_rule_group_description VARCHAR2(100) NOT NULL ,
	cdd_rule_group_name  VARCHAR2(100) NOT NULL ,
	cdd_rule_group_input_ds_name VARCHAR2(32) NULL ,
	cdd_rule_group_by_var_1_name VARCHAR2(32) NULL ,
	cdd_rule_group_by_var_2_name VARCHAR2(32) NULL ,
	cdd_rule_group_level NUMBER(10) NULL ,
	cdd_rule_group_order_in_level NUMBER(10) NULL ,
	cdd_rule_group_save_to_kc_flg CHAR(1) NULL ,
	cdd_rule_group_save_trig_v_flg CHAR(1) NULL ,
	lstupdate_user_id    VARCHAR2(60) NULL ,
	logical_delete_ind   CHAR(1) NULL ,
	create_user_id       VARCHAR2(60) NULL 
)
	 TABLESPACE KC_DATA01;

CREATE UNIQUE INDEX FCFKC.XPKFSK_CDD_RULE_GROUP ON FCFKC.FSK_CDD_RULE_GROUP
(cdd_rule_group_id   ASC,version_no   ASC)
	TABLESPACE KC_INDEX01;

ALTER TABLE FCFKC.FSK_CDD_RULE_GROUP
	ADD CONSTRAINT  XPKFSK_CDD_RULE_GROUP PRIMARY KEY (cdd_rule_group_id,version_no);

CREATE TABLE FCFKC.FSK_CDD_RULE_PARAMETER
(
	cdd_rule_version_no  NUMBER(10) NOT NULL ,
	cdd_rule_parm_name   VARCHAR2(100) NOT NULL ,
	cdd_rule_id          VARCHAR2(32) NOT NULL ,
	cdd_rule_parm_description VARCHAR2(100) NOT NULL ,
	cdd_rule_parm_type_code VARCHAR2(32) NOT NULL ,
	cdd_rule_parm_val    VARCHAR2(1024) NOT NULL 
)
	 TABLESPACE KC_DATA01;

CREATE UNIQUE INDEX FCFKC.XPKFSK_CDD_RULE_PARAMETER ON FCFKC.FSK_CDD_RULE_PARAMETER
(cdd_rule_version_no   ASC,cdd_rule_parm_name   ASC,cdd_rule_id   ASC)
	TABLESPACE KC_INDEX01;

ALTER TABLE FCFKC.FSK_CDD_RULE_PARAMETER
	ADD CONSTRAINT  XPKFSK_CDD_RULE_PARAMETER PRIMARY KEY (cdd_rule_version_no,cdd_rule_parm_name,cdd_rule_id);

CREATE  INDEX FCFKC.XIF1FSK_CDD_RULE_PARAMETER ON FCFKC.FSK_CDD_RULE_PARAMETER
(cdd_rule_id   ASC)
	TABLESPACE KC_INDEX01;

CREATE TABLE FCFKC.FSK_CDD_SCORING_EVENT
(
	cdd_scoring_event_key NUMBER(12) NOT NULL ,
	primary_entity_key   NUMBER(12) NOT NULL ,
	primary_entity_number VARCHAR2(50) NOT NULL ,
	primary_entity_level_code CHAR(3) NOT NULL ,
	cdd_rule_id          VARCHAR2(32) NOT NULL ,
	version_no           NUMBER(10) NULL ,
	rule_score           NUMBER(10) NULL ,
	score_classification_code VARCHAR2(32) NULL ,
	event_date           DATE NOT NULL ,
	auto_high_ind        CHAR(1) NULL ,
	investigation_ind    CHAR(1) NULL ,
	category_code        VARCHAR2(32) NULL ,
	score_type_code      VARCHAR2(32) NULL 
)
	 TABLESPACE KC_DATA01;

CREATE UNIQUE INDEX FCFKC.XPKFSK_CDD_SCORING_EVENT ON FCFKC.FSK_CDD_SCORING_EVENT
(cdd_scoring_event_key   ASC)
	TABLESPACE KC_INDEX01;

ALTER TABLE FCFKC.FSK_CDD_SCORING_EVENT
	ADD CONSTRAINT  XPKFSK_CDD_SCORING_EVENT PRIMARY KEY (cdd_scoring_event_key);

CREATE UNIQUE INDEX FCFKC.XAK2FSK_CDD_SCORING_EVENT ON FCFKC.FSK_CDD_SCORING_EVENT
(cdd_rule_id   ASC,primary_entity_key   ASC,event_date   ASC)
	TABLESPACE KC_INDEX01;

CREATE  INDEX FCFKC.XIE2FSK_CDD_SCORING_EVENT ON FCFKC.FSK_CDD_SCORING_EVENT
(primary_entity_number   ASC)
	TABLESPACE KC_INDEX01;

CREATE  INDEX FCFKC.XIF1FSK_CDD_SCORING_EVENT ON FCFKC.FSK_CDD_SCORING_EVENT
(cdd_rule_id   ASC,version_no   ASC)
	TABLESPACE KC_INDEX01;


GRANT SELECT, INSERT, DELETE, UPDATE on FCFKC.FSK_CDD_RULE to FCFBU1;

GRANT SELECT, INSERT, DELETE, UPDATE on FCFKC.FSK_CDD_RULE_GROUP to FCFBU1;

GRANT SELECT, INSERT, DELETE, UPDATE on FCFKC.FSK_CDD_RULE_PARAMETER to FCFBU1;

GRANT SELECT, INSERT, DELETE, UPDATE on FCFKC.FSK_CDD_SCORING_EVENT to FCFBU1;

CREATE OR REPLACE VIEW FCFBU1.FSK_CDD_RULE AS SELECT * FROM FCFKC.FSK_CDD_RULE;

CREATE OR REPLACE VIEW FCFBU1.FSK_CDD_RULE_GROUP AS SELECT * FROM FCFKC.FSK_CDD_RULE_GROUP;

CREATE OR REPLACE VIEW FCFBU1.FSK_CDD_RULE_PARAMETER AS SELECT * FROM FCFKC.FSK_CDD_RULE_PARAMETER;

CREATE OR REPLACE VIEW FCFBU1.FSK_CDD_SCORING_EVENT AS SELECT * FROM FCFKC.FSK_CDD_SCORING_EVENT;

-- update existing CDD view

CREATE OR REPLACE VIEW FCFBU1.FSK_CDD_TRIGGERING_VALUES AS SELECT * FROM FCFKC.FSK_CDD_TRIGGERING_VALUES;


-- Add New CDD Tables

CREATE TABLE FCFKC.FSK_CDD_REVIEW
(
	review_key           NUMBER(12) NOT NULL ,
	version_number       NUMBER(10) NOT NULL ,
	primary_entity_number VARCHAR2(50) NOT NULL ,
	primary_entity_level_code CHAR(3) NOT NULL ,
	employee_ind         CHAR(1) NULL ,
	status_code          VARCHAR2(10) NULL ,
	owner_user_long_id   VARCHAR2(60) NULL ,
	initial_scoring_event_key NUMBER(12) NULL ,
	initial_risk_score   NUMBER(10) NULL ,
	initial_risk_rating  VARCHAR2(32) NULL ,
	initial_auto_high_ind CHAR(1) NULL ,
	periodic_review_date DATE NULL ,
	last_review_date     DATE NULL ,
	next_review_date     DATE NULL ,
	review_due_date      DATE NULL ,
	final_disposition_code VARCHAR2(32) NULL ,
	rating_override      VARCHAR2(32) NULL ,
	create_date          DATE NOT NULL ,
	create_user_id       VARCHAR2(60) NULL ,
	lstupdate_user_id    VARCHAR2(60) NULL ,
	lstupdate_date       DATE NOT NULL 
)
	 TABLESPACE KC_DATA01;

CREATE UNIQUE INDEX FCFKC.XPKFSK_CDD_REVIEW ON FCFKC.FSK_CDD_REVIEW
(review_key   ASC)
	TABLESPACE KC_INDEX01;

ALTER TABLE FCFKC.FSK_CDD_REVIEW
	ADD CONSTRAINT  XPKFSK_CDD_REVIEW PRIMARY KEY (review_key);

CREATE  INDEX FCFKC.XIE1FSK_CDD_REVIEW ON FCFKC.FSK_CDD_REVIEW
(primary_entity_number   ASC)
	TABLESPACE KC_INDEX01;

CREATE  INDEX FCFKC.XIE2FSK_CDD_REVIEW ON FCFKC.FSK_CDD_REVIEW
(primary_entity_level_code   ASC)
	TABLESPACE KC_INDEX01;

CREATE  INDEX FCFKC.XIE3FSK_CDD_REVIEW ON FCFKC.FSK_CDD_REVIEW
(owner_user_long_id   ASC)
	TABLESPACE KC_INDEX01;

CREATE  INDEX FCFKC.XIE4FSK_CDD_REVIEW ON FCFKC.FSK_CDD_REVIEW
(status_code   ASC)
	TABLESPACE KC_INDEX01;

CREATE  INDEX FCFKC.XIE5FSK_CDD_REVIEW ON FCFKC.FSK_CDD_REVIEW
(final_disposition_code   ASC)
	TABLESPACE KC_INDEX01;

CREATE TABLE FCFKC.FSK_CDD_REVIEW_EVENT
(
	event_id             NUMBER(12) NOT NULL ,
	event_type_code      VARCHAR(3) NOT NULL ,
	event_description    VARCHAR2(255) NULL ,
	create_user_id       VARCHAR2(60) NOT NULL ,
	create_date          DATE NOT NULL ,
	review_key           NUMBER(12) NOT NULL 
)
	 TABLESPACE KC_DATA01;

CREATE UNIQUE INDEX FCFKC.XPKFSK_CDD_REVIEW_EVENT ON FCFKC.FSK_CDD_REVIEW_EVENT
(event_id   ASC)
	TABLESPACE KC_INDEX01;

ALTER TABLE FCFKC.FSK_CDD_REVIEW_EVENT
	ADD CONSTRAINT  XPKFSK_CDD_REVIEW_EVENT PRIMARY KEY (event_id);

CREATE  INDEX FCFKC.XIF1FSK_CDD_REVIEW_EVENT ON FCFKC.FSK_CDD_REVIEW_EVENT
(review_key   ASC)
	TABLESPACE KC_INDEX01;

CREATE TABLE FCFKC.FSK_CDD_EDD_REVIEW
(
	review_key           NUMBER(12) NOT NULL ,
	edd_step_code        VARCHAR2(10) NOT NULL ,
	edd_step_sort_position_number INTEGER NULL ,
	edd_step_required    CHAR(1) NULL ,
	edd_step_completed   CHAR(1) NULL ,
	edd_step_notes       VARCHAR2(100) NULL 
)
	 TABLESPACE KC_DATA01;

CREATE UNIQUE INDEX FCFKC.XPKFSK_CDD_EDD_REVIEW ON FCFKC.FSK_CDD_EDD_REVIEW
(review_key   ASC,edd_step_code   ASC)
	TABLESPACE KC_INDEX01;

ALTER TABLE FCFKC.FSK_CDD_EDD_REVIEW
	ADD CONSTRAINT  XPKFSK_CDD_EDD_REVIEW PRIMARY KEY (review_key,edd_step_code);

CREATE  INDEX FCFKC.XIF1FSK_CDD_EDD_REVIEW ON FCFKC.FSK_CDD_EDD_REVIEW
(review_key   ASC)
	TABLESPACE KC_INDEX01;

ALTER TABLE FCFKC.FSK_CDD_REVIEW_EVENT
	ADD (CONSTRAINT FK_CDD_REVIEW_EVENT_CDD_REVIEW FOREIGN KEY (review_key) REFERENCES FCFKC.FSK_CDD_REVIEW (review_key));

ALTER TABLE FCFKC.FSK_CDD_EDD_REVIEW
	ADD (CONSTRAINT FK_CDD_EDD_REVIEW_CDD_REVIEW FOREIGN KEY (review_key) REFERENCES FCFKC.FSK_CDD_REVIEW (review_key));



GRANT SELECT, INSERT, DELETE, UPDATE on FCFKC.FSK_CDD_REVIEW to FCFBU1;

GRANT SELECT, INSERT, DELETE, UPDATE on FCFKC.FSK_CDD_REVIEW_EVENT to FCFBU1;

GRANT SELECT, INSERT, DELETE, UPDATE on FCFKC.FSK_CDD_EDD_REVIEW to FCFBU1;

CREATE OR REPLACE VIEW FCFBU1.FSK_CDD_REVIEW AS SELECT * FROM FCFKC.FSK_CDD_REVIEW;

CREATE OR REPLACE VIEW FCFBU1.FSK_CDD_REVIEW_EVENT AS SELECT * FROM FCFKC.FSK_CDD_REVIEW_EVENT;

CREATE OR REPLACE VIEW FCFBU1.FSK_CDD_EDD_REVIEW AS SELECT * FROM FCFKC.FSK_CDD_EDD_REVIEW;


