-- NAME:    AML7.5.2__drop_bu.sql
-- PRODUCT: SAS Compliance Solutions
-- DESC:    drop indexes from business unit schema ready for column
--          type conversion
-------------------------------------------------------------------
-- USAGE:   Substiture the schema for each of your business units 
--          and execute in your SQL Server client
-------------------------------------------------------------------
-------------------------------------------------------------------
-- Copyright (c) 2018 by SAS Institute Inc., Cary, NC 27513 USA
--               All Rights Reserved.
-------------------------------------------------------------------

-- 7.1
USE [LOCALDB]
GO

ALTER TABLE SCHKC.FSK_ALERT_EMAIL
DROP CONSTRAINT FK_ALERT_EMAIL_ALERT
GO

ALTER TABLE SCHKC.FSK_ALERT_EVENT
DROP CONSTRAINT FK_ALERT_EVENT_ALERT
GO

ALTER TABLE SCHKC.FSK_SCENARIO
DROP CONSTRAINT FK_SCENARIO_HEADER
GO

ALTER TABLE SCHKC.FSK_SCENARIO
DROP CONSTRAINT R_66
GO

ALTER TABLE SCHKC.FSK_SCENARIO_ALERT_COLUMN
DROP CONSTRAINT R_265
GO

ALTER TABLE SCHKC.FSK_ALERT
DROP CONSTRAINT FK_ALRT_SCENARIO
GO

ALTER TABLE SCHKC.FSK_ENHANCED_ALERT
DROP CONSTRAINT R_266
GO

ALTER TABLE SCHKC.FSK_ALERT_NEIGHBOR
DROP CONSTRAINT R_56
GO

ALTER TABLE SCHKC.FSK_ALERT_REMINDER
DROP CONSTRAINT R_67
GO

ALTER TABLE SCHKC.FSK_ALERT_RISK_FACTOR
DROP CONSTRAINT R_51
GO

ALTER TABLE SCHKC.FSK_ALERT_RISK_FACTOR
DROP CONSTRAINT R_52
GO

ALTER TABLE SCHKC.FSK_ENHANCED_ALERT_RISK_FACTOR
DROP CONSTRAINT R_269
GO

ALTER TABLE SCHKC.FSK_ASSESSMENT_ROUTING_RULE
DROP CONSTRAINT R_100
GO

ALTER TABLE SCHKC.FSK_HEADER_ELEMENT
DROP CONSTRAINT FK_HEADER_ELEMENT_HEADER
GO

ALTER TABLE SCHKC.FSK_LIST
DROP CONSTRAINT R_72
GO

ALTER TABLE SCHKC.FSK_LIST_ELEMENT
DROP CONSTRAINT R_73
GO

ALTER TABLE SCHKC.FSK_RISK_ASSESSMENT_CLASSIFIER
DROP CONSTRAINT R_95
GO

ALTER TABLE SCHKC.FSK_RISK_ASSESSMENT_CLASSIFIER
DROP CONSTRAINT R_97
GO

ALTER TABLE SCHKC.FSK_RISK_ASSESSMENT_EMAIL
DROP CONSTRAINT FK_RISK_ASS_EMAIL_ALERT
GO

ALTER TABLE SCHKC.FSK_RISK_ASSESSMENT_EVENT
DROP CONSTRAINT FK_RISK_ASS_EVENT_ALERT
GO

ALTER TABLE SCHKC.FSK_RISK_CLASSIFIER
DROP CONSTRAINT R_79
GO

ALTER TABLE SCHKC.FSK_RISK_CLASSIFIER
DROP CONSTRAINT R_80
GO

ALTER TABLE SCHKC.FSK_ROUTING_RULE
DROP CONSTRAINT R_64
GO

ALTER TABLE SCHKC.FSK_SCENARIO_ALERT_CONSTRAINT
DROP CONSTRAINT R_273
GO

ALTER TABLE SCHKC.FSK_SCENARIO_FILTER
DROP CONSTRAINT R_270
GO

ALTER TABLE SCHKC.FSK_SCENARIO_MESSAGE_PARAMETER
DROP CONSTRAINT R_274
GO

ALTER TABLE SCHKC.FSK_SCENARIO_PARAMETER
DROP CONSTRAINT FK_SCENARIO_PARAMETER_SCENARIO
GO

ALTER TABLE SCHKC.FSK_SCENARIO_LOCALIZED_MSG
DROP CONSTRAINT R_285
GO

ALTER TABLE SCHKC.FSK_UI_COLUMN
DROP CONSTRAINT R_49
GO

ALTER TABLE SCHKC.FSK_CASE_ENTITY
DROP  CONSTRAINT R_393  
GO

ALTER TABLE SCHKC.FSK_RC_EFILE
DROP CONSTRAINT R_392
GO

ALTER TABLE SCHKC.FSK_RC_REPORT
DROP CONSTRAINT R_391
GO

ALTER TABLE SCHKC.FSK_RC_EFILE_REPORT
DROP CONSTRAINT R_383
GO

ALTER TABLE SCHKC.FSK_RC_EFILE_REPORT
DROP CONSTRAINT R_384
GO

ALTER TABLE SCHKC.FSK_RC_REPORT_ENTITY
DROP CONSTRAINT R_385
GO

ALTER TABLE SCHKC.FSK_RC_REPORT_ENTITY_EVENT
DROP CONSTRAINT R_407
GO

ALTER TABLE SCHKC.FSK_RC_REPORT_EVENT
DROP CONSTRAINT R_409
GO

ALTER TABLE SCHKC.FSK_UI_COLUMN
DROP CONSTRAINT R_50
GO

ALTER TABLE SCHKC.FSK_CDD_REVIEW_EVENT
DROP CONSTRAINT FK_CDD_REVIEW_EVENT_CDD_REVIEW
GO

ALTER TABLE SCHKC.FSK_CDD_EDD_REVIEW
DROP CONSTRAINT FK_CDD_EDD_REVIEW_CDD_REVIEW
GO

ALTER TABLE SCHKC.FSK_RC_REPORT_ENTITY_BRIDGE
DROP CONSTRAINT FSK_RC_ENT_BRIDGE_RPT
GO

ALTER TABLE SCHCORE.FSC_ACCOUNT_PROFILE_FACT
DROP CONSTRAINT R_6
GO

ALTER TABLE SCHCORE.FSC_CASH_FLOW_BANK_BRIDGE
DROP CONSTRAINT R_175
GO

ALTER TABLE SCHCORE.FSC_CASH_FLOW_BANK_BRIDGE
DROP CONSTRAINT R_176
GO

ALTER TABLE SCHCORE.FSC_CASH_FLOW_FACT
DROP CONSTRAINT FK_ACCOUNT_CREDIT
GO

ALTER TABLE SCHCORE.FSC_CASH_FLOW_FACT
DROP CONSTRAINT R_113
GO

ALTER TABLE SCHCORE.FSC_CASH_FLOW_FACT
DROP CONSTRAINT R_149
GO

ALTER TABLE SCHCORE.FSC_CASH_FLOW_FACT
DROP CONSTRAINT R_154
GO

ALTER TABLE SCHCORE.FSC_CASH_FLOW_FACT
DROP CONSTRAINT R_178
GO

ALTER TABLE SCHCORE.FSC_CASH_FLOW_FACT
DROP CONSTRAINT R_179
GO

ALTER TABLE SCHCORE.FSC_CASH_FLOW_FACT
DROP CONSTRAINT FK_BRANCH_CREDIT
GO

ALTER TABLE SCHCORE.FSC_CASH_FLOW_FACT
DROP CONSTRAINT FK_DATE_CREDIT
GO

ALTER TABLE SCHCORE.FSC_CASH_FLOW_FACT
DROP CONSTRAINT FK_TIME_CREDIT
GO

ALTER TABLE SCHCORE.FSC_CASH_FLOW_FACT
DROP CONSTRAINT R_389
GO

ALTER TABLE SCHCORE.FSC_HOUSEHOLD_PARTY_BRIDGE
DROP CONSTRAINT FK_CUST_HH_BRIDGE
GO

ALTER TABLE SCHCORE.FSC_HOUSEHOLD_PARTY_BRIDGE
DROP CONSTRAINT R_47
GO

ALTER TABLE SCHCORE.FSC_ACCOUNT_EVENT_FACT
DROP CONSTRAINT R_131
GO

ALTER TABLE SCHCORE.FSC_ACCOUNT_EVENT_FACT
DROP CONSTRAINT R_132
GO

ALTER TABLE SCHCORE.FSC_ACCOUNT_EVENT_FACT
DROP CONSTRAINT R_140
GO

ALTER TABLE SCHCORE.FSC_ACCOUNT_EVENT_FACT
DROP CONSTRAINT R_157
GO

ALTER TABLE SCHCORE.FSC_ACCOUNT_EVENT_FACT
DROP CONSTRAINT R_158
GO

ALTER TABLE SCHCORE.FSC_ACCOUNT_EVENT_FACT
DROP CONSTRAINT R_161
GO

ALTER TABLE SCHCORE.FSC_ACCOUNT_EVENT_FACT
DROP CONSTRAINT R_133
GO

ALTER TABLE SCHCORE.FSC_ACCOUNT_EVENT_FACT
DROP CONSTRAINT R_160
GO

ALTER TABLE SCHCORE.FSC_ACCOUNT_TRADE_FACT
DROP CONSTRAINT R_165
GO

ALTER TABLE SCHCORE.FSC_ACCOUNT_TRADE_FACT
DROP CONSTRAINT R_166
GO

ALTER TABLE SCHCORE.FSC_ACCOUNT_TRADE_FACT
DROP CONSTRAINT R_167
GO

ALTER TABLE SCHCORE.FSC_ACCOUNT_TRADE_FACT
DROP CONSTRAINT R_168
GO

ALTER TABLE SCHCORE.FSC_ACCOUNT_TRADE_FACT
DROP CONSTRAINT R_171
GO

ALTER TABLE SCHCORE.FSC_ACCOUNT_TRADE_FACT
DROP CONSTRAINT R_184
GO

ALTER TABLE SCHCORE.FSC_ACCOUNT_TRADE_FACT
DROP CONSTRAINT R_186
GO

ALTER TABLE SCHCORE.FSC_CLASSIFIER_FACT
DROP CONSTRAINT R_181
GO

ALTER TABLE SCHCORE.FSC_HOUSEHOLD_ACCOUNT_BRIDGE
DROP CONSTRAINT R_162
GO

ALTER TABLE SCHCORE.FSC_HOUSEHOLD_ACCOUNT_BRIDGE
DROP CONSTRAINT R_163
GO

ALTER TABLE SCHCORE.FSC_PARTY_ACCOUNT_BRIDGE
DROP CONSTRAINT FK_CUST_ACCT_BRIDGE
GO

ALTER TABLE SCHCORE.FSC_PARTY_ACCOUNT_BRIDGE
DROP CONSTRAINT R_8
GO

ALTER TABLE SCHCORE.FSC_PARTY_PROFILE_FACT
DROP CONSTRAINT R_155
GO

ALTER TABLE SCHCORE.FSC_CASH_FLOW_FACT
DROP CONSTRAINT R_85 ;

ALTER TABLE SCHCORE.FSC_CASH_FLOW_FACT
DROP CONSTRAINT R_126;

ALTER TABLE SCHCORE.FSC_ACCOUNT_TRADE_FACT
DROP CONSTRAINT R_169;

ALTER TABLE SCHCORE.FSC_ACCOUNT_TRADE_FACT
DROP CONSTRAINT R_170 ;

ALTER TABLE SCHCORE.FSC_CASH_FLOW_FACT
DROP CONSTRAINT R_111 ;

ALTER TABLE SCHCORE.FSC_CASH_FLOW_FACT
DROP CONSTRAINT R_159 ;

ALTER TABLE SCHCORE.FSC_SUMMARY_TRANS_TYPE_BRIDGE
DROP CONSTRAINT R_412 ;

drop index XIE2FSC_ACCOUNT_DIM ON SCHCORE.FSC_ACCOUNT_DIM;
DROP INDEX XIE6FSC_ASSOCIATE_DIM ON SCHCORE.FSC_ASSOCIATE_DIM;
DROP INDEX XIE2FSC_BRANCH_DIM ON SCHCORE.FSC_BRANCH_DIM;
DROP INDEX XIE1FSC_COUNTRY_DIM ON SCHCORE.FSC_COUNTRY_DIM;
DROP INDEX XIE2FSC_CURRENCY_DIM ON SCHCORE.FSC_CURRENCY_DIM;
DROP INDEX XIE4FSC_ENTITY_WATCH_LIST_DIM ON SCHCORE.FSC_ENTITY_WATCH_LIST_DIM;
DROP INDEX XIE2FSC_EXT_PARTY_ACCOUNT_DIM ON SCHCORE.FSC_EXT_PARTY_ACCOUNT_DIM;
DROP INDEX XIE5FSC_EXT_PARTY_ACCOUNT_DIM ON SCHCORE.FSC_EXT_PARTY_ACCOUNT_DIM;
DROP INDEX XIE3FSC_HOUSEHOLD_DIM ON SCHCORE.FSC_HOUSEHOLD_DIM;
DROP INDEX XIE20FSC_PARTY_DIM ON SCHCORE.FSC_PARTY_DIM;
DROP INDEX XIE16FSC_PARTY_DIM ON SCHCORE.FSC_PARTY_DIM;
DROP INDEX XIE12FSC_PARTY_DIM ON SCHCORE.FSC_PARTY_DIM;
DROP INDEX XIE7FSC_PARTY_DIM ON SCHCORE.FSC_PARTY_DIM;
DROP INDEX XIE22FSC_PARTY_DIM ON SCHCORE.FSC_PARTY_DIM;
DROP INDEX XIE15FSC_PARTY_DIM ON SCHCORE.FSC_PARTY_DIM;
DROP INDEX XIE21FSC_PARTY_DIM ON SCHCORE.FSC_PARTY_DIM;
DROP INDEX XIE6FSK_ALERT ON SCHKC.FSK_ALERT;
DROP INDEX XIE1FSK_LIST_ELEMENT ON SCHKC.FSK_LIST_ELEMENT;
