USE [LOCALDB]
GO

CREATE TABLE SCHCORE.FSC_ACCOUNT_STATE_VECTOR_FACT
(
	account_number       VARCHAR(50) NOT NULL ,
	date_key             DECIMAL(8) NOT NULL ,
	account_type_desc    VARCHAR(20) NOT NULL ,
	debits_total         DECIMAL(18,5)  ,
	credits_total        DECIMAL(18,5)  ,
	atm_debits_total     DECIMAL(18,5)  ,
	atm_credits_total    DECIMAL(18,5)  ,
	atm_d_trans_count    DECIMAL(10)  ,
	atm_c_trans_count    DECIMAL(10)  ,
	debit_trans_count    DECIMAL(10)  ,
	credit_trans_count   DECIMAL(10)  ,
	debit_loc_count      DECIMAL(10)  ,
	credit_loc_count     DECIMAL(10)  ,
	atm_d_loc_count      DECIMAL(10) NOT NULL ,
	atm_c_loc_count      DECIMAL(10)  ,
	wire_credit_total    DECIMAL(18,5)  ,
	wire_credit_trans_count DECIMAL(10)  ,
	wire_debits_total    DECIMAL(18,5)  ,
	wire_debit_trans_count DECIMAL(10)  ,
	d_i_wire_credits_total DECIMAL(18,5)  ,
	d_i_wire_credit_trans_count DECIMAL(10)  ,
	d_i_wire_debits_total DECIMAL(18,5)  ,
	d_i_wire_debit_trans_count DECIMAL(10)  ,
	balance_inquiry_count DECIMAL(10)  ,
	exceeded_daily_limit_count DECIMAL(10)  ,
	insufficient_funds_count DECIMAL(10)  ,
	CONSTRAINT XPKFSC_ACCOUNT_STATE_VECTOR_FA PRIMARY KEY CLUSTERED (account_number,date_key))
GO

CREATE  VIEW SCHBU1.FSC_ACCOUNT_STATE_VECTOR_FACT
AS  SELECT SCHCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.account_number
SCHCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.date_key,
SCHCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.account_type_desc,
SCHCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.debits_total,
SCHCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.credits_total,
SCHCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.atm_debits_total,
SCHCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.atm_credits_total,
SCHCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.atm_d_trans_count,
SCHCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.atm_c_trans_count,
SCHCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.debit_trans_count,
SCHCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.credit_trans_count,
SCHCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.debit_loc_count,
SCHCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.credit_loc_count,
SCHCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.atm_d_loc_count,
SCHCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.atm_c_loc_count,
SCHCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.wire_credit_total,
SCHCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.wire_credit_trans_count,
SCHCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.wire_debits_total,
SCHCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.wire_debit_trans_count,
SCHCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.d_i_wire_credits_total,
SCHCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.d_i_wire_credit_trans_count,
SCHCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.d_i_wire_debits_total,
SCHCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.d_i_wire_debit_trans_count,
SCHCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.balance_inquiry_count,
SCHCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.exceeded_daily_limit_count,
SCHCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.insufficient_funds_count
FROM SCHCORE.FSC_ACCOUNT_STATE_VECTOR_FACT
GO


CREATE VIEW SCHBU1.FSC_ACCOUNT_STATE_VECTOR_VIEW
AS
   SELECT
    account_number,
    account_type_desc,
    date_key,
        debits_total,
          SUM (debits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                               debits_total_5,
          SUM (debits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                              debits_total_10,
          SUM (debits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                              debits_total_30,
          credits_total,
          SUM (credits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                              credits_total_5,
          SUM (credits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                             credits_total_10,
          SUM (credits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                             credits_total_30,
          atm_debits_total,
          SUM (atm_debits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                           atm_debits_total_5,
          SUM (atm_debits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                          atm_debits_total_10,
          SUM (atm_debits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                          atm_debits_total_30,
          atm_credits_total,
          SUM (atm_credits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                          atm_credits_total_5,
          SUM (atm_credits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                         atm_credits_total_10,
          SUM (atm_credits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                         atm_credits_total_30,
          atm_d_trans_count,
          SUM (atm_d_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                          atm_d_trans_count_5,
          SUM (atm_d_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                         atm_d_trans_count_10,
          SUM (atm_d_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                         atm_d_trans_count_30,
          atm_c_trans_count,
          SUM (atm_c_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                          atm_c_trans_count_5,
          SUM (atm_c_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                         atm_c_trans_count_10,
          SUM (atm_c_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                         atm_c_trans_count_30,
          debit_trans_count,
          SUM (debit_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                          debit_trans_count_5,
          SUM (debit_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                         debit_trans_count_10,
          SUM (debit_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                         debit_trans_count_30,
          credit_trans_count,
          SUM (credit_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                         credit_trans_count_5,
          SUM (credit_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                        credit_trans_count_10,
          SUM (credit_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                        credit_trans_count_30,
          debit_loc_count,
          SUM (debit_loc_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                            debit_loc_count_5,
          SUM (debit_loc_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                           debit_loc_count_10,
          SUM (debit_loc_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                           debit_loc_count_30,
          credit_loc_count,
          SUM (credit_loc_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                           credit_loc_count_5,
          SUM (credit_loc_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                          credit_loc_count_10,
          SUM (credit_loc_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                          credit_loc_count_30,
          atm_d_loc_count,
          SUM (atm_d_loc_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                            atm_d_loc_count_5,
          SUM (atm_d_loc_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                           atm_d_loc_count_10,
          SUM (atm_d_loc_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                           atm_d_loc_count_30,
          atm_c_loc_count,
          SUM (atm_c_loc_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                            atm_c_loc_count_5,
          SUM (atm_c_loc_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                           atm_c_loc_count_10,
          SUM (atm_c_loc_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                           atm_c_loc_count_30,
          wire_credit_total,
          SUM (wire_credit_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                          wire_credit_total_5,
          SUM (wire_credit_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                         wire_credit_total_10,
          SUM (wire_credit_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                         wire_credit_total_30,
          wire_credit_trans_count,
          SUM (wire_credit_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                    wire_credit_trans_count_5,
          SUM (wire_credit_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                   wire_credit_trans_count_10,
          SUM (wire_credit_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                   wire_credit_trans_count_30,
          wire_debits_total,
          SUM (wire_debits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                          wire_debits_total_5,
          SUM (wire_debits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                         wire_debits_total_10,
          SUM (wire_debits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                         wire_debits_total_30,
          wire_debit_trans_count,
          SUM (wire_debit_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                     wire_debit_trans_count_5,
          SUM (wire_debit_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                    wire_debit_trans_count_10,
          SUM (wire_debit_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                    wire_debit_trans_count_30,
          d_i_wire_credits_total,
          SUM (d_i_wire_credits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                     d_i_wire_credits_total_5,
          SUM (d_i_wire_credits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                    d_i_wire_credits_total_10,
          SUM (d_i_wire_credits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                    d_i_wire_credits_total_30,
          d_i_wire_credit_trans_count,
          SUM (d_i_wire_credit_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                d_i_wire_credit_trans_count_5,
          SUM (d_i_wire_credit_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                               d_i_wire_credit_trans_count_10,
          SUM (d_i_wire_credit_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                               d_i_wire_credit_trans_count_30,
          d_i_wire_debits_total,
          SUM (d_i_wire_debits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                      d_i_wire_debits_total_5,
          SUM (d_i_wire_debits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                     d_i_wire_debits_total_10,
          SUM (d_i_wire_debits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                     d_i_wire_debits_total_30,
          d_i_wire_debit_trans_count,
          SUM (d_i_wire_debit_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                 d_i_wire_debit_trans_count_5,
          SUM (d_i_wire_debit_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                d_i_wire_debit_trans_count_10,
          SUM (d_i_wire_debit_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                d_i_wire_debit_trans_count_30,
          balance_inquiry_count,
          SUM (balance_inquiry_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                      balance_inquiry_count_5,
          SUM (balance_inquiry_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                     balance_inquiry_count_10,
          SUM (balance_inquiry_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                     balance_inquiry_count_30,
          exceeded_daily_limit_count,
          SUM (exceeded_daily_limit_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                 exceeded_daily_limit_count_5,
          SUM (exceeded_daily_limit_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                exceeded_daily_limit_count_10,
          SUM (exceeded_daily_limit_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                exceeded_daily_limit_count_30,
          insufficient_funds_count,
          SUM (insufficient_funds_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                   insufficient_funds_count_5,
          SUM (insufficient_funds_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                  insufficient_funds_count_10,
          SUM (insufficient_funds_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                  insufficient_funds_count_30
     FROM SCHCORE.fsc_account_state_vector_fact
	GO



