-- Updated with HF7 changes
REPLACE VIEW FCFBU1.FSK_SEQ AS LOCK ROW FOR ACCESS SELECT next_sequence_id FROM FCFKC.FSK_SEQ;

-- Update FSK_RC_FORM_CONFIG

ALTER TABLE FCFKC.FSK_RC_FORM_CONFIG
     ADD  IMPLEMENTATION_TYPE_CODE VARCHAR(32) NULL ;
     
DROP VIEW FCFBU1.FSK_RC_FORM_CONFIG;

CREATE VIEW FCFBU1.FSK_RC_FORM_CONFIG AS SELECT * FROM FCFKC.FSK_RC_FORM_CONFIG; 


-- Recreate CDD Rule Tables


DROP VIEW FCFBU1.FSK_CDD_RULE;

DROP VIEW FCFBU1.FSK_CDD_RULE_PARAMETER;

DROP VIEW FCFBU1.FSK_CDD_RULE_GROUP;

DROP VIEW FCFBU1.FSK_CDD_SCORING_EVENT;

DROP VIEW FCFBU1.FSK_CDD_TRIGGERING_VALUES;

DROP TABLE FCFKC.FSK_CDD_RULE_PARAMETER;

DROP TABLE FCFKC.FSK_CDD_RULE;

DROP TABLE FCFKC.FSK_CDD_RULE_GROUP;

DROP TABLE FCFKC.FSK_CDD_SCORING_EVENT;


CREATE SET TABLE FCFKC.FSK_CDD_RULE,
	 NO FALLBACK, 
	 NO BEFORE JOURNAL, 
	 NO AFTER JOURNAL, 
	 CHECKSUM = DEFAULT
(
	cdd_rule_id          VARCHAR(32) NOT NULL ,
	version_no           DECIMAL(10) NOT NULL ,
	current_ind          CHAR(1)  ,
	cdd_update_date      TIMESTAMP(6) NOT NULL ,
	cdd_create_date      TIMESTAMP(6) NOT NULL ,
	cdd_rule_name        VARCHAR(100) NOT NULL ,
	cdd_rule_description VARCHAR(100) NOT NULL ,
	cdd_rule_status_code VARCHAR(32) NOT NULL ,
	cdd_rule_type_code   VARCHAR(32) NOT NULL ,
	cdd_rule_save_id_flg CHAR(1)  ,
	cdd_rule_order_in_group DECIMAL(12) NOT NULL ,
	cdd_rule_group_id    VARCHAR(32)  ,
	logical_delete_ind   CHAR(1)  ,
	create_user_id       VARCHAR(60)  ,
	lstupdate_user_id    VARCHAR(60)  
)
	UNIQUE PRIMARY INDEX XPKFSK_CDD_RULE(cdd_rule_id,version_no);

CREATE  INDEX XIF1FSK_CDD_RULE(cdd_rule_group_id) ON FCFKC.FSK_CDD_RULE;

CREATE SET TABLE FCFKC.FSK_CDD_RULE_GROUP,
	 NO FALLBACK, 
	 NO BEFORE JOURNAL, 
	 NO AFTER JOURNAL, 
	 CHECKSUM = DEFAULT
(
	cdd_rule_group_id    VARCHAR(32) NOT NULL ,
	version_no           DECIMAL(10) NOT NULL ,
	current_ind          CHAR(1)  ,
	cdd_update_date      TIMESTAMP(6) NOT NULL ,
	cdd_create_date      TIMESTAMP(6) NOT NULL ,
	cdd_rule_group_file_name VARCHAR(128)  ,
	cdd_rule_group_type  VARCHAR(32) NOT NULL ,
	cdd_rule_group_category_code VARCHAR(32)  ,
	cdd_rule_group_description VARCHAR(100) NOT NULL ,
	cdd_rule_group_name  VARCHAR(100) NOT NULL ,
	cdd_rule_group_input_ds_name VARCHAR(32)  ,
	cdd_rule_group_by_var_1_name VARCHAR(32)  ,
	cdd_rule_group_by_var_2_name VARCHAR(32)  ,
	cdd_rule_group_level DECIMAL(10)  ,
	cdd_rule_group_order_in_level DECIMAL(10)  ,
	cdd_rule_group_save_to_kc_flg CHAR(1)  ,
	cdd_rule_group_save_trig_v_flg CHAR(1)  ,
	lstupdate_user_id    VARCHAR(60)  ,
	logical_delete_ind   CHAR(1)  ,
	create_user_id       VARCHAR(60)  
)
	UNIQUE PRIMARY INDEX XPKFSK_CDD_RULE_GROUP(cdd_rule_group_id,version_no);

CREATE SET TABLE FCFKC.FSK_CDD_RULE_PARAMETER,
	 NO FALLBACK, 
	 NO BEFORE JOURNAL, 
	 NO AFTER JOURNAL, 
	 CHECKSUM = DEFAULT
(
	cdd_rule_version_no  DECIMAL(10) NOT NULL ,
	cdd_rule_parm_name   VARCHAR(100) NOT NULL ,
	cdd_rule_id          VARCHAR(32) NOT NULL ,
	cdd_rule_parm_description VARCHAR(100) NOT NULL ,
	cdd_rule_parm_type_code VARCHAR(32) NOT NULL ,
	cdd_rule_parm_val    VARCHAR(1024) NOT NULL 
)
	UNIQUE PRIMARY INDEX XPKFSK_CDD_RULE_PARAMETER(cdd_rule_version_no,cdd_rule_parm_name,cdd_rule_id);

CREATE  INDEX XIF1FSK_CDD_RULE_PARAMETER(cdd_rule_id) ON FCFKC.FSK_CDD_RULE_PARAMETER;


CREATE SET TABLE FCFKC.FSK_CDD_SCORING_EVENT,
	 NO FALLBACK, 
	 NO BEFORE JOURNAL, 
	 NO AFTER JOURNAL, 
	 CHECKSUM = DEFAULT
(
	cdd_scoring_event_key DECIMAL(12) NOT NULL ,
	primary_entity_key   DECIMAL(12) NOT NULL ,
	primary_entity_number VARCHAR(50) NOT NULL ,
	primary_entity_level_code CHAR(3) NOT NULL ,
	cdd_rule_id          VARCHAR(32) NOT NULL ,
	version_no           DECIMAL(10)  ,
	rule_score           DECIMAL(10)  ,
	score_classification_code VARCHAR(32)  ,
	event_date           TIMESTAMP(6) NOT NULL ,
	auto_high_ind        CHAR(1)  ,
	investigation_ind    CHAR(1)  ,
	category_code        VARCHAR(32)  ,
	score_type_code      VARCHAR(32)  
)
	UNIQUE PRIMARY INDEX XPKFSK_CDD_SCORING_EVENT(cdd_scoring_event_key);

CREATE  UNIQUE  INDEX XAK2FSK_CDD_SCORING_EVENT(cdd_rule_id, primary_entity_key, event_date) ON FCFKC.FSK_CDD_SCORING_EVENT;

CREATE  INDEX XIE2FSK_CDD_SCORING_EVENT(primary_entity_number) ON FCFKC.FSK_CDD_SCORING_EVENT;

CREATE  INDEX XIF1FSK_CDD_SCORING_EVENT(cdd_rule_id, version_no) ON FCFKC.FSK_CDD_SCORING_EVENT;


CREATE VIEW FCFBU1.FSK_CDD_RULE AS SELECT * FROM FCFKC.FSK_CDD_RULE;

CREATE VIEW FCFBU1.FSK_CDD_RULE_GROUP AS SELECT * FROM FCFKC.FSK_CDD_RULE_GROUP;

CREATE VIEW FCFBU1.FSK_CDD_RULE_PARAMETER AS SELECT * FROM FCFKC.FSK_CDD_RULE_PARAMETER;

CREATE VIEW FCFBU1.FSK_CDD_SCORING_EVENT AS SELECT * FROM FCFKC.FSK_CDD_SCORING_EVENT;

-- Update existing CDD views

CREATE VIEW FCFBU1.FSK_CDD_TRIGGERING_VALUES AS SELECT * FROM FCFKC.FSK_CDD_TRIGGERING_VALUES;




-- Add CDD Review Tables


CREATE SET TABLE FCFKC.FSK_CDD_REVIEW,
	 NO FALLBACK, 
	 NO BEFORE JOURNAL, 
	 NO AFTER JOURNAL, 
	 CHECKSUM = DEFAULT
(
	review_key           DECIMAL(12) NOT NULL ,
	version_number       DECIMAL(10) NOT NULL ,
	primary_entity_number VARCHAR(50) NOT NULL ,
	primary_entity_level_code CHAR(3) NOT NULL ,
	employee_ind         CHAR(1)  ,
	status_code          VARCHAR(10)  ,
	owner_user_long_id   VARCHAR(60)  ,
	initial_scoring_event_key DECIMAL(12)  ,
	initial_risk_score   DECIMAL(10)  ,
	initial_risk_rating  VARCHAR(32)  ,
	initial_auto_high_ind CHAR(1)  ,
	periodic_review_date TIMESTAMP(6)  ,
	last_review_date     TIMESTAMP(6)  ,
	next_review_date     TIMESTAMP(6)  ,
	review_due_date      TIMESTAMP(6)  ,
	final_disposition_code VARCHAR(32)  ,
	rating_override      VARCHAR(32)  ,
	create_date          TIMESTAMP(6) NOT NULL ,
	create_user_id       VARCHAR(60)  ,
	lstupdate_user_id    VARCHAR(60)  ,
	lstupdate_date       TIMESTAMP(6) NOT NULL 
)
	UNIQUE PRIMARY INDEX XPKFSK_CDD_REVIEW(review_key);

CREATE  INDEX XIE1FSK_CDD_REVIEW(primary_entity_number) ON FCFKC.FSK_CDD_REVIEW;

CREATE  INDEX XIE2FSK_CDD_REVIEW(primary_entity_level_code) ON FCFKC.FSK_CDD_REVIEW;

CREATE  INDEX XIE3FSK_CDD_REVIEW(owner_user_long_id) ON FCFKC.FSK_CDD_REVIEW;

CREATE  INDEX XIE4FSK_CDD_REVIEW(status_code) ON FCFKC.FSK_CDD_REVIEW;

CREATE  INDEX XIE5FSK_CDD_REVIEW(final_disposition_code) ON FCFKC.FSK_CDD_REVIEW;

CREATE SET TABLE FCFKC.FSK_CDD_REVIEW_EVENT,
	 NO FALLBACK, 
	 NO BEFORE JOURNAL, 
	 NO AFTER JOURNAL, 
	 CHECKSUM = DEFAULT
(
	event_id             DECIMAL(12) NOT NULL ,
	event_type_code      VARCHAR(3) NOT NULL ,
	event_description    VARCHAR(255)  ,
	create_user_id       VARCHAR(60) NOT NULL ,
	create_date          TIMESTAMP(6) NOT NULL ,
	review_key           DECIMAL(12) NOT NULL 
)
	UNIQUE PRIMARY INDEX XPKFSK_CDD_REVIEW_EVENT(event_id);

CREATE  INDEX XIF1FSK_CDD_REVIEW_EVENT(review_key) ON FCFKC.FSK_CDD_REVIEW_EVENT;

CREATE SET TABLE FCFKC.FSK_CDD_EDD_REVIEW,
	 NO FALLBACK, 
	 NO BEFORE JOURNAL, 
	 NO AFTER JOURNAL, 
	 CHECKSUM = DEFAULT
(
	review_key           DECIMAL(12) NOT NULL ,
	edd_step_code        VARCHAR(10) NOT NULL ,
	edd_step_sort_position_number INTEGER  ,
	edd_step_required    CHAR(1)  ,
	edd_step_completed   CHAR(1)  ,
	edd_step_notes       VARCHAR(100)  
)
	UNIQUE PRIMARY INDEX XPKFSK_CDD_EDD_REVIEW(review_key,edd_step_code);

CREATE  INDEX XIF1FSK_CDD_EDD_REVIEW(review_key) ON FCFKC.FSK_CDD_EDD_REVIEW;



CREATE VIEW FCFBU1.FSK_CDD_REVIEW AS SELECT * FROM FCFKC.FSK_CDD_REVIEW;

CREATE VIEW FCFBU1.FSK_CDD_EDD_REVIEW AS SELECT * FROM FCFKC.FSK_CDD_EDD_REVIEW;

CREATE VIEW FCFBU1.FSK_CDD_REVIEW_EVENT AS SELECT * FROM FCFKC.FSK_CDD_REVIEW_EVENT;
-- Modify FSK_RC_REPORT
ALTER TABLE FCFKC.FSK_RC_REPORT ADD SAR90_CASE_ID DECIMAL(12) NULL ;
DROP VIEW FCFBU1.FSK_RC_REPORT;
CREATE VIEW FCFBU1.FSK_RC_REPORT AS SELECT * FROM FCFKC.FSK_RC_REPORT;

-- Modify FSK_CASE
ALTER TABLE FCFKC.FSK_CASE ADD  ACTIVATE_DATE TIMESTAMP NULL ;

-- Modify FSK_RC_REPORT_ENTITY_INFO

ALTER TABLE FCFKC.FSK_RC_REPORT_ENTITY_INFO ADD PARENT_ENTITY_NUMBER VARCHAR(32) NULL;
ALTER TABLE FCFKC.FSK_RC_REPORT_ENTITY_INFO ADD DEFAULT_IND CHAR(1) NULL;

DROP VIEW FCFBU1.FSK_RC_REPORT_ENTITY_INFO;

CREATE VIEW FCFBU1.FSK_RC_REPORT_ENTITY_INFO AS SELECT * FROM FCFKC.FSK_RC_REPORT_ENTITY_INFO;
-- Update FSC_EXT_PARTY_ACCOUNT_DIM with SCD2 columns

ALTER TABLE FCFCORE.FSC_EXT_PARTY_ACCOUNT_DIM ADD change_begin_date    TIMESTAMP(6) NOT NULL DEFAULT current_timestamp;
ALTER TABLE FCFCORE.FSC_EXT_PARTY_ACCOUNT_DIM ADD change_end_date      TIMESTAMP(6) NOT NULL  DEFAULT TIMESTAMP '5999-01-01 00:00:00.000000';
ALTER TABLE FCFCORE.FSC_EXT_PARTY_ACCOUNT_DIM ADD change_current_ind   CHAR(1) NOT NULL DEFAULT 'Y';

DROP VIEW FCFBU1.FSC_EXT_PARTY_ACCOUNT_DIM;
CREATE VIEW FCFBU1.FSC_EXT_PARTY_ACCOUNT_DIM AS SELECT * FROM FCFCORE.FSC_EXT_PARTY_ACCOUNT_DIM;

-- Recreate the Alert Triage Datamart to contain entity numbers

---- Drop Datamart Views 
DROP VIEW FCFBU1.FSK_ALERT_TX_AGG;
DROP VIEW FCFBU1.FSK_ENTITY_TX_AGG;
DROP VIEW FCFBU1.FSK_ALERTED_ENTITY;
DROP VIEW FCFBU1.FSK_ENTITY_TRANSACTION;
DROP VIEW FCFBU1.FSK_ALERT_TRANSACTION;

---- Drop Datamart Tables
DROP TABLE FCFKC.FSK_ENTITY_TX_AGG; 
DROP TABLE FCFKC.FSK_ALERT_TX_AGG; 
DROP TABLE FCFKC.FSK_ENTITY_TRANSACTION; 
-- DROP TABLE FCFKC.FSK_ALERTED_ENTITY;
DROP TABLE FCFKC.FSK_ALERT_TRANSACTION; 

RENAME TABLE FCFKC.FSK_ALERTED_ENTITY TO FCFKC.FSK_ALERTED_ENTITY_TOGO;

---- Create Tables;
CREATE SET TABLE FCFKC.FSK_ALERTED_ENTITY,
	 NO FALLBACK,
	 NO BEFORE JOURNAL,
	 NO AFTER JOURNAL,
	 CHECKSUM = DEFAULT
(
	alerted_entity_level_code CHAR(3) NOT NULL ,
	alerted_entity_number VARCHAR(50) NOT NULL ,
	alerted_entity_name  VARCHAR(35)  ,
	alerts_cnt           DECIMAL(4)  ,
	transactions_cnt     DECIMAL(8)  ,
	aggregate_amt        DECIMAL(15,3)  ,
	age_oldest_alert     DECIMAL(4)  ,
	risk_Score_code      VARCHAR(32)  ,
	money_laundering_score DECIMAL(4)  ,
	employee_ind         CHAR(1)  ,
	owner_userid         VARCHAR(240)  ,
	politically_exposed_person_ind CHAR(1)  ,
	created_timestamp    TIMESTAMP(6)
)
	UNIQUE PRIMARY INDEX XPKFSK_ALERTED_ENTITY(alerted_entity_level_code,alerted_entity_number);

INSERT INTO FCFKC.FSK_ALERTED_ENTITY (
  alerted_entity_level_code,alerted_entity_number,alerted_entity_name,alerts_cnt,
	transactions_cnt,aggregate_amt,age_oldest_alert,risk_Score_code,money_laundering_score,employee_ind,owner_userid,
	politically_exposed_person_ind,	created_timestamp
	)
	SELECT
	alerted_entity_level_code,alerted_entity_number,alerted_entity_name,alerts_cnt,
	transactions_cnt,aggregate_amt,age_oldest_alert,risk_Score_code,money_laundering_score,employee_ind,owner_userid,
	politically_exposed_person_ind,	created_timestamp
	from
	FCFKC.FSK_ALERTED_ENTITY_TOGO;

DROP TABLE FCFKC.FSK_ALERTED_ENTITY_TOGO;

CREATE SET TABLE FCFKC.FSK_ALERT_TRANSACTION,
	 NO FALLBACK, 
	 NO BEFORE JOURNAL, 
	 NO AFTER JOURNAL, 
	 CHECKSUM = DEFAULT
(
	fsk_alert_transaction_pk DECIMAL(22) NOT NULL ,
	alerted_entity_level_code CHAR(3)  ,
        alerted_entity_number VARCHAR(50)  ,
	alert_id             DECIMAL(12)  ,
	transaction_id       VARCHAR(50)  ,
	transaction_amt      NUMERIC(15,3)  ,
	transaction_cdi_desc VARCHAR(30)  ,
	primary_medium_desc  VARCHAR(30)  ,
	secondary_medium_desc VARCHAR(30)  ,
	transaction_date     TIMESTAMP  ,
	transaction_mechanism VARCHAR(50)  ,
	account_number       VARCHAR(50)  ,
	beneficiary_name     VARCHAR(200)  ,
	associate_name       VARCHAR(250)  ,
	Branch_name          VARCHAR(100)  ,
	transaction_desc     VARCHAR(255)  ,
	transaction_status   VARCHAR(20)  ,
	triggering_indicator_cd VARCHAR(3)  ,
	created_timestamp    TIMESTAMP  ,
	date_key             DECIMAL(8)  ,
	time_key             DECIMAL(6)  
)
	UNIQUE PRIMARY INDEX XPKFSK_ALERT_TRANSACTION(fsk_alert_transaction_pk);

CREATE  INDEX XIF2FSK_ALERT_TRANSACTION(alert_id) ON FCFKC.FSK_ALERT_TRANSACTION;

CREATE  INDEX XIF3FSK_ALERT_TRANSACTION(alerted_entity_level_code, alerted_entity_number) ON FCFKC.FSK_ALERT_TRANSACTION;

CREATE SET TABLE FCFKC.FSK_ALERT_TX_AGG,
	 NO FALLBACK, 
	 NO BEFORE JOURNAL, 
	 NO AFTER JOURNAL, 
	 CHECKSUM = DEFAULT
(
	fsk_alert_tx_agg_pk  DECIMAL(12) NOT NULL ,
	alert_id             DECIMAL(12)  ,
	aggregate_type_code  VARCHAR(35)  ,
	group_code           VARCHAR(30)  ,
	group_desc           VARCHAR(30)  ,
	aggregate_amt        DECIMAL(15,3)  ,
	created_timestamp    TIMESTAMP  
)
	UNIQUE PRIMARY INDEX XPKFSK_ALERT_TX_AGG(fsk_alert_tx_agg_pk);

CREATE  INDEX XIF1FSK_ALERT_TX_AGG(alert_id) ON FCFKC.FSK_ALERT_TX_AGG;

CREATE SET TABLE FCFKC.FSK_ENTITY_TRANSACTION,
	 NO FALLBACK, 
	 NO BEFORE JOURNAL, 
	 NO AFTER JOURNAL, 
	 CHECKSUM = DEFAULT
(
	fsk_entity_transaction_pk DECIMAL(22) NOT NULL ,
	alerted_entity_level_code CHAR(3)  ,
        alerted_entity_number VARCHAR(50)  ,
	transaction_id       VARCHAR(50)  ,
	transaction_amt      NUMERIC(15,3)  ,
	transaction_cdi_desc VARCHAR(30)  ,
	primary_medium_desc  VARCHAR(30)  ,
	secondary_medium_desc VARCHAR(30)  ,
	transaction_date     TIMESTAMP  ,
	transaction_mechanism VARCHAR(50)  ,
	account_number       VARCHAR(50)  ,
	beneficiary_name     VARCHAR(200)  ,
	associate_name       VARCHAR(250)  ,
	Branch_name          VARCHAR(100)  ,
	transaction_desc     VARCHAR(255)  ,
	transaction_status   VARCHAR(20)  ,
	created_timestamp    TIMESTAMP  ,
	date_key             DECIMAL(8)  ,
	time_key             DECIMAL(6)  ,
	household_number     VARCHAR(50)
)
	UNIQUE PRIMARY INDEX XPKFSK_ENTITY_TRANSACTION(fsk_entity_transaction_pk);

CREATE  INDEX XIF1FSK_ENTITY_TRANSACTION(alerted_entity_level_code, alerted_entity_number) ON FCFKC.FSK_ENTITY_TRANSACTION;

CREATE SET TABLE FCFKC.FSK_ENTITY_TX_AGG,
	 NO FALLBACK, 
	 NO BEFORE JOURNAL, 
	 NO AFTER JOURNAL, 
	 CHECKSUM = DEFAULT
(
	fsk_entity_tx_agg_pk DECIMAL(12) NOT NULL ,
	alerted_entity_level_code CHAR(3)  ,
        alerted_entity_number VARCHAR(50)  ,
	aggregate_type_code  VARCHAR(4)  ,
	group_code           VARCHAR(50)  ,
	group_desc           VARCHAR(50)  ,
	aggregate_amt        DECIMAL(15,3)  ,
	created_timestamp    TIMESTAMP  
)
	UNIQUE PRIMARY INDEX XPKFSK_ENTITY_TX_AGG(fsk_entity_tx_agg_pk);

CREATE  INDEX XIF1FSK_ENTITY_TX_AGG(alerted_entity_level_code, alerted_entity_number) ON FCFKC.FSK_ENTITY_TX_AGG;

---- Create Views
CREATE  VIEW FCFBU1.FSK_ALERT_TX_AGG AS SELECT * FROM FCFKC.FSK_ALERT_TX_AGG;
CREATE  VIEW FCFBU1.FSK_ENTITY_TX_AGG AS SELECT * FROM FCFKC.FSK_ENTITY_TX_AGG;
CREATE  VIEW FCFBU1.FSK_ALERTED_ENTITY AS SELECT * FROM FCFKC.FSK_ALERTED_ENTITY;
CREATE  VIEW FCFBU1.FSK_ALERT_TRANSACTION AS SELECT * FROM FCFKC.FSK_ALERT_TRANSACTION;
CREATE  VIEW FCFBU1.FSK_ENTITY_TRANSACTION AS SELECT * FROM FCFKC.FSK_ENTITY_TRANSACTION;

-- modify FSC_PARTY_DIM for Beneficial Ownership support
ALTER TABLE FCFCORE.FSC_PARTY_DIM ADD  ben_own_exempt_ind   CHAR(1) NULL DEFAULT 'N';
DROP VIEW FCFBU1.FSC_PARTY_DIM;
CREATE VIEW FCFBU1.FSC_PARTY_DIM AS SELECT * FROM FCFCORE.FSC_PARTY_DIM;

-- modify FSC_ACCOUNT_DIM for Beneficial Ownership support
ALTER TABLE FCFCORE.FSC_ACCOUNT_DIM ADD opened_by_party_number       VARCHAR(50) NULL;
ALTER TABLE FCFCORE.FSC_ACCOUNT_DIM ADD opened_by_party_name         VARCHAR(200) NULL;
ALTER TABLE FCFCORE.FSC_ACCOUNT_DIM ADD opened_by_party_title        VARCHAR(50) NULL;
DROP VIEW FCFBU1.FSC_ACCOUNT_DIM;
CREATE VIEW FCFBU1.FSC_ACCOUNT_DIM AS SELECT * FROM FCFCORE.FSC_ACCOUNT_DIM;

ALTER TABLE FCFKC.FSK_CASE ADD case_description VARCHAR(100);
DROP VIEW FCFBU1.FSK_CASE;
CREATE VIEW FCFBU1.FSK_CASE AS SELECT * FROM FCFKC.FSK_CASE;
-- Add segments
CREATE SET TABLE FCFKC.FSK_SEGMENT,
 	 NO FALLBACK,
	 NO BEFORE JOURNAL,
	 NO AFTER JOURNAL,
	 CHECKSUM = DEFAULT
(
  entity_segment_key  DECIMAL(12) NOT NULL,
  entity_segment_id   DECIMAL(12) NOT NULL,
  segment_name        VARCHAR(50),
  segment_description VARCHAR(100),
  lstupdate_user      VARCHAR(60),
  logical_delete_ind  CHAR(1),
  active_ind          CHAR(1),
  change_begin_date   TIMESTAMP(6) NOT NULL DEFAULT current_timestamp,
  change_end_date     TIMESTAMP(6) NOT NULL  DEFAULT TIMESTAMP '5999-01-01 00:00:00.000000',
  change_current_ind  CHAR(1) NOT NULL DEFAULT 'Y'
)
UNIQUE PRIMARY INDEX XPKFSK_SEGMENT(entity_segment_key);

ALTER TABLE FCFCORE.FSC_ACCOUNT_DIM   ADD entity_segment_id DECIMAL(12) NULL;
ALTER TABLE FCFCORE.FSC_PARTY_DIM     ADD entity_segment_id DECIMAL(12) NULL;
ALTER TABLE FCFKC.FSK_ALERT           ADD entity_segment_id DECIMAL(12) NULL;
ALTER TABLE FCFKC.FSK_ALERTED_ENTITY  ADD alerted_entity_segment_id DECIMAL(12) NULL;
ALTER TABLE FCFKC.FSK_ALERTED_ENTITY  DROP COLUMN owner_userid;
ALTER TABLE FCFKC.FSK_ALERTED_ENTITY  ADD alerted_entity_name VARCHAR(200);

CREATE  VIEW FCFBU1.FSK_SEGMENT AS SELECT * FROM FCFKC.FSK_SEGMENT;
REPLACE VIEW FCFBU1.FSC_PARTY_DIM AS SELECT * FROM FCFCORE.FSC_PARTY_DIM;
REPLACE VIEW FCFBU1.FSK_ALERTED_ENTITY AS SELECT * FROM FCFKC.FSK_ALERTED_ENTITY;

ALTER TABLE FCFKC.FSK_SCENARIO_PARAMETER ADD btl_parm_value  VARCHAR(1024) NULL;
ALTER TABLE FCFKC.FSK_SCENARIO_PARAMETER ADD entity_segment_id   DECIMAL(12) NOT NULL DEFAULT -1;
-- SECONDARY INDEX is needed so that MODIFY UNIQUE PRIMARY can be run on non-empty table
CREATE UNIQUE INDEX USI_SCENARIO_PARAMETER (scenario_id, entity_segment_id, parm_name) ON FCFKC.FSK_SCENARIO_PARAMETER;
ALTER TABLE FCFKC.FSK_SCENARIO_PARAMETER  MODIFY UNIQUE PRIMARY INDEX PK_SCENARIO_PARAMETER (scenario_id, entity_segment_id, parm_name);
REPLACE VIEW FCFBU1.FSK_SCENARIO_PARAMETER AS SELECT * FROM FCFKC.FSK_SCENARIO_PARAMETER;

ALTER TABLE FCFKC.FSK_SCENARIO ADD segments_enabled_ind CHAR(1) NULL DEFAULT 'N';
ALTER TABLE FCFKC.FSK_SCENARIO ADD btl_enabled_ind  CHAR(1) NULL DEFAULT 'N';
REPLACE VIEW FCFBU1.FSK_SCENARIO AS SELECT * FROM FCFKC.FSK_SCENARIO;

-- Add queues

CREATE SET TABLE FCFKC.FSK_QUEUE,
 	 NO FALLBACK,
	 NO BEFORE JOURNAL,
	 NO AFTER JOURNAL,
	 CHECKSUM = DEFAULT
(
  queue_key           DECIMAL(12) NOT NULL,
  queue_code          VARCHAR(32) NOT NULL,
  queue_description   VARCHAR(100),
  access_role_name    VARCHAR(60) NOT NULL,
  lstupdate_user      VARCHAR(60),
  logical_delete_ind  CHAR(1),
  active_ind          CHAR(1),
  change_begin_date   TIMESTAMP(6) NOT NULL DEFAULT current_timestamp,
  change_end_date     TIMESTAMP(6) NOT NULL  DEFAULT TIMESTAMP '5999-01-01 00:00:00.000000',
  change_current_ind  CHAR(1) NOT NULL DEFAULT 'Y'
)
UNIQUE PRIMARY INDEX XPKFSK_QUEUE (queue_key);

CREATE INDEX XIE1FSK_QUEUE (queue_code) ON FCFKC.FSK_QUEUE;

ALTER TABLE FCFKC.FSK_ALERT           ADD queue_code         VARCHAR(32) NULL;
ALTER TABLE FCFKC.FSK_CASE            ADD queue_code         VARCHAR(32) NULL;
ALTER TABLE FCFKC.FSK_CDD_REVIEW      ADD queue_code         VARCHAR(32) NULL;
ALTER TABLE FCFKC.FSK_RC_REPORT       ADD queue_code         VARCHAR(32) NULL;
ALTER TABLE FCFKC.FSK_RC_REPORT       ADD employee_ind  CHAR(1) NULL DEFAULT 'N';

CREATE INDEX FCFKC.XEIQFSK_ALERT(queue_code) ON FCFKC.FSK_ALERT;
CREATE INDEX FCFKC.XEIQFSK_CASE (queue_code) ON FCFKC.FSK_CASE;
CREATE INDEX FCFKC.XEIQFSK_CDD_REVIEW (queue_code) ON FCFKC.FSK_CDD_REVIEW;
CREATE INDEX FCFKC.XEIQFSK_RC_REPORT (queue_code) ON FCFKC.FSK_RC_REPORT;

CREATE  VIEW FCFBU1.FSK_QUEUE AS SELECT * FROM FCFKC.FSK_QUEUE;

REPLACE VIEW FCFBU1.FSK_CDD_REVIEW AS SELECT * FROM FCFKC.FSK_CDD_REVIEW;
REPLACE VIEW FCFBU1.FSK_RC_REPORT AS SELECT * FROM FCFKC.FSK_RC_REPORT;

CREATE TABLE FCFKC.FSK_ENTITY_QUEUE (
  queue_code                VARCHAR(32)  NULL,
	alerted_entity_level_code CHAR(3) NOT NULL ,
	alerted_entity_number     VARCHAR(50) NOT NULL,
	owner_userid              VARCHAR(60) NULL
)
CREATE INDEX XEI1FSK_ENTITY_QUEUE (alerted_entity_level_code, alerted_entity_number, queue_code, owner_userid) ON FCFKC.FSK_ENTITY_QUEUE;
CREATE VIEW FCFBU1.FSK_ENTITY_QUEUE AS SELECT * FROM FCFKC.FSK_ENTITY_QUEUE;

-- AML-800: Add case close date
ALTER TABLE FCFKC.FSK_CASE ADD case_close_date TIMESTAMP(6) NULL;
REPLACE VIEW FCFBU1.FSK_CASE AS SELECT * FROM FCFKC.FSK_CASE;


CREATE SET TABLE FCFKC.FSK_RC_REPORT_ENTITY_BRIDGE,
 	 NO FALLBACK,
	 NO BEFORE JOURNAL,
	 NO AFTER JOURNAL,
	 CHECKSUM = DEFAULT
(
	report_key           DECIMAL(12) NOT NULL ,
	parent_level_code    VARCHAR(32) NOT NULL ,
	parent_key           DECIMAL(12) NOT NULL ,
	entity_level_code    VARCHAR(32) NOT NULL ,
	entity_key           DECIMAL(12) NOT NULL ,
	ui_json              VARCHAR(10000)  NULL
)
UNIQUE PRIMARY INDEX XPKFSK_RPT_ENT_BR  (report_key, parent_key, entity_key);

CREATE VIEW FCFBU1.FSK_RC_REPORT_ENTITY_BRIDGE AS SELECT * FROM FCFKC.FSK_RC_REPORT_ENTITY_BRIDGE;

-- AML-1213: standardize lengths for entity name
DROP INDEX XIE6FSK_ALERT ON FCFKC.FSK_ALERT;
ALTER TABLE FCFKC.FSK_ALERT add alerted_entity_name VARCHAR(200);
ALTER TABLE FCFKC.FSK_ALERT add primary_entity_name VARCHAR(200);
ALTER TABLE FCFKC.FSK_CASE_ENTITY add entity_name VARCHAR(200);
ALTER TABLE FCFKC.FSK_RC_REPORT_ENTITY add entity_name VARCHAR(200);
ALTER TABLE FCFKC.FSK_RC_REPORT_ENTITY_INFO add entity_name VARCHAR(200);
CREATE INDEX XIE6FSK_ALERT(primary_entity_name) ON FCFKC.FSK_ALERT;

DROP INDEX XIE6FSC_ASSOCIATE_DIM ON FCFCORE.FSC_ASSOCIATE_DIM;
DROP INDEX XIE3FSC_HOUSEHOLD_DIM ON FCFCORE.FSC_HOUSEHOLD_DIM;
DROP INDEX XIE2FSC_ACCOUNT_DIM ON FCFCORE.FSC_ACCOUNT_DIM;
ALTER TABLE FCFCORE.FSC_BANK_DIM add bank_name VARCHAR(200);
ALTER TABLE FCFCORE.FSC_ASSOCIATE_DIM add associate_last_name VARCHAR(200);
ALTER TABLE FCFCORE.FSC_HOUSEHOLD_DIM add head_of_household_name VARCHAR(200);
ALTER TABLE FCFCORE.FSC_ACCOUNT_DIM add account_name VARCHAR(200);
CREATE INDEX XIE6FSC_ASSOCIATE_DIM(associate_last_name) ON FCFCORE.FSC_ASSOCIATE_DIM;
CREATE INDEX XIE3FSC_HOUSEHOLD_DIM(head_of_household_name) ON FCFCORE.FSC_HOUSEHOLD_DIM;
CREATE INDEX XIE2FSC_ACCOUNT_DIM(account_name) ON FCFCORE.FSC_ACCOUNT_DIM;

REPLACE VIEW FCFBU1.FSK_ALERT AS SELECT * FROM FCFKC.FSK_ALERT;
REPLACE VIEW FCFBU1.FSK_CASE_ENTITY AS SELECT * FROM FCFKC.FSK_CASE_ENTITY;
REPLACE VIEW FCFBU1.FSK_RC_REPORT_ENTITY AS SELECT * from FCFKC.FSK_RC_REPORT_ENTITY;
REPLACE VIEW FCFBU1.FSK_RC_REPORT_ENTITY_INFO AS SELECT * FROM FCFKC.FSK_RC_REPORT_ENTITY_INFO;
REPLACE VIEW FCFBU1.FSC_BANK_DIM AS SELECT * FROM FCFCORE.FSC_BANK_DIM;
REPLACE VIEW FCFBU1.FSC_ASSOCIATE_DIM AS SELECT * FROM FCFCORE.FSC_ASSOCIATE_DIM;
REPLACE VIEW FCFBU1.FSC_HOUSEHOLD_DIM AS SELECT * FROM FCFCORE.FSC_HOUSEHOLD_DIM;
REPLACE VIEW FCFBU1.FSC_ACCOUNT_DIM AS SELECT * FROM FCFCORE.FSC_ACCOUNT_DIM;

REPLACE VIEW FCFBU1.fsc_transaction_view (account_key, account_number, branch_key, date_key, time_key, transaction_type_key, transaction_key,
currency_amount, transaction_reference_number, transaction_description, security_name, deal_number, bank_name_1, role_desc_1, bank_name_2,
role_desc_2, bank_name_3, role_desc_3, bank_name_4, role_desc_4, bank_name_5, role_desc_5, bank_name_6, role_desc_6) AS SELECT CFF.account_key,
ACC.account_number, CFF.branch_key, CFF.date_key, CFF.time_key, CFF.transaction_type_key, CFF.transaction_key, CFF.currency_amount, TD.transaction_reference_number,
TD.transaction_description, TD.security_name, TD.deal_number, BD.BANK_NAME AS bank_name_1, CFBB.Role_Desc AS role_desc_1, BD2.BANK_NAME AS bank_name_2,
 CFBB2.Role_Desc AS role_desc_2, BD3.BANK_NAME AS bank_name_3, CFBB3.Role_Desc AS role_desc_3, BD4.BANK_NAME AS bank_name_4, CFBB4.Role_Desc AS role_desc_4,
BD5.BANK_NAME AS bank_name_5, CFBB5.Role_Desc AS role_desc_5, BD6.BANK_NAME AS bank_name_6, CFBB6.Role_Desc AS role_desc_6
FROM FCFCORE.FSC_CASH_FLOW_FACT CFF JOIN FCFCORE.FSC_TRANSACTION_DIM TD ON CFF.transaction_key = TD.transaction_key
JOIN FCFCORE.FSC_ACCOUNT_DIM ACC ON CFF.account_key = ACC.account_key  LEFT JOIN FCFCORE.FSC_CASH_FLOW_BANK_BRIDGE CFBB
ON CFF.TRANSACTION_KEY = CFBB.TRANSACTION_KEY AND CFBB.SEQUENCE_NUMBER = 1 LEFT JOIN FCFCORE.FSC_BANK_DIM BD
ON CFBB.BANK_KEY = BD.BANK_KEY LEFT JOIN FCFCORE.FSC_CASH_FLOW_BANK_BRIDGE CFBB2 ON CFF.TRANSACTION_KEY = CFBB2.TRANSACTION_KEY
AND CFBB2.SEQUENCE_NUMBER = 2  LEFT JOIN FCFCORE.FSC_BANK_DIM BD2 ON CFBB2.BANK_KEY = BD2.BANK_KEY
LEFT JOIN FCFCORE.FSC_CASH_FLOW_BANK_BRIDGE CFBB3 ON CFF.TRANSACTION_KEY = CFBB3.TRANSACTION_KEY AND CFBB3.SEQUENCE_NUMBER = 3
LEFT JOIN FCFCORE.FSC_BANK_DIM BD3 ON CFBB3.BANK_KEY = BD3.BANK_KEY  LEFT JOIN FCFCORE.FSC_CASH_FLOW_BANK_BRIDGE CFBB4
ON CFF.TRANSACTION_KEY = CFBB4.TRANSACTION_KEY AND CFBB4.SEQUENCE_NUMBER = 4 LEFT JOIN FCFCORE.FSC_BANK_DIM BD4
ON CFBB4.BANK_KEY = BD4.BANK_KEY  LEFT JOIN FCFCORE.FSC_CASH_FLOW_BANK_BRIDGE CFBB5 ON CFF.TRANSACTION_KEY = CFBB5.TRANSACTION_KEY
AND CFBB5.SEQUENCE_NUMBER = 5  LEFT JOIN FCFCORE.FSC_BANK_DIM BD5 ON CFBB5.BANK_KEY = BD5.BANK_KEY
LEFT JOIN FCFCORE.FSC_CASH_FLOW_BANK_BRIDGE CFBB6 ON CFF.TRANSACTION_KEY = CFBB6.TRANSACTION_KEY AND CFBB6.SEQUENCE_NUMBER = 6
LEFT JOIN FCFCORE.FSC_BANK_DIM BD6 ON CFBB6.BANK_KEY = BD6.BANK_KEY
UNION ALL(SELECT AEF.account_key,
ACC.account_number, AEF.branch_key, AEF.date_key, AEF.time_key, AEF.transaction_type_key, AEF.transaction_key, 0, TD.transaction_reference_number, TD.transaction_description,
TD.security_name, TD.deal_number, '', '', '', '', '', '', '', '', '', '', '', '' FROM FCFCORE.FSC_ACCOUNT_EVENT_FACT AEF JOIN FCFCORE.FSC_ACCOUNT_DIM ACC
ON AEF.account_key = ACC.account_key  JOIN FCFCORE.FSC_TRANSACTION_DIM TD ON AEF.transaction_key = TD.transaction_key
UNION ALL
(SELECT ATF.account_key, ACC.account_number, ATF.branch_key, ATF.trade_date_key AS date_key,
ATF.execution_time_key AS time_key, ATF.transaction_type_key, ATF.transaction_key, ATF.principal_amount AS currency_amount, TD.transaction_reference_number,
TD.transaction_description, TD.security_name, TD.deal_number, '', '', '', '', '', '', '', '', '', '', '', '' FROM FCFCORE.FSC_ACCOUNT_TRADE_FACT ATF
JOIN FCFCORE.FSC_ACCOUNT_DIM ACC ON ATF.account_key = ACC.account_key  JOIN FCFCORE.FSC_TRANSACTION_DIM TD
ON ATF.transaction_key = TD.transaction_key));-- Recreate Fundstracker's FSK_INT_XFER table with time_key included
DROP VIEW FCFBU1.FSK_INT_XFER;

DROP TABLE FCFKC.FSK_INT_XFER;

CREATE SET TABLE FCFKC.FSK_INT_XFER,
     NO FALLBACK,
     NO BEFORE JOURNAL,
     NO AFTER JOURNAL,
     CHECKSUM = DEFAULT
(
    remitter_account_number VARCHAR(304) NOT NULL ,
    remitter_name        VARCHAR(304) NOT NULL ,
    remitter_party_key   DECIMAL(12) NOT NULL ,
    beneficiary_account_number VARCHAR(304) NOT NULL ,
    beneficiary_name     VARCHAR(304) NOT NULL ,
    beneficiary_party_key DECIMAL(12) NOT NULL ,
    date_key             DECIMAL(8) NOT NULL ,
    time_key             DECIMAL(6) NOT NULL ,
    currency_amount      DECIMAL(18,5) NOT NULL ,
    edge_type_code       CHAR(4) NOT NULL
);

CREATE INDEX IDX_1_FSK_INT_XFER( remitter_account_number, beneficiary_account_number ) ON FCFKC.FSK_INT_XFER;

CREATE VIEW FCFBU1.FSK_INT_XFER AS SELECT * FROM FCFKC.FSK_INT_XFER;
-- Added columns
ALTER TABLE FCFCORE.FSC_PARTY_DIM   ADD purge_date         TIMESTAMP(6) NULL;

-- Replace/create views of altered/created tables
REPLACE VIEW FCFBU1.FSC_PARTY_DIM AS SELECT * FROM FCFCORE.FSC_PARTY_DIM;

-- Change preference value lengths
ALTER TABLE FCFKC.FSK_PREFERENCE ADD PREF_VALUE VARCHAR(4000);
ALTER TABLE FCFKC.FSK_PREFERENCE ADD PREF_VALUE_DEFAULT VARCHAR(4000);
REPLACE VIEW FCFBU1.FSC_PREFERENCE AS SELECT * FROM FCFKC.FSK_PREFERENCE;

-- add lock columns to alerted entity
ALTER TABLE FCFKC.FSK_ALERTED_ENTITY ADD lock_userid VARCHAR(32) NULL;
ALTER TABLE FCFKC.FSK_ALERTED_ENTITY ADD lock_timestamp TIMESTAMP NULL;
REPLACE VIEW FCFBU1.FSK_ALERTED_ENTITY AS SELECT * FROM FCFKC.FSK_ALERTED_ENTITY;

-- add lock columns to report
ALTER TABLE FCFKC.FSK_RC_REPORT ADD lock_userid VARCHAR(32) NULL;
ALTER TABLE FCFKC.FSK_RC_REPORT ADD lock_timestamp TIMESTAMP NULL;
REPLACE VIEW FCFBU1.FSK_RC_REPORT AS SELECT * FROM FCFKC.FSK_RC_REPORT;

-- add lock columns to cdd review
ALTER TABLE FCFKC.FSK_CDD_REVIEW ADD lock_userid VARCHAR(32) NULL;
ALTER TABLE FCFKC.FSK_CDD_REVIEW ADD lock_timestamp TIMESTAMP NULL;
REPLACE VIEW FCFBU1.FSK_CDD_REVIEW AS SELECT * FROM FCFKC.FSK_CDD_REVIEW;

-- add lock columns to efile
ALTER TABLE FCFKC.FSK_RC_EFILE ADD lock_userid VARCHAR(32) NULL;
ALTER TABLE FCFKC.FSK_RC_EFILE ADD lock_timestamp TIMESTAMP NULL;
REPLACE VIEW FCFBU1.FSK_RC_EFILE AS SELECT * FROM FCFKC.FSK_RC_EFILE;

-- add lock columns to case
ALTER TABLE FCFKC.FSK_CASE ADD lock_userid VARCHAR(32) NULL;
ALTER TABLE FCFKC.FSK_CASE ADD lock_timestamp TIMESTAMP NULL;
REPLACE VIEW FCFBU1.FSK_CASE AS SELECT * FROM FCFKC.FSK_CASE;

-- add update info columns to alerted entity
ALTER TABLE FCFKC.FSK_ALERTED_ENTITY ADD LSTUPDATE_USER_ID VARCHAR(32) NULL;
ALTER TABLE FCFKC.FSK_ALERTED_ENTITY ADD LSTUPDATE_DATE TIMESTAMP NULL;
REPLACE VIEW FCFBU1.FSK_ALERTED_ENTITY AS SELECT * FROM FCFKC.FSK_ALERTED_ENTITY;

-- add efile event table
CREATE SET TABLE FCFKC.FSK_RC_EFILE_EVENT,
	 NO FALLBACK,
	 NO BEFORE JOURNAL,
	 NO AFTER JOURNAL,
	 CHECKSUM = DEFAULT
(
	event_id             DECIMAL(12) NOT NULL ,
	efile_key           DECIMAL(12) NOT NULL ,
	event_type_code      VARCHAR(3) NOT NULL ,
	event_description    VARCHAR(255)  ,
	create_user_id       VARCHAR(60) NOT NULL ,
	create_date          TIMESTAMP(6) NOT NULL
)
	UNIQUE PRIMARY INDEX XPKFSK_RC_EFILE_EVENT(event_id);

CREATE  INDEX XIF1FSK_RC_EFILE_EVENT(efile_key) ON FCFKC.FSK_RC_EFILE_EVENT;
CREATE VIEW FCFBU1.FSK_RC_EFILE_EVENT AS SELECT * FROM FCFKC.FSK_RC_EFILE_EVENT;