----------------------------------------------------------------
--Create FCFBU1 views.
----------------------------------------------------------------
--Description:
--Create FCFBU1 views.
--This script is a template for creating the bufferpools
--required for the 'base' FCF Knowledge Center schema.
--
--This script can be run as FCFBU1.
--
--This script assumes that one bank segment is being
--created (FCFBU1).
--------------------------------------------------------------
--------------------------------------------------------------

----------------------------------------------------------------------------
--Create sequences in each multibank segment schema. Additional sequences
--will be needed if this script is customized to add additional multibank segments.
----------------------------------------------------------------------------

---------------------------------------------------------------------------------
--FCFBU1 tables creation statements. These are generated in Teradata fcfkc model.
----------------------------------------------------------------------------------

CREATE SET TABLE FCFBU1.FSK_SCENARIO_STATUS,
	 NO FALLBACK, 
	 NO BEFORE JOURNAL, 
	 NO AFTER JOURNAL, 
	 CHECKSUM = DEFAULT
(
	stored_procedure_name VARCHAR(35)  ,
	create_date          TIMESTAMP(6)  ,
	begin_time           TIMESTAMP(6)  ,
	end_time             TIMESTAMP(6)  
);

CREATE SET TABLE FCFBU1.FSK_ERROR_LOG,
	 NO FALLBACK, 
	 NO BEFORE JOURNAL, 
	 NO AFTER JOURNAL, 
	 CHECKSUM = DEFAULT
(
	stored_procedure_name VARCHAR(35)  ,
	create_date          TIMESTAMP(6)  ,
	sql_state            VARCHAR(35)  ,
	sql_code             VARCHAR(35)  ,
	sql_error_message    VARCHAR(255)  
);

CREATE SET TABLE FCFBU1.FSK_SCENARIO_MESSAGE_DECOMP,
	 NO FALLBACK, 
	 NO BEFORE JOURNAL, 
	 NO AFTER JOURNAL, 
	 CHECKSUM = DEFAULT
(
	scenario_message_name VARCHAR(35) NOT NULL ,
	message_segment_sequence_nbr DECIMAL(10) NOT NULL ,
	message_segment_text VARCHAR(255)  
)
	UNIQUE PRIMARY INDEX XPK1FSK_SCENARIO_MESSAGE_DECOM(scenario_message_name,message_segment_sequence_nbr);

CREATE SET TABLE FCFBU1.FSK_SCENARIO_MESSAGE_PARAMS,
	 NO FALLBACK, 
	 NO BEFORE JOURNAL, 
	 NO AFTER JOURNAL, 
	 CHECKSUM = DEFAULT
(
	scenario_message_name VARCHAR(35) NOT NULL ,
	message_parameter_nbr DECIMAL(10) NOT NULL ,
	query_column_parameter_text VARCHAR(64)  
)
	UNIQUE PRIMARY INDEX XPKFSK_SCENARIO_MESSAGE_PARAM(scenario_message_name,message_parameter_nbr);

----------------------------------------------------------------------------
--FCFBU1 views on FCFCORE tables statements
----------------------------------------------------------------------------

CREATE  VIEW FCFBU1.FSC_ACCOUNT_ANALYSIS_DIM AS SELECT * FROM FCFCORE.FSC_ACCOUNT_ANALYSIS_DIM;

CREATE  VIEW FCFBU1.FSC_ACCOUNT_DIM AS SELECT * FROM FCFCORE.FSC_ACCOUNT_DIM;

CREATE  VIEW FCFBU1.FSC_ACCOUNT_EVENT_FACT AS SELECT * FROM FCFCORE.FSC_ACCOUNT_EVENT_FACT;

CREATE  VIEW FCFBU1.FSC_ACCOUNT_PROFILE_FACT AS SELECT * FROM FCFCORE.FSC_ACCOUNT_PROFILE_FACT;

CREATE  VIEW FCFBU1.FSC_ACCOUNT_TRADE_FACT AS SELECT * FROM FCFCORE.FSC_ACCOUNT_TRADE_FACT;

CREATE  VIEW FCFBU1.FSC_ASSOCIATE_DIM AS SELECT * FROM FCFCORE.FSC_ASSOCIATE_DIM;

CREATE  VIEW FCFBU1.FSC_BANK_DIM AS SELECT * FROM FCFCORE.FSC_BANK_DIM;

CREATE  VIEW FCFBU1.FSC_BRANCH_DIM AS SELECT * FROM FCFCORE.FSC_BRANCH_DIM;

CREATE  VIEW FCFBU1.FSC_CASH_FLOW_BANK_BRIDGE AS SELECT * FROM FCFCORE.FSC_CASH_FLOW_BANK_BRIDGE ;

CREATE  VIEW FCFBU1.FSC_CASH_FLOW_FACT AS SELECT * FROM FCFCORE.FSC_CASH_FLOW_FACT;

CREATE  VIEW FCFBU1.FSC_CLASSIFIER_FACT AS SELECT * FROM FCFCORE.FSC_CLASSIFIER_FACT;

CREATE  VIEW FCFBU1.FSC_COUNTRY_DIM AS SELECT * FROM FCFCORE.FSC_COUNTRY_DIM;

CREATE  VIEW FCFBU1.FSC_CURRENCY_DIM AS SELECT * FROM FCFCORE.FSC_CURRENCY_DIM;

CREATE  VIEW FCFBU1.FSC_DATE_DIM AS SELECT * FROM FCFCORE.FSC_DATE_DIM;

CREATE  VIEW FCFBU1.FSC_ENTITY_WATCH_LIST_DIM AS SELECT * FROM FCFCORE.FSC_ENTITY_WATCH_LIST_DIM;

CREATE  VIEW FCFBU1.FSC_EXT_PARTY_ACCOUNT_DIM AS SELECT * FROM FCFCORE.FSC_EXT_PARTY_ACCOUNT_DIM ;

CREATE  VIEW FCFBU1.FSC_HOUSEHOLD_ACCOUNT_BRIDGE AS SELECT * FROM FCFCORE.FSC_HOUSEHOLD_ACCOUNT_BRIDGE;

CREATE  VIEW FCFBU1.FSC_HOUSEHOLD_DIM AS SELECT * FROM FCFCORE.FSC_HOUSEHOLD_DIM;

CREATE  VIEW FCFBU1.FSC_HOUSEHOLD_PARTY_BRIDGE AS SELECT * FROM FCFCORE.FSC_HOUSEHOLD_PARTY_BRIDGE;

CREATE  VIEW FCFBU1.FSC_LOCATION_WATCH_LIST_DIM AS SELECT * FROM FCFCORE.FSC_LOCATION_WATCH_LIST_DIM;

CREATE  VIEW FCFBU1.FSC_MONTH_DIM AS SELECT * FROM FCFCORE.FSC_MONTH_DIM;

CREATE  VIEW FCFBU1.FSC_PARTY_ACCOUNT_BRIDGE AS SELECT * FROM FCFCORE.FSC_PARTY_ACCOUNT_BRIDGE;

CREATE  VIEW FCFBU1.FSC_PARTY_DIM AS SELECT * FROM FCFCORE.FSC_PARTY_DIM;

CREATE  VIEW FCFBU1.FSC_PARTY_PROFILE_FACT AS SELECT * FROM FCFCORE.FSC_PARTY_PROFILE_FACT;

CREATE  VIEW FCFBU1.FSC_TIME_DIM AS SELECT * FROM FCFCORE.FSC_TIME_DIM;

CREATE  VIEW FCFBU1.FSC_TRANSACTION_DIM AS SELECT * FROM FCFCORE.FSC_TRANSACTION_DIM;

CREATE  VIEW FCFBU1.FSC_TRANSACTION_STATUS_DIM AS SELECT * FROM FCFCORE.FSC_TRANSACTION_STATUS_DIM;

CREATE  VIEW FCFBU1.FSC_TRANSACTION_TYPE_DIM AS SELECT * FROM FCFCORE.FSC_TRANSACTION_TYPE_DIM;

CREATE  VIEW FCFBU1.FSC_PARTY_SEQUENCE AS SELECT * FROM FCFCORE.FSC_PARTY_SEQUENCE;

CREATE  VIEW FCFBU1.FSC_ACCOUNT_PRIMARY_OWNER_VIEW (account_number, current_primary_owner_number) AS SELECT a.account_number AS account_number, p.party_number AS current_primary_owner_number FROM FCFCORE.fsc_party_dim p JOIN FCFCORE.fsc_party_account_bridge b ON p.party_key = b.party_key AND b.change_current_ind = 'Y' AND b.role_key = 1 JOIN FCFCORE.fsc_account_dim a ON a.account_key = b.account_key AND b.change_current_ind = 'Y' WHERE p.change_current_ind = 'Y';

CREATE  VIEW FCFBU1.fsc_transaction_view (account_key, account_number, branch_key, date_key, time_key, transaction_type_key, transaction_key, 
currency_amount, transaction_reference_number, transaction_description, security_name, deal_number, bank_name_1, role_desc_1, bank_name_2, 
role_desc_2, bank_name_3, role_desc_3, bank_name_4, role_desc_4, bank_name_5, role_desc_5, bank_name_6, role_desc_6) AS SELECT CFF.account_key, 
ACC.account_number, CFF.branch_key, CFF.date_key, CFF.time_key, CFF.transaction_type_key, CFF.transaction_key, CFF.currency_amount, TD.transaction_reference_number, 
TD.transaction_description, TD.security_name, TD.deal_number, BD.BANK_NAME AS bank_name_1, CFBB.Role_Desc AS role_desc_1, BD2.BANK_NAME AS bank_name_2,
 CFBB2.Role_Desc AS role_desc_2, BD3.BANK_NAME AS bank_name_3, CFBB3.Role_Desc AS role_desc_3, BD4.BANK_NAME AS bank_name_4, CFBB4.Role_Desc AS role_desc_4, 
BD5.BANK_NAME AS bank_name_5, CFBB5.Role_Desc AS role_desc_5, BD6.BANK_NAME AS bank_name_6, CFBB6.Role_Desc AS role_desc_6
FROM FCFCORE.FSC_CASH_FLOW_FACT CFF JOIN FCFCORE.FSC_TRANSACTION_DIM TD ON CFF.transaction_key = TD.transaction_key 
JOIN FCFCORE.FSC_ACCOUNT_DIM ACC ON CFF.account_key = ACC.account_key  LEFT JOIN FCFCORE.FSC_CASH_FLOW_BANK_BRIDGE CFBB 
ON CFF.TRANSACTION_KEY = CFBB.TRANSACTION_KEY AND CFBB.SEQUENCE_NUMBER = 1 LEFT JOIN FCFCORE.FSC_BANK_DIM BD 
ON CFBB.BANK_KEY = BD.BANK_KEY LEFT JOIN FCFCORE.FSC_CASH_FLOW_BANK_BRIDGE CFBB2 ON CFF.TRANSACTION_KEY = CFBB2.TRANSACTION_KEY 
AND CFBB2.SEQUENCE_NUMBER = 2  LEFT JOIN FCFCORE.FSC_BANK_DIM BD2 ON CFBB2.BANK_KEY = BD2.BANK_KEY
LEFT JOIN FCFCORE.FSC_CASH_FLOW_BANK_BRIDGE CFBB3 ON CFF.TRANSACTION_KEY = CFBB3.TRANSACTION_KEY AND CFBB3.SEQUENCE_NUMBER = 3 
LEFT JOIN FCFCORE.FSC_BANK_DIM BD3 ON CFBB3.BANK_KEY = BD3.BANK_KEY  LEFT JOIN FCFCORE.FSC_CASH_FLOW_BANK_BRIDGE CFBB4 
ON CFF.TRANSACTION_KEY = CFBB4.TRANSACTION_KEY AND CFBB4.SEQUENCE_NUMBER = 4 LEFT JOIN FCFCORE.FSC_BANK_DIM BD4 
ON CFBB4.BANK_KEY = BD4.BANK_KEY  LEFT JOIN FCFCORE.FSC_CASH_FLOW_BANK_BRIDGE CFBB5 ON CFF.TRANSACTION_KEY = CFBB5.TRANSACTION_KEY 
AND CFBB5.SEQUENCE_NUMBER = 5  LEFT JOIN FCFCORE.FSC_BANK_DIM BD5 ON CFBB5.BANK_KEY = BD5.BANK_KEY 
LEFT JOIN FCFCORE.FSC_CASH_FLOW_BANK_BRIDGE CFBB6 ON CFF.TRANSACTION_KEY = CFBB6.TRANSACTION_KEY AND CFBB6.SEQUENCE_NUMBER = 6 
LEFT JOIN FCFCORE.FSC_BANK_DIM BD6 ON CFBB6.BANK_KEY = BD6.BANK_KEY   
UNION ALL(SELECT AEF.account_key, 
ACC.account_number, AEF.branch_key, AEF.date_key, AEF.time_key, AEF.transaction_type_key, AEF.transaction_key, 0, TD.transaction_reference_number, TD.transaction_description, 
TD.security_name, TD.deal_number, '', '', '', '', '', '', '', '', '', '', '', '' FROM FCFCORE.FSC_ACCOUNT_EVENT_FACT AEF JOIN FCFCORE.FSC_ACCOUNT_DIM ACC 
ON AEF.account_key = ACC.account_key  JOIN FCFCORE.FSC_TRANSACTION_DIM TD ON AEF.transaction_key = TD.transaction_key 
UNION ALL
(SELECT ATF.account_key, ACC.account_number, ATF.branch_key, ATF.trade_date_key AS date_key, 
ATF.execution_time_key AS time_key, ATF.transaction_type_key, ATF.transaction_key, ATF.principal_amount AS currency_amount, TD.transaction_reference_number, 
TD.transaction_description, TD.security_name, TD.deal_number, '', '', '', '', '', '', '', '', '', '', '', '' FROM FCFCORE.FSC_ACCOUNT_TRADE_FACT ATF 
JOIN FCFCORE.FSC_ACCOUNT_DIM ACC ON ATF.account_key = ACC.account_key  JOIN FCFCORE.FSC_TRANSACTION_DIM TD 
ON ATF.transaction_key = TD.transaction_key));

CREATE  VIEW FCFBU1.FSC_ACCOUNT_STATE_VECTOR_FACT
AS  SELECT FCFCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.account_number,
FCFCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.date_key,
FCFCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.account_type_desc,
FCFCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.debits_total,
FCFCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.credits_total,
FCFCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.atm_debits_total,
FCFCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.atm_credits_total,
FCFCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.atm_d_trans_count,
FCFCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.atm_c_trans_count,
FCFCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.debit_trans_count,
FCFCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.credit_trans_count,
FCFCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.debit_loc_count,
FCFCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.credit_loc_count,
FCFCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.atm_d_loc_count,
FCFCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.atm_c_loc_count,
FCFCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.wire_credit_total,
FCFCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.wire_credit_trans_count,
FCFCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.wire_debits_total,
FCFCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.wire_debit_trans_count,
FCFCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.d_i_wire_credits_total,
FCFCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.d_i_wire_credit_trans_count,
FCFCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.d_i_wire_debits_total,
FCFCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.d_i_wire_debit_trans_count,
FCFCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.balance_inquiry_count,
FCFCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.exceeded_daily_limit_count,
FCFCORE.FSC_ACCOUNT_STATE_VECTOR_FACT.insufficient_funds_count
FROM FCFCORE.FSC_ACCOUNT_STATE_VECTOR_FACT;

CREATE  VIEW FCFBU1.fsc_account_state_vector_view
AS
   SELECT 
    account_number,
    account_type_desc,
    date_key,
        debits_total,
          SUM (debits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                               debits_total_5,
          SUM (debits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                              debits_total_10,
          SUM (debits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                              debits_total_30,
          credits_total,
          SUM (credits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                              credits_total_5,
          SUM (credits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                             credits_total_10,
          SUM (credits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                             credits_total_30,
          atm_debits_total,
          SUM (atm_debits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                           atm_debits_total_5,
          SUM (atm_debits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                          atm_debits_total_10,
          SUM (atm_debits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                          atm_debits_total_30,
          atm_credits_total,
          SUM (atm_credits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                          atm_credits_total_5,
          SUM (atm_credits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                         atm_credits_total_10,
          SUM (atm_credits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                         atm_credits_total_30,
          atm_d_trans_count,
          SUM (atm_d_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                          atm_d_trans_count_5,
          SUM (atm_d_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                         atm_d_trans_count_10,
          SUM (atm_d_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                         atm_d_trans_count_30,
          atm_c_trans_count,
          SUM (atm_c_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                          atm_c_trans_count_5,
          SUM (atm_c_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                         atm_c_trans_count_10,
          SUM (atm_c_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                         atm_c_trans_count_30,
          debit_trans_count,
          SUM (debit_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                          debit_trans_count_5,
          SUM (debit_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                         debit_trans_count_10,
          SUM (debit_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                         debit_trans_count_30,
          credit_trans_count,
          SUM (credit_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                         credit_trans_count_5,
          SUM (credit_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                        credit_trans_count_10,
          SUM (credit_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                        credit_trans_count_30,
          debit_loc_count,
          SUM (debit_loc_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                            debit_loc_count_5,
          SUM (debit_loc_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                           debit_loc_count_10,
          SUM (debit_loc_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                           debit_loc_count_30,
          credit_loc_count,
          SUM (credit_loc_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                           credit_loc_count_5,
          SUM (credit_loc_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                          credit_loc_count_10,
          SUM (credit_loc_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                          credit_loc_count_30,
          atm_d_loc_count,
          SUM (atm_d_loc_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                            atm_d_loc_count_5,
          SUM (atm_d_loc_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                           atm_d_loc_count_10,
          SUM (atm_d_loc_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                           atm_d_loc_count_30,
          atm_c_loc_count,
          SUM (atm_c_loc_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                            atm_c_loc_count_5,
          SUM (atm_c_loc_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                           atm_c_loc_count_10,
          SUM (atm_c_loc_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                           atm_c_loc_count_30,
          wire_credit_total,
          SUM (wire_credit_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                          wire_credit_total_5,
          SUM (wire_credit_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                         wire_credit_total_10,
          SUM (wire_credit_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                         wire_credit_total_30,
          wire_credit_trans_count,
          SUM (wire_credit_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                    wire_credit_trans_count_5,
          SUM (wire_credit_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                   wire_credit_trans_count_10,
          SUM (wire_credit_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                   wire_credit_trans_count_30,
          wire_debits_total,
          SUM (wire_debits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                          wire_debits_total_5,
          SUM (wire_debits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                         wire_debits_total_10,
          SUM (wire_debits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                         wire_debits_total_30,
          wire_debit_trans_count,
          SUM (wire_debit_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                     wire_debit_trans_count_5,
          SUM (wire_debit_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                    wire_debit_trans_count_10,
          SUM (wire_debit_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                    wire_debit_trans_count_30,
          d_i_wire_credits_total,
          SUM (d_i_wire_credits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                     d_i_wire_credits_total_5,
          SUM (d_i_wire_credits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                    d_i_wire_credits_total_10,
          SUM (d_i_wire_credits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                    d_i_wire_credits_total_30,
          d_i_wire_credit_trans_count,
          SUM (d_i_wire_credit_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                d_i_wire_credit_trans_count_5,
          SUM (d_i_wire_credit_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                               d_i_wire_credit_trans_count_10,
          SUM (d_i_wire_credit_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                               d_i_wire_credit_trans_count_30,
          d_i_wire_debits_total,
          SUM (d_i_wire_debits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                      d_i_wire_debits_total_5,
          SUM (d_i_wire_debits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                     d_i_wire_debits_total_10,
          SUM (d_i_wire_debits_total) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                     d_i_wire_debits_total_30,
          d_i_wire_debit_trans_count,
          SUM (d_i_wire_debit_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                 d_i_wire_debit_trans_count_5,
          SUM (d_i_wire_debit_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                d_i_wire_debit_trans_count_10,
          SUM (d_i_wire_debit_trans_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                d_i_wire_debit_trans_count_30,
          balance_inquiry_count,
          SUM (balance_inquiry_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                      balance_inquiry_count_5,
          SUM (balance_inquiry_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                     balance_inquiry_count_10,
          SUM (balance_inquiry_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                     balance_inquiry_count_30,
          exceeded_daily_limit_count,
          SUM (exceeded_daily_limit_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                 exceeded_daily_limit_count_5,
          SUM (exceeded_daily_limit_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                exceeded_daily_limit_count_10,
          SUM (exceeded_daily_limit_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                exceeded_daily_limit_count_30,
          insufficient_funds_count,
          SUM (insufficient_funds_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 4 PRECEDING AND CURRENT ROW)
                                                   insufficient_funds_count_5,
          SUM (insufficient_funds_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 9 PRECEDING AND CURRENT ROW)
                                                  insufficient_funds_count_10,
          SUM (insufficient_funds_count) OVER (PARTITION BY account_number ORDER BY date_key ROWS BETWEEN 29 PRECEDING AND CURRENT ROW)
                                                  insufficient_funds_count_30
     FROM FCFCORE.fsc_account_state_vector_fact;

CREATE  VIEW FCFBU1.FSC_LOOKUP_DIM ( lookup_code,lookup_char_value,lookup_num_value,change_begin_date,change_end_date,change_current_ind,lookup_date_value,lookup_level_1_type_code,lookup_level_2_type_code,lookup_key ) 
	 AS  SELECT FCFCORE.FSC_LOOKUP_DIM.lookup_code,FCFCORE.FSC_LOOKUP_DIM.lookup_char_value,FCFCORE.FSC_LOOKUP_DIM.lookup_num_value,FCFCORE.FSC_LOOKUP_DIM.change_begin_date,FCFCORE.FSC_LOOKUP_DIM.change_end_date,FCFCORE.FSC_LOOKUP_DIM.change_current_ind,FCFCORE.FSC_LOOKUP_DIM.lookup_date_value,FCFCORE.FSC_LOOKUP_DIM.lookup_level_1_type_code,FCFCORE.FSC_LOOKUP_DIM.lookup_level_2_type_code,FCFCORE.FSC_LOOKUP_DIM.lookup_key
		FROM FCFCORE.FSC_LOOKUP_DIM;

CREATE  VIEW FCFBU1.FSC_ADDRESS_DIM ( address_key,address_line_1_text,address_line_2_text,city_name,state_code,state_name,postal_code,country_code,country_name,match_code_address,match_code_addr_lines,match_code_city,match_code_state,match_code_country,change_begin_date,change_end_date,change_current_ind,address_type_code,primary_entity_level_code,primary_entity_number ) 
	 AS  SELECT FCFCORE.FSC_ADDRESS_DIM.address_key,FCFCORE.FSC_ADDRESS_DIM.address_line_1_text,FCFCORE.FSC_ADDRESS_DIM.address_line_2_text,FCFCORE.FSC_ADDRESS_DIM.city_name,FCFCORE.FSC_ADDRESS_DIM.state_code,FCFCORE.FSC_ADDRESS_DIM.state_name,FCFCORE.FSC_ADDRESS_DIM.postal_code,FCFCORE.FSC_ADDRESS_DIM.country_code,FCFCORE.FSC_ADDRESS_DIM.country_name,FCFCORE.FSC_ADDRESS_DIM.match_code_address,FCFCORE.FSC_ADDRESS_DIM.match_code_addr_lines,FCFCORE.FSC_ADDRESS_DIM.match_code_city,FCFCORE.FSC_ADDRESS_DIM.match_code_state,FCFCORE.FSC_ADDRESS_DIM.match_code_country,FCFCORE.FSC_ADDRESS_DIM.change_begin_date,FCFCORE.FSC_ADDRESS_DIM.change_end_date,FCFCORE.FSC_ADDRESS_DIM.change_current_ind,FCFCORE.FSC_ADDRESS_DIM.address_type_code,FCFCORE.FSC_ADDRESS_DIM.primary_entity_level_code,FCFCORE.FSC_ADDRESS_DIM.primary_entity_number
		FROM FCFCORE.FSC_ADDRESS_DIM;

CREATE  VIEW FCFBU1.FSC_PARTY_ASSOC ( party_number,related_party_number,relationship_type_code,change_begin_date,change_end_date,change_current_ind ) 
	 AS  SELECT FCFCORE.FSC_PARTY_ASSOC.party_number,FCFCORE.FSC_PARTY_ASSOC.related_party_number,FCFCORE.FSC_PARTY_ASSOC.relationship_type_code,FCFCORE.FSC_PARTY_ASSOC.change_begin_date,FCFCORE.FSC_PARTY_ASSOC.change_end_date,FCFCORE.FSC_PARTY_ASSOC.change_current_ind
		FROM FCFCORE.FSC_PARTY_ASSOC;

CREATE  VIEW FCFBU1.FSC_PARTY_ASSOC_ATTRIBUTE ( party_number,related_party_number,relationship_type_code,attribute_type_code,attribute_char_value,attribute_num_value,change_begin_date,change_end_date,change_current_ind,attribute_date_value ) 
	 AS  SELECT FCFCORE.FSC_PARTY_ASSOC_ATTRIBUTE.party_number,FCFCORE.FSC_PARTY_ASSOC_ATTRIBUTE.related_party_number,FCFCORE.FSC_PARTY_ASSOC_ATTRIBUTE.relationship_type_code,FCFCORE.FSC_PARTY_ASSOC_ATTRIBUTE.attribute_type_code,FCFCORE.FSC_PARTY_ASSOC_ATTRIBUTE.attribute_char_value,FCFCORE.FSC_PARTY_ASSOC_ATTRIBUTE.attribute_num_value,FCFCORE.FSC_PARTY_ASSOC_ATTRIBUTE.change_begin_date,FCFCORE.FSC_PARTY_ASSOC_ATTRIBUTE.change_end_date,FCFCORE.FSC_PARTY_ASSOC_ATTRIBUTE.change_current_ind,FCFCORE.FSC_PARTY_ASSOC_ATTRIBUTE.attribute_date_value
		FROM FCFCORE.FSC_PARTY_ASSOC_ATTRIBUTE;

CREATE  VIEW FCFBU1.FSC_SUMMARY_TRANS_TYPE_BRIDGE ( transaction_type_key,summary_group_key,change_begin_date,change_end_date,change_current_ind ) 
	 AS  SELECT FCFCORE.FSC_SUMMARY_TRANS_TYPE_BRIDGE.transaction_type_key,FCFCORE.FSC_SUMMARY_TRANS_TYPE_BRIDGE.summary_group_key,FCFCORE.FSC_SUMMARY_TRANS_TYPE_BRIDGE.change_begin_date,FCFCORE.FSC_SUMMARY_TRANS_TYPE_BRIDGE.change_end_date,FCFCORE.FSC_SUMMARY_TRANS_TYPE_BRIDGE.change_current_ind
		FROM FCFCORE.FSC_SUMMARY_TRANS_TYPE_BRIDGE;

CREATE  VIEW FCFBU1.FSC_ENTITY_PROFILE_HISTORY ( history_period_code,history_begin_date_key,history_period_count,period_sufficiency_count,avg_trans_count,avg_trans_amount,avg_max_trans_amount,max_trans_count,max_trans_amount,max_max_trans_amount,std_trans_count,std_trans_amount,std_max_trans_amount,avg_log10_trans_count,avg_log10_trans_amount,avg_log10_max_trans_amount,max_log10_trans_count,max_log10_trans_amount,max_log10_max_trans_amount,std_log10_trans_count,std_log10_trans_amount,std_log10_max_trans_amount,period_count,profile_group_id,entity_level_code,entity_number,history_end_date_key ) 
	 AS  SELECT FCFCORE.FSC_ENTITY_PROFILE_HISTORY.history_period_code,FCFCORE.FSC_ENTITY_PROFILE_HISTORY.history_begin_date_key,FCFCORE.FSC_ENTITY_PROFILE_HISTORY.history_period_count,FCFCORE.FSC_ENTITY_PROFILE_HISTORY.period_sufficiency_count,FCFCORE.FSC_ENTITY_PROFILE_HISTORY.avg_trans_count,FCFCORE.FSC_ENTITY_PROFILE_HISTORY.avg_trans_amount,FCFCORE.FSC_ENTITY_PROFILE_HISTORY.avg_max_trans_amount,FCFCORE.FSC_ENTITY_PROFILE_HISTORY.max_trans_count,FCFCORE.FSC_ENTITY_PROFILE_HISTORY.max_trans_amount,FCFCORE.FSC_ENTITY_PROFILE_HISTORY.max_max_trans_amount,FCFCORE.FSC_ENTITY_PROFILE_HISTORY.std_trans_count,FCFCORE.FSC_ENTITY_PROFILE_HISTORY.std_trans_amount,FCFCORE.FSC_ENTITY_PROFILE_HISTORY.std_max_trans_amount,FCFCORE.FSC_ENTITY_PROFILE_HISTORY.avg_log10_trans_count,FCFCORE.FSC_ENTITY_PROFILE_HISTORY.avg_log10_trans_amount,FCFCORE.FSC_ENTITY_PROFILE_HISTORY.avg_log10_max_trans_amount,FCFCORE.FSC_ENTITY_PROFILE_HISTORY.max_log10_trans_count,FCFCORE.FSC_ENTITY_PROFILE_HISTORY.max_log10_trans_amount,FCFCORE.FSC_ENTITY_PROFILE_HISTORY.max_log10_max_trans_amount,FCFCORE.FSC_ENTITY_PROFILE_HISTORY.std_log10_trans_count,FCFCORE.FSC_ENTITY_PROFILE_HISTORY.std_log10_trans_amount,FCFCORE.FSC_ENTITY_PROFILE_HISTORY.std_log10_max_trans_amount,FCFCORE.FSC_ENTITY_PROFILE_HISTORY.period_count,FCFCORE.FSC_ENTITY_PROFILE_HISTORY.profile_group_id,FCFCORE.FSC_ENTITY_PROFILE_HISTORY.entity_level_code,FCFCORE.FSC_ENTITY_PROFILE_HISTORY.entity_number,FCFCORE.FSC_ENTITY_PROFILE_HISTORY.history_end_date_key
		FROM FCFCORE.FSC_ENTITY_PROFILE_HISTORY;

CREATE  VIEW FCFBU1.FSC_ENTITY_PEER_GROUP ( entity_level_code,entity_number,change_begin_date,change_end_date,change_current_ind,peer_group_id ) 
	 AS  SELECT FCFCORE.FSC_ENTITY_PEER_GROUP.entity_level_code,FCFCORE.FSC_ENTITY_PEER_GROUP.entity_number,FCFCORE.FSC_ENTITY_PEER_GROUP.change_begin_date,FCFCORE.FSC_ENTITY_PEER_GROUP.change_end_date,FCFCORE.FSC_ENTITY_PEER_GROUP.change_current_ind,FCFCORE.FSC_ENTITY_PEER_GROUP.peer_group_id
		FROM FCFCORE.FSC_ENTITY_PEER_GROUP;

CREATE  VIEW FCFBU1.FSC_PEER_GROUP ( peer_group_key,peer_group_id,peer_group_name,peer_group_desc,change_begin_date,change_end_date,change_current_ind ) 
	 AS  SELECT FCFCORE.FSC_PEER_GROUP.peer_group_key,FCFCORE.FSC_PEER_GROUP.peer_group_id,FCFCORE.FSC_PEER_GROUP.peer_group_name,FCFCORE.FSC_PEER_GROUP.peer_group_desc,FCFCORE.FSC_PEER_GROUP.change_begin_date,FCFCORE.FSC_PEER_GROUP.change_end_date,FCFCORE.FSC_PEER_GROUP.change_current_ind
		FROM FCFCORE.FSC_PEER_GROUP;

CREATE  VIEW FCFBU1.FSC_PROFILE_GROUP ( profile_group_key,profile_group_id,profile_group_name,profile_group_desc,change_begin_date,change_end_date,change_current_ind ) 
	 AS  SELECT FCFCORE.FSC_PROFILE_GROUP.profile_group_key,FCFCORE.FSC_PROFILE_GROUP.profile_group_id,FCFCORE.FSC_PROFILE_GROUP.profile_group_name,FCFCORE.FSC_PROFILE_GROUP.profile_group_desc,FCFCORE.FSC_PROFILE_GROUP.change_begin_date,FCFCORE.FSC_PROFILE_GROUP.change_end_date,FCFCORE.FSC_PROFILE_GROUP.change_current_ind
		FROM FCFCORE.FSC_PROFILE_GROUP;

CREATE  VIEW FCFBU1.FSC_ENTITY_PROFILE_SUMMARY_AGG ( summary_period_code,summary_begin_date_key,entity_level_code,trans_count,trans_amount,max_trans_amount,round_trans_amount,non_monetary_trans_count,log10_trans_amount,log10_max_trans_amount,log10_round_trans_count,log10_round_trans_amount,round_trans_count,log10_trans_count,entity_number,profile_group_id,summary_group_id,summary_end_date_key ) 
	 AS  SELECT FCFCORE.FSC_ENTITY_PROFILE_SUMMARY_AGG.summary_period_code,FCFCORE.FSC_ENTITY_PROFILE_SUMMARY_AGG.summary_begin_date_key,FCFCORE.FSC_ENTITY_PROFILE_SUMMARY_AGG.entity_level_code,FCFCORE.FSC_ENTITY_PROFILE_SUMMARY_AGG.trans_count,FCFCORE.FSC_ENTITY_PROFILE_SUMMARY_AGG.trans_amount,FCFCORE.FSC_ENTITY_PROFILE_SUMMARY_AGG.max_trans_amount,FCFCORE.FSC_ENTITY_PROFILE_SUMMARY_AGG.round_trans_amount,FCFCORE.FSC_ENTITY_PROFILE_SUMMARY_AGG.non_monetary_trans_count,FCFCORE.FSC_ENTITY_PROFILE_SUMMARY_AGG.log10_trans_amount,FCFCORE.FSC_ENTITY_PROFILE_SUMMARY_AGG.log10_max_trans_amount,FCFCORE.FSC_ENTITY_PROFILE_SUMMARY_AGG.log10_round_trans_count,FCFCORE.FSC_ENTITY_PROFILE_SUMMARY_AGG.log10_round_trans_amount,FCFCORE.FSC_ENTITY_PROFILE_SUMMARY_AGG.round_trans_count,FCFCORE.FSC_ENTITY_PROFILE_SUMMARY_AGG.log10_trans_count,FCFCORE.FSC_ENTITY_PROFILE_SUMMARY_AGG.entity_number,FCFCORE.FSC_ENTITY_PROFILE_SUMMARY_AGG.profile_group_id,FCFCORE.FSC_ENTITY_PROFILE_SUMMARY_AGG.summary_group_id,FCFCORE.FSC_ENTITY_PROFILE_SUMMARY_AGG.summary_end_date_key
		FROM FCFCORE.FSC_ENTITY_PROFILE_SUMMARY_AGG;

CREATE  VIEW FCFBU1.FSC_SUMMARY_GROUP ( summary_group_key,summary_group_id,summary_group_name,summary_group_desc,change_begin_date,change_end_date,change_current_ind ) 
	 AS  SELECT FCFCORE.FSC_SUMMARY_GROUP.summary_group_key,FCFCORE.FSC_SUMMARY_GROUP.summary_group_id,FCFCORE.FSC_SUMMARY_GROUP.summary_group_name,FCFCORE.FSC_SUMMARY_GROUP.summary_group_desc,FCFCORE.FSC_SUMMARY_GROUP.change_begin_date,FCFCORE.FSC_SUMMARY_GROUP.change_end_date,FCFCORE.FSC_SUMMARY_GROUP.change_current_ind
		FROM FCFCORE.FSC_SUMMARY_GROUP;

CREATE  VIEW FCFBU1.FSC_PEER_GROUP_PROFILE_HISTORY ( history_period_code,history_begin_date_key,history_period_count,entity_sufficiency_count,avg_trans_count,avg_trans_amount,avg_max_trans_amount,max_trans_count,max_trans_amount,max_max_trans_amount,std_trans_count,std_trans_amount,std_max_trans_amount,avg_log10_trans_count,avg_log10_trans_amount,avg_log10_max_trans_amount,max_log10_trans_count,max_log10_trans_amount,max_log10_max_trans_amount,std_log10_trans_count,std_log10_trans_amount,std_log10_max_trans_amount,entity_count,peer_group_id,profile_group_id,history_end_date_key ) 
	 AS  SELECT FCFCORE.FSC_PEER_GROUP_PROFILE_HISTORY.history_period_code,FCFCORE.FSC_PEER_GROUP_PROFILE_HISTORY.history_begin_date_key,FCFCORE.FSC_PEER_GROUP_PROFILE_HISTORY.history_period_count,FCFCORE.FSC_PEER_GROUP_PROFILE_HISTORY.entity_sufficiency_count,FCFCORE.FSC_PEER_GROUP_PROFILE_HISTORY.avg_trans_count,FCFCORE.FSC_PEER_GROUP_PROFILE_HISTORY.avg_trans_amount,FCFCORE.FSC_PEER_GROUP_PROFILE_HISTORY.avg_max_trans_amount,FCFCORE.FSC_PEER_GROUP_PROFILE_HISTORY.max_trans_count,FCFCORE.FSC_PEER_GROUP_PROFILE_HISTORY.max_trans_amount,FCFCORE.FSC_PEER_GROUP_PROFILE_HISTORY.max_max_trans_amount,FCFCORE.FSC_PEER_GROUP_PROFILE_HISTORY.std_trans_count,FCFCORE.FSC_PEER_GROUP_PROFILE_HISTORY.std_trans_amount,FCFCORE.FSC_PEER_GROUP_PROFILE_HISTORY.std_max_trans_amount,FCFCORE.FSC_PEER_GROUP_PROFILE_HISTORY.avg_log10_trans_count,FCFCORE.FSC_PEER_GROUP_PROFILE_HISTORY.avg_log10_trans_amount,FCFCORE.FSC_PEER_GROUP_PROFILE_HISTORY.avg_log10_max_trans_amount,FCFCORE.FSC_PEER_GROUP_PROFILE_HISTORY.max_log10_trans_count,FCFCORE.FSC_PEER_GROUP_PROFILE_HISTORY.max_log10_trans_amount,FCFCORE.FSC_PEER_GROUP_PROFILE_HISTORY.max_log10_max_trans_amount,FCFCORE.FSC_PEER_GROUP_PROFILE_HISTORY.std_log10_trans_count,FCFCORE.FSC_PEER_GROUP_PROFILE_HISTORY.std_log10_trans_amount,FCFCORE.FSC_PEER_GROUP_PROFILE_HISTORY.std_log10_max_trans_amount,FCFCORE.FSC_PEER_GROUP_PROFILE_HISTORY.entity_count,FCFCORE.FSC_PEER_GROUP_PROFILE_HISTORY.peer_group_id,FCFCORE.FSC_PEER_GROUP_PROFILE_HISTORY.profile_group_id,FCFCORE.FSC_PEER_GROUP_PROFILE_HISTORY.history_end_date_key
		FROM FCFCORE.FSC_PEER_GROUP_PROFILE_HISTORY;

CREATE  VIEW FCFBU1.FSC_PROFILE_SUMMARY_BRIDGE ( profile_group_key,summary_group_key,change_begin_date,change_end_date,change_current_ind ) 
	 AS  SELECT FCFCORE.FSC_PROFILE_SUMMARY_BRIDGE.profile_group_key,FCFCORE.FSC_PROFILE_SUMMARY_BRIDGE.summary_group_key,FCFCORE.FSC_PROFILE_SUMMARY_BRIDGE.change_begin_date,FCFCORE.FSC_PROFILE_SUMMARY_BRIDGE.change_end_date,FCFCORE.FSC_PROFILE_SUMMARY_BRIDGE.change_current_ind
		FROM FCFCORE.FSC_PROFILE_SUMMARY_BRIDGE;

CREATE  VIEW FCFBU1.FSC_ENTITY_PROFILE_AGG ( summary_period_code,summary_begin_date_key,entity_level_code,trans_count,trans_amount,max_trans_amount,round_trans_amount,non_monetary_trans_count,log10_trans_amount,log10_max_trans_amount,log10_round_trans_count,log10_round_trans_amount,round_trans_count,log10_trans_count,entity_number,profile_group_id,summary_end_date_key ) 
	 AS  SELECT FCFCORE.FSC_ENTITY_PROFILE_AGG.summary_period_code,FCFCORE.FSC_ENTITY_PROFILE_AGG.summary_begin_date_key,FCFCORE.FSC_ENTITY_PROFILE_AGG.entity_level_code,FCFCORE.FSC_ENTITY_PROFILE_AGG.trans_count,FCFCORE.FSC_ENTITY_PROFILE_AGG.trans_amount,FCFCORE.FSC_ENTITY_PROFILE_AGG.max_trans_amount,FCFCORE.FSC_ENTITY_PROFILE_AGG.round_trans_amount,FCFCORE.FSC_ENTITY_PROFILE_AGG.non_monetary_trans_count,FCFCORE.FSC_ENTITY_PROFILE_AGG.log10_trans_amount,FCFCORE.FSC_ENTITY_PROFILE_AGG.log10_max_trans_amount,FCFCORE.FSC_ENTITY_PROFILE_AGG.log10_round_trans_count,FCFCORE.FSC_ENTITY_PROFILE_AGG.log10_round_trans_amount,FCFCORE.FSC_ENTITY_PROFILE_AGG.round_trans_count,FCFCORE.FSC_ENTITY_PROFILE_AGG.log10_trans_count,FCFCORE.FSC_ENTITY_PROFILE_AGG.entity_number,FCFCORE.FSC_ENTITY_PROFILE_AGG.profile_group_id,FCFCORE.FSC_ENTITY_PROFILE_AGG.summary_end_date_key
		FROM FCFCORE.FSC_ENTITY_PROFILE_AGG;

CREATE  VIEW FCFBU1.FSC_TRANSPORT_WATCH_LIST_DIM AS SELECT * FROM FCFCORE.FSC_TRANSPORT_WATCH_LIST_DIM;

----------------------------------------------------------------------------
--FCFBU1 views on FCFKC tables statements
----------------------------------------------------------------------------

CREATE  VIEW FCFBU1.FSK_ACCOUNT_EVENT_ALERT AS SELECT * FROM FCFKC.FSK_ACCOUNT_EVENT_ALERT;

CREATE  VIEW FCFBU1.FSK_ACCOUNT_PROFILE_ALERT AS SELECT * FROM FCFKC.FSK_ACCOUNT_PROFILE_ALERT;

CREATE  VIEW FCFBU1.FSK_ACCOUNT_TRADE_ALERT AS SELECT * FROM FCFKC.FSK_ACCOUNT_TRADE_ALERT;

CREATE  VIEW FCFBU1.FSK_ALERT AS SELECT * FROM FCFKC.FSK_ALERT;

CREATE  VIEW FCFBU1.FSK_ALERT_EMAIL AS SELECT * FROM FCFKC.FSK_ALERT_EMAIL;

CREATE  VIEW FCFBU1.FSK_ALERT_EVENT AS SELECT * FROM FCFKC.FSK_ALERT_EVENT;

CREATE  VIEW FCFBU1.FSK_ALERT_REMINDER AS SELECT * FROM FCFKC.FSK_ALERT_REMINDER;

CREATE  VIEW FCFBU1.FSK_ALERT_RISK_FACTOR AS SELECT * FROM FCFKC.FSK_ALERT_RISK_FACTOR;

CREATE  VIEW FCFBU1.FSK_CASH_FLOW_ALERT AS SELECT * FROM FCFKC.FSK_CASH_FLOW_ALERT;

CREATE  VIEW FCFBU1.FSK_CASH_FLOW_BANK_ALERT AS SELECT * FROM FCFKC.FSK_CASH_FLOW_BANK_ALERT;

CREATE  view FCFBU1.FSK_HEADER as select
   HEADER_ID,
   HEADER_NAME,
   HEADER_DESCRIPTION,
   ENTITY_LEVEL_CODE,
   DENORM_TABLE_NAME,
   ALERT_TABLE_NAME,
   HEADER_AUTOGEN_IND,
   HEADER_LOCATION_DESC,
   SOURCE_TYPE_DESC,
   CREATE_USER_ID,
   CREATE_DATE,
   LSTUPDATE_USER_ID,
   LSTUPDATE_DATE,
   HEADER_HOST_DESC,
   VERSION_NUMBER,
   LOGICAL_DELETE_IND
   from FCFKC.FSK_HEADER;

CREATE  view FCFBU1.FSK_HEADER_ELEMENT as select
   HEADER_ID,
   ELEMENT_NAME,
   ELEMENT_TYPE_CODE,
   ELEMENT_LENGTH_COUNT,
   ELEMENT_FORMAT_CODE,
   ELEMENT_LABEL_DESC,
   ELEMENT_USAGE_DESC
   from FCFKC.FSK_HEADER_ELEMENT;

CREATE  VIEW FCFBU1.FSK_JOB_CALENDAR AS SELECT * FROM FCFKC.FSK_JOB_CALENDAR;

CREATE  VIEW FCFBU1.FSK_LIST AS SELECT * FROM FCFKC.FSK_LIST;

CREATE  VIEW FCFBU1.FSK_LIST_CATEGORY AS SELECT * FROM FCFKC.FSK_LIST_CATEGORY;

CREATE  VIEW FCFBU1.FSK_LIST_ELEMENT AS SELECT * FROM FCFKC.FSK_LIST_ELEMENT;

CREATE  VIEW FCFBU1.FSK_LOV AS SELECT * FROM FCFKC.FSK_LOV;

CREATE  VIEW FCFBU1.FSK_PARTY_PROFILE_ALERT AS SELECT * FROM FCFKC.FSK_PARTY_PROFILE_ALERT;

CREATE  VIEW FCFBU1.FSK_RISK_ASSESSMENT AS SELECT * FROM FCFKC.FSK_RISK_ASSESSMENT;

CREATE  VIEW FCFBU1.FSK_RISK_ASSESSMENT_CLASSIFIER AS SELECT * FROM FCFKC.FSK_RISK_ASSESSMENT_CLASSIFIER;

CREATE  VIEW FCFBU1.FSK_RISK_ASSESSMENT_EMAIL AS SELECT * FROM FCFKC.FSK_RISK_ASSESSMENT_EMAIL;

CREATE  VIEW FCFBU1.FSK_RISK_ASSESSMENT_EVENT AS SELECT * FROM FCFKC.FSK_RISK_ASSESSMENT_EVENT;

CREATE  VIEW FCFBU1.FSK_RISK_CLASSIFIER AS SELECT * FROM FCFKC.FSK_RISK_CLASSIFIER;

CREATE  VIEW FCFBU1.FSK_RISK_CLASSIFIER_CATEGORY AS SELECT * FROM FCFKC.FSK_RISK_CLASSIFIER_CATEGORY;

create  view FCFBU1.FSK_ROUTING_CONSTRAINT as select 
    routing_group_id,
    routing_rule_id,
    constraint_order_number,
    column_name,
    operator_desc,
    value_desc,
    compound_operator_name 
from FCFKC.FSK_ROUTING_CONSTRAINT;

create  view FCFBU1.FSK_ROUTING_GROUP as select 
    routing_group_id,
    routing_group_name,
    version_number,
    logical_delete_ind,
    lstupdate_user_id,
    lstupdate_date 
from FCFKC.FSK_ROUTING_GROUP;

create  view FCFBU1.FSK_ROUTING_RULE as select 
    routing_group_id,
    routing_rule_id,
    route_order_number,
    alert_type_cd,
    alert_category_cd,
    alert_subcategory_cd,
    routing_user_long_id
from FCFKC.FSK_ROUTING_RULE;

CREATE  VIEW FCFBU1.FSK_SCENARIO_MESSAGE AS SELECT * FROM FCFKC.FSK_SCENARIO_MESSAGE;

CREATE  view FCFBU1.FSK_SCENARIO_PARAMETER as select
   SCENARIO_ID ,
   PARM_NAME ,
   PARM_VALUE ,
   PARM_TYPE_DESC,
   PARM_DESC
   from FCFKC.FSK_SCENARIO_PARAMETER;

CREATE  VIEW FCFBU1.FSK_TRANSACTION_ALERT AS SELECT * FROM FCFKC.FSK_TRANSACTION_ALERT;

CREATE  VIEW FCFBU1.FSK_UI_AVAILABILITY AS SELECT * FROM FCFKC.FSK_UI_AVAILABILITY;

CREATE  VIEW FCFBU1.FSK_UI_COLUMN AS SELECT * FROM FCFKC.FSK_UI_COLUMN;

CREATE  VIEW FCFBU1.FSK_UI_GROUP AS SELECT * FROM FCFKC.FSK_UI_GROUP;

CREATE  VIEW FCFBU1.FSK_UI_TABLE AS SELECT * FROM FCFKC.FSK_UI_TABLE;

CREATE  VIEW FCFBU1.FSK_ASSESSMENT_ROUTING_RULE AS SELECT * FROM FCFKC.FSK_ASSESSMENT_ROUTING_RULE;

CREATE  VIEW FCFBU1.FSK_SCD2_COLUMNS AS SELECT * FROM FCFKC.FSK_SCD2_COLUMNS;

CREATE  VIEW FCFBU1.FSK_SCENARIO_FILTER ( scenario_id,filter_id,filter_name,save_trig_trans_ind,days_number,filter_order_number ) 
	 AS  SELECT FCFKC.FSK_SCENARIO_FILTER.scenario_id,FCFKC.FSK_SCENARIO_FILTER.filter_id,FCFKC.FSK_SCENARIO_FILTER.filter_name,FCFKC.FSK_SCENARIO_FILTER.save_trig_trans_ind,FCFKC.FSK_SCENARIO_FILTER.days_number,FCFKC.FSK_SCENARIO_FILTER.filter_order_number
		FROM FCFKC.FSK_SCENARIO_FILTER;

CREATE  VIEW FCFBU1.FSK_SCENARIO_FILTER_CONSTRAINT ( filter_id,left_operand,left_operand_type,constraint_operator,right_operand,right_operand_type,compound_operator,constraint_order_number ) 
	 AS  SELECT FCFKC.FSK_SCENARIO_FILTER_CONSTRAINT.filter_id,FCFKC.FSK_SCENARIO_FILTER_CONSTRAINT.left_operand,FCFKC.FSK_SCENARIO_FILTER_CONSTRAINT.left_operand_type,FCFKC.FSK_SCENARIO_FILTER_CONSTRAINT.constraint_operator,FCFKC.FSK_SCENARIO_FILTER_CONSTRAINT.right_operand,FCFKC.FSK_SCENARIO_FILTER_CONSTRAINT.right_operand_type,FCFKC.FSK_SCENARIO_FILTER_CONSTRAINT.compound_operator,FCFKC.FSK_SCENARIO_FILTER_CONSTRAINT.constraint_order_number
		FROM FCFKC.FSK_SCENARIO_FILTER_CONSTRAINT;

CREATE  VIEW FCFBU1.FSK_SCENARIO_FILTER_VARIABLE ( filter_id,variable_name,function_name,variable_type ) 
	 AS  SELECT FCFKC.FSK_SCENARIO_FILTER_VARIABLE.filter_id,FCFKC.FSK_SCENARIO_FILTER_VARIABLE.variable_name,FCFKC.FSK_SCENARIO_FILTER_VARIABLE.function_name,FCFKC.FSK_SCENARIO_FILTER_VARIABLE.variable_type
		FROM FCFKC.FSK_SCENARIO_FILTER_VARIABLE;

CREATE  VIEW FCFBU1.FSK_SCENARIO_MESSAGE_PARAMETER ( scenario_id,message_parameter,message_parameter_type,variable_format,parameter_number ) 
	 AS  SELECT FCFKC.FSK_SCENARIO_MESSAGE_PARAMETER.scenario_id,FCFKC.FSK_SCENARIO_MESSAGE_PARAMETER.message_parameter,FCFKC.FSK_SCENARIO_MESSAGE_PARAMETER.message_parameter_type,FCFKC.FSK_SCENARIO_MESSAGE_PARAMETER.variable_format,FCFKC.FSK_SCENARIO_MESSAGE_PARAMETER.parameter_number
		FROM FCFKC.FSK_SCENARIO_MESSAGE_PARAMETER;

CREATE  VIEW FCFBU1.FSK_SCENARIO_ALERT_CONSTRAINT ( scenario_id,left_operand,left_operand_type,constraint_operator,right_operand,right_operand_type,compound_operator,constraint_order_number ) 
	 AS  SELECT FCFKC.FSK_SCENARIO_ALERT_CONSTRAINT.scenario_id,FCFKC.FSK_SCENARIO_ALERT_CONSTRAINT.left_operand,FCFKC.FSK_SCENARIO_ALERT_CONSTRAINT.left_operand_type,FCFKC.FSK_SCENARIO_ALERT_CONSTRAINT.constraint_operator,FCFKC.FSK_SCENARIO_ALERT_CONSTRAINT.right_operand,FCFKC.FSK_SCENARIO_ALERT_CONSTRAINT.right_operand_type,FCFKC.FSK_SCENARIO_ALERT_CONSTRAINT.compound_operator,FCFKC.FSK_SCENARIO_ALERT_CONSTRAINT.constraint_order_number
		FROM FCFKC.FSK_SCENARIO_ALERT_CONSTRAINT;

CREATE  VIEW FCFBU1.FSK_SCENARIO_LOCALIZED_MSG ( scenario_id,locale,scenario_message_text ) 
	 AS  SELECT FCFKC.FSK_SCENARIO_LOCALIZED_MSG.scenario_id,FCFKC.FSK_SCENARIO_LOCALIZED_MSG.locale,FCFKC.FSK_SCENARIO_LOCALIZED_MSG.scenario_message_text
		FROM FCFKC.FSK_SCENARIO_LOCALIZED_MSG;

CREATE  VIEW FCFBU1.FSK_TEMP_ASSESS ( create_date,party_key ) 
	 AS  SELECT FCFKC.FSK_TEMP_ASSESS.create_date,FCFKC.FSK_TEMP_ASSESS.party_key
		FROM FCFKC.FSK_TEMP_ASSESS;

CREATE  VIEW FCFBU1.FSK_TEMP_NUMBER ( primary_entity_number ) 
	 AS  SELECT FCFKC.FSK_TEMP_NUMBER.primary_entity_number
		FROM FCFKC.FSK_TEMP_NUMBER;

CREATE  VIEW FCFBU1.FSK_TEMP_EXT_PARTY_KEYS ( alert_id,ext_party_account_key,run_date ) 
	 AS  SELECT FCFKC.FSK_TEMP_EXT_PARTY_KEYS.alert_id,FCFKC.FSK_TEMP_EXT_PARTY_KEYS.ext_party_account_key,FCFKC.FSK_TEMP_EXT_PARTY_KEYS.run_date
		FROM FCFKC.FSK_TEMP_EXT_PARTY_KEYS;






CREATE  VIEW FCFBU1.FSK_ACCOUNT_KEYS_PTY ( alert_id,account_key,run_date ) 
	 AS  SELECT FCFKC.FSK_ACCOUNT_KEYS_PTY.alert_id,FCFKC.FSK_ACCOUNT_KEYS_PTY.account_key,FCFKC.FSK_ACCOUNT_KEYS_PTY.run_date
		FROM FCFKC.FSK_ACCOUNT_KEYS_PTY;

CREATE  VIEW FCFBU1.FSK_NN_PARTY ( alert_id,party_number ) 
	 AS  SELECT FCFKC.FSK_NN_PARTY.alert_id,FCFKC.FSK_NN_PARTY.party_number
		FROM FCFKC.FSK_NN_PARTY;

CREATE  VIEW FCFBU1.FSK_REPLICATION_DATES ( alert_id,start_date,start_date_key ) 
	 AS  SELECT FCFKC.FSK_REPLICATION_DATES.alert_id,FCFKC.FSK_REPLICATION_DATES.start_date,FCFKC.FSK_REPLICATION_DATES.start_date_key
		FROM FCFKC.FSK_REPLICATION_DATES;

CREATE  VIEW FCFBU1.FSK_ACCOUNT_KEYS_HHD ( alert_id,account_key,run_date ) 
	 AS  SELECT FCFKC.FSK_ACCOUNT_KEYS_HHD.alert_id,FCFKC.FSK_ACCOUNT_KEYS_HHD.account_key,FCFKC.FSK_ACCOUNT_KEYS_HHD.run_date
		FROM FCFKC.FSK_ACCOUNT_KEYS_HHD;

CREATE  VIEW FCFBU1.FSK_NN_ENTITY ( primary_entity_number,primary_entity_level_code,alert_id ) 
	 AS  SELECT FCFKC.FSK_NN_ENTITY.primary_entity_number,FCFKC.FSK_NN_ENTITY.primary_entity_level_code,FCFKC.FSK_NN_ENTITY.alert_id
		FROM FCFKC.FSK_NN_ENTITY;

CREATE  VIEW FCFBU1.FSK_ALERT_NEIGHBOR ( alert_id,target_account_number,neighbor_account_number,distance ) 
	 AS  SELECT FCFKC.FSK_ALERT_NEIGHBOR.alert_id,FCFKC.FSK_ALERT_NEIGHBOR.target_account_number,FCFKC.FSK_ALERT_NEIGHBOR.neighbor_account_number,FCFKC.FSK_ALERT_NEIGHBOR.distance
		FROM FCFKC.FSK_ALERT_NEIGHBOR;

CREATE  VIEW FCFBU1.FSK_ACCOUNT_KEYS_ASC ( alert_id,account_key,run_date ) 
	 AS  SELECT FCFKC.FSK_ACCOUNT_KEYS_ASC.alert_id,FCFKC.FSK_ACCOUNT_KEYS_ASC.account_key,FCFKC.FSK_ACCOUNT_KEYS_ASC.run_date
		FROM FCFKC.FSK_ACCOUNT_KEYS_ASC;

CREATE  VIEW FCFBU1.FSK_CDD_SCORING_EVENT ( cdd_scoring_event_key,primary_entity_key,rule_score,event_date,score_classification_code,auto_high_ind,investigation_ind,investigation_action_code,primary_entity_number,cdd_rule_id,category_code,score_type_code,investigation_type_cd,investigation_category_cd,investigation_subcategory_cd,investigation_status_cd,investigation_rk,primary_entity_level_code,version_no,investigation_object_code ) 
	 AS  SELECT FCFKC.FSK_CDD_SCORING_EVENT.cdd_scoring_event_key,FCFKC.FSK_CDD_SCORING_EVENT.primary_entity_key,FCFKC.FSK_CDD_SCORING_EVENT.rule_score,FCFKC.FSK_CDD_SCORING_EVENT.event_date,FCFKC.FSK_CDD_SCORING_EVENT.score_classification_code,FCFKC.FSK_CDD_SCORING_EVENT.auto_high_ind,FCFKC.FSK_CDD_SCORING_EVENT.investigation_ind,FCFKC.FSK_CDD_SCORING_EVENT.investigation_action_code,FCFKC.FSK_CDD_SCORING_EVENT.primary_entity_number,FCFKC.FSK_CDD_SCORING_EVENT.cdd_rule_id,FCFKC.FSK_CDD_SCORING_EVENT.category_code,FCFKC.FSK_CDD_SCORING_EVENT.score_type_code,FCFKC.FSK_CDD_SCORING_EVENT.investigation_type_cd,FCFKC.FSK_CDD_SCORING_EVENT.investigation_category_cd,FCFKC.FSK_CDD_SCORING_EVENT.investigation_subcategory_cd,FCFKC.FSK_CDD_SCORING_EVENT.investigation_status_cd,FCFKC.FSK_CDD_SCORING_EVENT.investigation_rk,FCFKC.FSK_CDD_SCORING_EVENT.primary_entity_level_code,FCFKC.FSK_CDD_SCORING_EVENT.version_no,FCFKC.FSK_CDD_SCORING_EVENT.investigation_object_code
		FROM FCFKC.FSK_CDD_SCORING_EVENT;

CREATE  VIEW FCFBU1.FSK_CDD_TRIGGERING_VALUES ( cdd_scoring_event_key,cdd_triggering_value_key,triggering_value_id,triggering_char_value,triggering_date_value,triggering_num_value,triggering_value_type_code,ref_table_nm ) 
	 AS  SELECT FCFKC.FSK_CDD_TRIGGERING_VALUES.cdd_scoring_event_key,FCFKC.FSK_CDD_TRIGGERING_VALUES.cdd_triggering_value_key,FCFKC.FSK_CDD_TRIGGERING_VALUES.triggering_value_id,FCFKC.FSK_CDD_TRIGGERING_VALUES.triggering_char_value,FCFKC.FSK_CDD_TRIGGERING_VALUES.triggering_date_value,FCFKC.FSK_CDD_TRIGGERING_VALUES.triggering_num_value,FCFKC.FSK_CDD_TRIGGERING_VALUES.triggering_value_type_code,FCFKC.FSK_CDD_TRIGGERING_VALUES.ref_table_nm
		FROM FCFKC.FSK_CDD_TRIGGERING_VALUES;

CREATE  VIEW FCFBU1.FSK_CDD_RULE ( cdd_rule_id,cdd_rule_type_code,current_ind,cdd_update_date,cdd_deploy_date,cdd_rule_name_id,cdd_rule_name,cdd_rule_description_id,cdd_rule_description,cdd_rule_status_code,cdd_rule_save_id_flg,cdd_rule_order_in_group,version_no,cdd_rule_group_id ) 
	 AS  SELECT FCFKC.FSK_CDD_RULE.cdd_rule_id,FCFKC.FSK_CDD_RULE.cdd_rule_type_code,FCFKC.FSK_CDD_RULE.current_ind,FCFKC.FSK_CDD_RULE.cdd_update_date,FCFKC.FSK_CDD_RULE.cdd_deploy_date,FCFKC.FSK_CDD_RULE.cdd_rule_name_id,FCFKC.FSK_CDD_RULE.cdd_rule_name,FCFKC.FSK_CDD_RULE.cdd_rule_description_id,FCFKC.FSK_CDD_RULE.cdd_rule_description,FCFKC.FSK_CDD_RULE.cdd_rule_status_code,FCFKC.FSK_CDD_RULE.cdd_rule_save_id_flg,FCFKC.FSK_CDD_RULE.cdd_rule_order_in_group,FCFKC.FSK_CDD_RULE.version_no,FCFKC.FSK_CDD_RULE.cdd_rule_group_id
		FROM FCFKC.FSK_CDD_RULE;

CREATE  VIEW FCFBU1.FSK_CDD_RULE_PARAMETER ( cdd_rule_version_no,cdd_rule_parm_name,cdd_rule_parm_desc_id,cdd_rule_parm_description,cdd_rule_parm_type_code,cdd_rule_parm_val,cdd_rule_id ) 
	 AS  SELECT FCFKC.FSK_CDD_RULE_PARAMETER.cdd_rule_version_no,FCFKC.FSK_CDD_RULE_PARAMETER.cdd_rule_parm_name,FCFKC.FSK_CDD_RULE_PARAMETER.cdd_rule_parm_desc_id,FCFKC.FSK_CDD_RULE_PARAMETER.cdd_rule_parm_description,FCFKC.FSK_CDD_RULE_PARAMETER.cdd_rule_parm_type_code,FCFKC.FSK_CDD_RULE_PARAMETER.cdd_rule_parm_val,FCFKC.FSK_CDD_RULE_PARAMETER.cdd_rule_id
		FROM FCFKC.FSK_CDD_RULE_PARAMETER;

CREATE  VIEW FCFBU1.FSK_CDD_RULE_GROUP ( cdd_rule_group_id,version_no,current_ind,cdd_update_date,cdd_deploy_date,cdd_rule_group_file_name,cdd_rule_group_category_code,cdd_rule_group_desc_id,cdd_rule_group_description,cdd_rule_group_name_id,cdd_rule_group_name,cdd_rule_group_input_ds_name,cdd_rule_group_by_var_1_name,cdd_rule_group_by_var_2_name,cdd_rule_group_level,cdd_rule_group_order_in_level,cdd_rule_group_save_to_kc_flg,cdd_rule_group_save_trig_v_flg ) 
	 AS  SELECT FCFKC.FSK_CDD_RULE_GROUP.cdd_rule_group_id,FCFKC.FSK_CDD_RULE_GROUP.version_no,FCFKC.FSK_CDD_RULE_GROUP.current_ind,FCFKC.FSK_CDD_RULE_GROUP.cdd_update_date,FCFKC.FSK_CDD_RULE_GROUP.cdd_deploy_date,FCFKC.FSK_CDD_RULE_GROUP.cdd_rule_group_file_name,FCFKC.FSK_CDD_RULE_GROUP.cdd_rule_group_category_code,FCFKC.FSK_CDD_RULE_GROUP.cdd_rule_group_desc_id,FCFKC.FSK_CDD_RULE_GROUP.cdd_rule_group_description,FCFKC.FSK_CDD_RULE_GROUP.cdd_rule_group_name_id,FCFKC.FSK_CDD_RULE_GROUP.cdd_rule_group_name,FCFKC.FSK_CDD_RULE_GROUP.cdd_rule_group_input_ds_name,FCFKC.FSK_CDD_RULE_GROUP.cdd_rule_group_by_var_1_name,FCFKC.FSK_CDD_RULE_GROUP.cdd_rule_group_by_var_2_name,FCFKC.FSK_CDD_RULE_GROUP.cdd_rule_group_level,FCFKC.FSK_CDD_RULE_GROUP.cdd_rule_group_order_in_level,FCFKC.FSK_CDD_RULE_GROUP.cdd_rule_group_save_to_kc_flg,FCFKC.FSK_CDD_RULE_GROUP.cdd_rule_group_save_trig_v_flg
		FROM FCFKC.FSK_CDD_RULE_GROUP;

CREATE  VIEW FCFBU1.FSK_CDD_ENTITY_FACT ( primary_entity_number,primary_entity_level_code,last_change_date,next_review_date,override_score_class_code,final_disposition_code,last_review_date,last_scoring_event_key,last_review_scoring_event_key,curr_review_scoring_event_key ) 
	 AS  SELECT FCFKC.FSK_CDD_ENTITY_FACT.primary_entity_number,FCFKC.FSK_CDD_ENTITY_FACT.primary_entity_level_code,FCFKC.FSK_CDD_ENTITY_FACT.last_change_date,FCFKC.FSK_CDD_ENTITY_FACT.next_review_date,FCFKC.FSK_CDD_ENTITY_FACT.override_score_class_code,FCFKC.FSK_CDD_ENTITY_FACT.final_disposition_code,FCFKC.FSK_CDD_ENTITY_FACT.last_review_date,FCFKC.FSK_CDD_ENTITY_FACT.last_scoring_event_key,FCFKC.FSK_CDD_ENTITY_FACT.last_review_scoring_event_key,FCFKC.FSK_CDD_ENTITY_FACT.curr_review_scoring_event_key
		FROM FCFKC.FSK_CDD_ENTITY_FACT;

CREATE  VIEW FCFBU1.FSK_TEMP_TABLE ( temp_char_1_value,temp_char_2_value,temp_char_3_value,temp_char_4_value,temp_date_1_value,temp_date_2_value,temp_date_3_value,temp_date_4_value,temp_num_1_value,temp_num_2_value,temp_num_3_value,temp_num_4_value ) 
	 AS  SELECT FCFKC.FSK_TEMP_TABLE.temp_char_1_value,FCFKC.FSK_TEMP_TABLE.temp_char_2_value,FCFKC.FSK_TEMP_TABLE.temp_char_3_value,FCFKC.FSK_TEMP_TABLE.temp_char_4_value,FCFKC.FSK_TEMP_TABLE.temp_date_1_value,FCFKC.FSK_TEMP_TABLE.temp_date_2_value,FCFKC.FSK_TEMP_TABLE.temp_date_3_value,FCFKC.FSK_TEMP_TABLE.temp_date_4_value,FCFKC.FSK_TEMP_TABLE.temp_num_1_value,FCFKC.FSK_TEMP_TABLE.temp_num_2_value,FCFKC.FSK_TEMP_TABLE.temp_num_3_value,FCFKC.FSK_TEMP_TABLE.temp_num_4_value
		FROM FCFKC.FSK_TEMP_TABLE;

CREATE  VIEW FCFBU1.FSK_SCENARIO AS SELECT * from FCFKC.FSK_SCENARIO;

CREATE   VIEW FCFBU1.FSK_PREFERENCE AS  SELECT * FROM FCFKC.FSK_PREFERENCE;

CREATE  VIEW FCFBU1.FSK_ALERT_TX_AGG AS SELECT * FROM FCFKC.FSK_ALERT_TX_AGG;

CREATE  VIEW FCFBU1.FSK_ENTITY_TX_AGG AS SELECT * FROM FCFKC.FSK_ENTITY_TX_AGG;

CREATE  VIEW FCFBU1.FSK_ALERTED_ENTITY AS SELECT * FROM FCFKC.FSK_ALERTED_ENTITY;

CREATE  VIEW FCFBU1.FSK_ALERT_TRANSACTION AS SELECT * FROM FCFKC.FSK_ALERT_TRANSACTION;

CREATE  VIEW FCFBU1.FSK_RC_REPORT AS SELECT * from FCFKC.FSK_RC_REPORT;

CREATE  VIEW FCFBU1.FSK_RC_REPORT_ENTITY AS SELECT * from FCFKC.FSK_RC_REPORT_ENTITY;

CREATE   VIEW FCFBU1.FSK_RC_EFILE AS  SELECT * FROM FCFKC.FSK_RC_EFILE;

CREATE   VIEW FCFBU1.FSK_RC_FORM_CONFIG AS  SELECT * FROM FCFKC.FSK_RC_FORM_CONFIG;

CREATE   VIEW FCFBU1.FSK_RC_EFILE_REPORT AS  SELECT * FROM FCFKC.FSK_RC_EFILE_REPORT;

CREATE  VIEW FCFBU1.FSK_CASE AS SELECT * FROM FCFKC.FSK_CASE;

CREATE  VIEW FCFBU1.FSK_CASE_ENTITY AS SELECT * FROM FCFKC.FSK_CASE_ENTITY;

CREATE  VIEW FCFBU1.FSK_ACCOUNT_KEYS_ACC ( alert_id,account_key,run_date ) 
	 AS  SELECT FCFKC.FSK_ACCOUNT_KEYS_ACC.alert_id,FCFKC.FSK_ACCOUNT_KEYS_ACC.account_key,FCFKC.FSK_ACCOUNT_KEYS_ACC.run_date
		FROM FCFKC.FSK_ACCOUNT_KEYS_ACC;

CREATE  VIEW FCFBU1.FSK_RC_FORM_DEFAULT AS SELECT * FROM FCFKC.FSK_RC_FORM_DEFAULT;

CREATE  VIEW FCFBU1.FSK_COMMENT AS SELECT * FROM FCFKC.FSK_COMMENT;

CREATE  VIEW FCFBU1.FSK_ATTACHMENT AS SELECT * FROM FCFKC.FSK_ATTACHMENT;

CREATE  VIEW FCFBU1.FSK_CASE_EVENT AS SELECT * FROM FCFKC.FSK_CASE_EVENT;

CREATE  VIEW FCFBU1.FSK_CASE_ENTITY_EVENT AS SELECT * FROM FCFKC.FSK_CASE_ENTITY_EVENT;

CREATE  VIEW FCFBU1.FSK_ENTITY_EVENT AS SELECT * FROM FCFKC.FSK_ENTITY_EVENT;

CREATE  VIEW FCFBU1.FSK_ALERT_CASE AS SELECT * FROM FCFKC.FSK_ALERT_CASE;

CREATE  VIEW FCFBU1.FSK_ENTITY_TRANSACTION AS SELECT * FROM FCFKC.FSK_ENTITY_TRANSACTION;

CREATE  VIEW FCFBU1.FSK_RC_REPORT_ENTITY_EVENT AS SELECT * FROM FCFKC.FSK_RC_REPORT_ENTITY_EVENT;

CREATE  VIEW FCFBU1.FSK_RC_REPORT_EVENT AS SELECT * FROM FCFKC.FSK_RC_REPORT_EVENT;

CREATE  VIEW FCFBU1.FSK_RC_REPORT_ENTITY_INFO AS SELECT * FROM FCFKC.FSK_RC_REPORT_ENTITY_INFO;

CREATE  VIEW FCFBU1.FSK_RC_FORM_CODE_MAPPING AS SELECT * FROM FCFKC.FSK_RC_FORM_CODE_MAPPING;


CREATE VIEW FCFBU1.AccountProfileView
(account_Number
,account_type_desc
,avg_Account_Value_Amount
,cust_Initiated_Trans_Count
,max_Account_Value_Amount
,min_Account_Value_Amount
,month_key
,total_Credits_Amount
,total_Debits_Amount
,total_Wire_Credits_Amount
,total_Wire_Debits_Amount
,wires_Count)
AS
locking row for access 
SELECT
a.account_number
,b.account_type_desc
,a.avg_Account_Value_Amount
,a.cust_Initiated_Trans_Count
,a.max_Account_Value_Amount
,a.min_Account_Value_Amount
,a. month_key
,a.total_Credits_Amount
,a.total_Debits_Amount
,a.total_Wire_Credits_Amount
,a.total_Wire_Debits_Amount
,a.wires_Count
FROM FCFCORE.fsc_account_profile_fact a
	,FCFCORE.fsc_account_dim b
WHERE a.account_number=b.account_number
		AND b.change_current_ind='Y';

CREATE VIEW FCFBU1.AccountTransactionView
(
account_number
,account_tax_state_code
,account_type_desc
,annual_income_amount
,branch_number
,branch_type_desc
,currency_amount
,currency_based_account_ind
,currency_code
,customer_since_date
,date_key
,expected_credit_ceiling_amount
,expected_debit_ceiling_amount
,expected_incoming_amount
,expected_incoming_count
,expected_outgoing_amount
,expected_outgoing_count
,increased_behavior_credit_amt
,increased_behavior_credit_cnt
,increased_behavior_debit_amt
,increased_behavior_debit_cnt
,last_cash_trans_rpt_date
,last_susp_actv_rpt_date
,mechanism_desc
,politically_exposed_person_ind
,primary_medium_desc
,secondary_medium_desc
,status_desc
,status_reason_desc
,street_state_code
,transaction_cdi_code
,transaction_key

) AS
locking row for access 
SELECT
aa.account_number
,aa.account_tax_state_code
,aa.account_type_desc
,aa.annual_income_amount
,aa.branch_number
,aa.branch_type_desc
,aa.currency_amount
,aa.currency_based_account_ind
,aa.currency_code
,aa.customer_since_date
,aa.date_key
,x.expected_credit_ceiling_amount
,x.expected_debit_ceiling_amount
,x.expected_incoming_amount
,x.expected_incoming_count
,x.expected_outgoing_amount
,x.expected_outgoing_count
,x.increased_behavior_credit_amt
,x.increased_behavior_credit_cnt
,x.increased_behavior_debit_amt
,x.increased_behavior_debit_cnt
,aa.last_cash_trans_rpt_date
,aa.last_susp_actv_rpt_date
,aa.mechanism_desc
,aa.politically_exposed_person_ind
,aa.primary_medium_desc
,aa.secondary_medium_desc
,aa.status_desc
,aa.status_reason_desc
,aa.street_state_code
,aa.transaction_cdi_code
,aa.transaction_key

FROM
(SELECT
 A.account_number
, A.account_tax_state_code
, A.account_type_desc
, B.annual_income_amount
, D.branch_number
, D.branch_type_desc
, I.currency_amount
, A.currency_based_account_ind
, F.currency_code
, B.customer_since_date
, I.date_key
, b.last_cash_trans_rpt_date
, b.last_susp_actv_rpt_date
, c.mechanism_desc
, b.politically_exposed_person_ind
, c.primary_medium_desc
, c.secondary_medium_desc
, g.status_desc
, g.status_reason_desc
, d.street_state_code
, c.transaction_cdi_code
, i.transaction_key
FROM
 FCFCORE.fsc_account_dim A
,FCFCORE.fsc_party_dim B
,FCFCORE.fsc_transaction_type_dim C
,FCFCORE.fsc_branch_dim D
,FCFCORE.fsc_country_dim E
,FCFCORE.fsc_currency_dim F
,FCFCORE.fsc_transaction_status_dim G
,FCFCORE.fsc_party_account_bridge H
,FCFCORE.fsc_cash_flow_fact I
WHERE
 I.account_key = A.account_key
 AND A.account_key = H.account_key
 AND B.party_key = H.party_key
 AND I.transaction_type_key = C.transaction_type_key
 AND I.transaction_status_key = G.transaction_status_key
 AND I.country_key = E.country_key
 AND I.branch_key = D.branch_key
 AND I.transaction_currency_key = F.currency_key
 AND H.role_desc = 'PRIMARY OWNER'
 AND H.change_current_ind = 'Y'
UNION ALL
SELECT
 A.account_number
 ,A.account_tax_state_code
 ,A.account_type_desc
 ,B.annual_income_amount
 ,D.branch_number
 ,D.branch_type_desc
 ,0 as currency_amount
 ,A.currency_based_account_ind
 ,'' as currency_code
 ,B.customer_since_date
 ,I.date_key
 ,B.last_cash_trans_rpt_date
 ,B.last_susp_actv_rpt_date
 ,C.mechanism_desc
 ,B.politically_exposed_person_ind
 ,C.primary_medium_desc
 ,C.secondary_medium_desc
 ,D.street_state_code
 ,G.status_desc
 ,G.status_reason_desc
 ,C.transaction_cdi_code
 ,I.transaction_key
FROM
FCFCORE.fsc_account_dim A
,FCFCORE.fsc_party_dim B
,FCFCORE.fsc_transaction_type_dim C
,FCFCORE.fsc_branch_dim D
,FCFCORE.fsc_country_dim E
,FCFCORE.fsc_transaction_status_dim G
,FCFCORE.fsc_party_account_bridge H
,FCFCORE.fsc_account_event_fact I
WHERE
 I.account_key = A.account_key
 AND A.account_key = H.account_key
 AND B.party_key = H.party_key
 AND I.transaction_type_key = C.transaction_type_key
 AND I.transaction_status_key = G.transaction_status_key
 AND I.country_key = E.country_key
 AND I.branch_key = D.branch_key
 AND H.role_desc = 'PRIMARY OWNER'
 AND H.change_current_ind = 'Y'
)aa
LEFT JOIN
FCFCORE.fsc_account_analysis_dim x
ON
aa.account_number=x.account_number;
;

CREATE VIEW FCFBU1.DormantAccountTransactionView
(
account_number
,last_dorm_date
,currency_amount
,date_key
,transaction_key
)
AS
locking row for access 
SELECT
 c.account_number
 ,a1.last_dorm_date
 ,d.currency_amount
 ,d.date_key
 ,d.transaction_key
FROM
 FCFCORE.fsc_account_dim c
 ,FCFCORE.fsc_cash_flow_fact d
 ,(SELECT a.account_number
		,x.last_dorm_date
	FROM FCFCORE.fsc_account_dim a
	,(SELECT account_number
		,CAST(max(change_end_date) AS DATE FORMAT 'YYYY-MM-DD')
		AS last_dorm_date
		FROM FCFCORE.fsc_account_dim
		WHERE  dormant_ind='Y'
		AND change_current_ind='N'
		GROUP BY  account_number
	) x
	WHERE a.dormant_ind = 'N'
	AND a.change_current_ind='Y'
	AND a.account_number = x.account_number
UNION
	SELECT b.account_number
	,NULL AS last_dorm_date
	FROM FCFCORE.fsc_cash_flow_fact a
	,FCFCORE.fsc_account_dim b
	WHERE dormant_ind = 'Y'
	AND change_current_ind = 'Y'
)AS a1
WHERE
 c.account_key = d.account_key
 AND c.account_number = a1.account_number;
;

CREATE VIEW FCFBU1.PartyProfileView
(party_number
,aggregate_Assets_Amount
,Total_Wire_Credits_Amount
,Total_Wire_Debits_Amount
,month_key) 
AS
locking row for access 
SELECT
 party_number
,aggregate_Assets_Amount
,Total_Wire_Credits_Amount
,Total_Wire_Debits_Amount
,month_key
FROM 
	FCFCORE.fsc_party_profile_fact;

CREATE VIEW FCFBU1.PartyTaxIdView
(STREET_STATE_CODE
,PARTY_TAX_ID
,PARTY_NUMBER
)
AS
locking row for access 
SELECT
	Fsc_party_dim.street_state_code
	,Fsc_party_dim.party_tax_id
	,Fsc_party_dim.party_number
FROM
	FCFCORE.Fsc_party_dim Fsc_party_dim
	WHERE party_tax_id IS NOT NULL;

CREATE VIEW FCFBU1.PartyTransactionView
(account_number
	,account_type_desc
	,annual_income_amount
	,country_code_3
	,currency_amount
	,currency_based_account_ind
	,currency_code
	,customer_since_date
	,date_key
	,last_cash_trans_rpt_date
	,last_susp_actv_rpt_date
	,mechanism_desc
	,party_number
	,politically_exposed_person_ind
	,primary_medium_desc
	,secondary_medium_desc
	,status_desc
	,transaction_cdi_code
	,transaction_key

) 
AS
locking row for access 
SELECT
	A.account_number
	,A.account_type_desc
	,B.annual_income_amount
	,E.country_code_3
	,I.currency_amount
	,A.currency_based_account_ind
	,F.currency_code
	,B.customer_since_date
	,I.date_key
	,B.last_cash_trans_rpt_date
	,B.last_susp_actv_rpt_date
	,C.mechanism_desc
	,B.party_number
	,B.politically_exposed_person_ind
	,C.primary_medium_desc
	,C.secondary_medium_desc
	,G.status_desc
	,C.transaction_cdi_code
	,I.transaction_key
FROM
	FCFCORE.fsc_account_dim A,
	FCFCORE.fsc_party_dim B,
	FCFCORE.fsc_transaction_type_dim C,
	FCFCORE.fsc_branch_dim D,
	FCFCORE.fsc_country_dim E,
	FCFCORE.fsc_currency_dim F,
	FCFCORE.fsc_transaction_status_dim G,
	FCFCORE.fsc_party_account_bridge H,
	FCFCORE.fsc_cash_flow_fact I
WHERE
	I.account_key = A.account_key
	AND A.account_key = H.account_key
	AND B.party_key = H.party_key
	AND I.transaction_type_key = C.transaction_type_key
	AND I.transaction_status_key = G.transaction_status_key
	AND I.country_key = E.country_key
	AND I.branch_key = D.branch_key
	AND I.transaction_currency_key = F.currency_key
	AND H.role_desc = 'PRIMARY OWNER'
	AND H.change_current_ind = 'Y'
UNION ALL
SELECT
	A.account_number
	,A.account_type_desc
	,B.annual_income_amount
	,E.country_code_3
	,0 AS currency_amount
	,A.currency_based_account_ind
	,'' AS currency_code
	,B.customer_since_date
	,I.date_key
	,B.last_cash_trans_rpt_date
	,B.last_susp_actv_rpt_date
	,C.mechanism_desc
	,B.party_number
	,B.politically_exposed_person_ind
	,C.primary_medium_desc
	,C.secondary_medium_desc
	,G.status_desc
	,C.transaction_cdi_code
	,I.transaction_key
FROM
	FCFCORE.fsc_account_dim A,
	FCFCORE.fsc_party_dim B,
	FCFCORE.fsc_transaction_type_dim C,
	FCFCORE.fsc_branch_dim D,
	FCFCORE.fsc_country_dim E,
	FCFCORE.fsc_transaction_status_dim G,
	FCFCORE.fsc_party_account_bridge H,
	FCFCORE.fsc_account_event_fact I
WHERE
	I.account_key = A.account_key
	AND A.account_key = H.account_key
	AND B.party_key = H.party_key
	AND I.transaction_type_key = C.transaction_type_key
	AND I.transaction_status_key = G.transaction_status_key
	AND I.country_key = E.country_key
	AND I.branch_key = D.branch_key
	AND H.role_desc = 'PRIMARY OWNER'
	AND H.change_current_ind = 'Y';

CREATE VIEW FCFBU1.fsk_account_list_view (
   list_id,
   list_element_value )
AS
locking row for access 
SELECT element.list_id,element.list_element_value
FROM FCFKC.FSK_LIST list
JOIN FCFKC.FSK_LIST_ELEMENT element ON list.list_id = element.list_id
WHERE list.validation_type_code = 'ACC'
AND list.logical_delete_ind = 'N'
AND element.logical_delete_ind = 'N';

CREATE VIEW FCFBU1.fsk_party_list_view (
   list_id,
   list_element_value )
AS
locking row for access 
SELECT element.list_id,element.list_element_value
FROM FCFKC.FSK_LIST list
JOIN FCFKC.FSK_LIST_ELEMENT element ON list.list_id = element.list_id
WHERE list.validation_type_code = 'PTY'
AND list.logical_delete_ind = 'N'
AND element.logical_delete_ind = 'N';

CREATE  VIEW FCFBU1.FSK_SCENARIO_ALERT_COLUMN AS SELECT scenario_id, column_name, column_usage_code FROM 
FCFKC.FSK_SCENARIO_ALERT_COLUMN;

CREATE  VIEW FCFBU1.FSK_ENHANCED_ALERT AS SELECT * FROM FCFKC.FSK_ENHANCED_ALERT;

CREATE  VIEW FCFBU1.FSK_ENHANCED_ALERT_RISK_FACTOR AS SELECT * FROM 
FCFKC.FSK_ENHANCED_ALERT_RISK_FACTOR;

CREATE  VIEW FCFBU1.FSK_INT_XFER AS SELECT * FROM FCFKC.FSK_INT_XFER;

CREATE  VIEW FCFBU1.FSK_CASE_TRANSACTION AS SELECT * FROM FCFKC.FSK_CASE_TRANSACTION;

CREATE  VIEW FCFBU1.FSK_CASE_ENTITY_TRANSACTION AS SELECT * FROM FCFKC.FSK_CASE_ENTITY_TRANSACTION;



