%MACRO VLDT_TRANSMITTER;

/**** SKIP *****/

/*T01: Transmitter name is blank.*/

/**** SKIP *****/

/*T02: Transmitter address is blank.*/

/**** SKIP *****/

/*T03: Transmitter city is blank.*/

/**** SKIP *****/

/*T04: Transmitter state is blank.*/

/**** SKIP *****/

/*T05: Transmitter zip Code or foreign postal code is blank.*/

/**** SKIP *****/

/*T06: Transmitter telephone number is blank.*/

/**** SKIP *****/

/*T07: Transmitter contact name is blank.*/

/**** SKIP *****/

/*T08: Transmitter TIN is blank.*/

/**** SKIP *****/

/*T09: Coverage beginning date is blank or invalid.*/

/**** SKIP *****/

/*T10: Coverage ending date is blank or invalid.*/

/**** SKIP *****/

/*T12: The Transmitter Control Code is blank.*/
%mend;


%MACRO VLDT_INSTITUTION;

/*S224: Financial institution type is blank.*/
error_code="S224";
target_field_name="INSTITUTION_TYPE_CODE";
if INSTITUTION_TYPE_CODE=""  then output;

/*S225: Financial institution type contains an invalid code.*/
error_code="S225";
target_field_name="INSTITUTION_TYPE_CODE";
if (index("ABCDEFGZ",strip(INSTITUTION_TYPE_CODE))=0) and (INSTITUTION_TYPE_CODE ne ' ') then output;

/*S226: Financial institution type other description is blank.*/
error_code="S226";
target_field_name="INSTITUTION_TYPE_OTHER";
if (INSTITUTION_TYPE_OTHER = ' ') and (index(INSTITUTION_TYPE_CODE,"Z") > 0) then output;

/*S227: Financial institution primary federal regulator is blank.*/
error_code="S227";
target_field_name="INSTITUTION_PRIM_FED_REG_CODE";
if INSTITUTION_PRIM_FED_REG_CODE=""  then output;

/*S228: Financial institution primary federal regulator contains an invalid code.*/
error_code="S228";
target_field_name="INSTITUTION_PRIM_FED_REG_CODE";
if (index("ABCDEFGHZ",strip(INSTITUTION_PRIM_FED_REG_CODE))=0) and (INSTITUTION_PRIM_FED_REG_CODE ne ' ') then output;

/*S229: Gaming institution type contains an invalid code.*/
error_code="S229";
target_field_name="INSTITUTION_GAMING_TYPE_CODE";
if (index("ABCZ",strip(INSTITUTION_GAMING_TYPE_CODE))=0) and (INSTITUTION_GAMING_TYPE_CODE ne ' ') then output;

/*S230: Gaming institution type other description is blank.*/
error_code="S230";
target_field_name="INSTITUTION_GAMING_TYPE_OTHER";
if (INSTITUTION_GAMING_TYPE_OTHER = ' ') and (index(INSTITUTION_GAMING_TYPE_CODE,"Z") > 0) then output;

/*S231: Securities/Futures institution type contains an invalid code.*/
error_code="S231";
target_field_name="INSTITUTION_SF_TYPE_CODE";
if (compress(INSTITUTION_SF_TYPE_CODE,'ABCDEFGHIJKLZ') ne ' ') and (INSTITUTION_SF_TYPE_CODE ne ' ') then output;

/*S232: Securities/Futures institution type other description is blank.*/
error_code="S232";
target_field_name="INSTITUTION_SF_TYPE_OTHER";
if (INSTITUTION_SF_TYPE_OTHER = ' ') and (index(INSTITUTION_SF_TYPE_CODE,"Z") > 0) then output;

/*S233: Financial institution identification type contains an invalid code.*/
error_code="S233";
target_field_name="INSTITUTION_ID_TYPE_CODE";
if (index("ABCDEFG",strip(INSTITUTION_ID_TYPE_CODE))=0) and (INSTITUTION_ID_TYPE_CODE ne ' ') then output;

/*S234: Financial institution identification number is blank.*/
error_code="S234";
target_field_name="INSTITUTION_ID";
if (INSTITUTION_ID="") and (INSTITUTION_ID_TYPE_CODE ne '') then output;

/*S235: The financial institution�s role in the transaction contains an invalid code.*/
error_code="S235";
target_field_name="INSTITUTION_REPORT_ROLE_CODE";
if (index("ABC",strip(INSTITUTION_REPORT_ROLE_CODE))=0) and (INSTITUTION_REPORT_ROLE_CODE ne ' ') then output;

/*S236: Financial institution legal name is blank.*/
error_code="S236";
target_field_name="INSTITUTION_LEGAL_NAME";
if (INSTITUTION_LEGAL_NAME = ' ') and (INSTITUTION_LEGAL_NAME_UNK_FLG ne 'X') then output;

/*S237: Financial institution TIN is blank.*/
error_code="S237";
target_field_name="INSTITUTION_TAX_ID";
if (INSTITUTION_TAX_ID="") and (INSTITUTION_TIN_UNK_FLG ne 'X') then output;

/*S238: Financial institution TIN is an invalid number string such as all zeros, all nines, 123456789, or a U.S. TIN and not nine digits.*/
error_code="S238";
target_field_name="INSTITUTION_TAX_ID";
if (length(INSTITUTION_TAX_ID) ne 9 or INSTITUTION_TAX_ID='123456789' or  INSTITUTION_TAX_ID='000000000' or  INSTITUTION_TAX_ID='999999999') and (INSTITUTION_TAX_ID ne ' ') then output;

/*S239: Financial institution TIN type is blank.*/
error_code="S239";
target_field_name="INSTITUTION_TAX_ID_TYPE";
if (INSTITUTION_TAX_ID_TYPE="") and (INSTITUTION_TIN_UNK_FLG ne 'X') then output;

/*S240: Financial institution TIN type contains an invalid code.*/
error_code="S240";
target_field_name="INSTITUTION_TAX_ID_TYPE";
if (index("ABC",strip(INSTITUTION_TAX_ID_TYPE))=0) and (INSTITUTION_TAX_ID_TYPE ne ' ') then output;

/*S241: Financial institution street address is blank.*/
error_code="S241";
target_field_name="INSTITUTION_ADDRESS";
if (INSTITUTION_ADDRESS = ' ') and (INSTITUTION_ADDRESS_UNK_FLG ne 'X') then output;

/*S242: Financial institution city is blank.*/
error_code="S242";
target_field_name="INSTITUTION_CITY_NAME";
if (INSTITUTION_CITY_NAME="") and (INSTITUTION_CITY_UNKN_FLG ne 'X') then output;

/*S243: Financial institution state is not a valid state code.*/
error_code="S243";
target_field_name="INSTITUTION_STATE_CODE";
if (put(strip(INSTITUTION_COUNTRY_CODE)||'_'||strip(INSTITUTION_STATE_CODE),$RT_STATE_PROVINCE.) ne 'VALID') and (INSTITUTION_STATE_CODE ne ' ' and (INSTITUTION_COUNTRY_CODE in ('CA' 'MX' 'US'))) then output;

/*S244: Financial institution state is blank and financial institution country is equal to CA, MX, or US.*/
error_code="S244";
target_field_name="INSTITUTION_STATE_CODE";
if (INSTITUTION_STATE_CODE="") and INSTITUTION_COUNTRY_CODE in ('CA' 'MX' 'US') then output;

/*S245: Financial institution ZIP Code or foreign postal code is blank.*/
error_code="S245";
target_field_name="INSTITUTION_ZIP_CODE";
if (INSTITUTION_ZIP_CODE="") and (INSTITUTION_COUNTRY_CODE in ('CA' 'MX' 'US'))  then output;

/*S246: Financial institution ZIP Code is a nine digit code ending in four zeros/nines and financial institution country is equal to US.*/
error_code="S246";
target_field_name="INSTITUTION_ZIP_CODE";
if (((length(INSTITUTION_ZIP_CODE) ne 5 and length(INSTITUTION_ZIP_CODE) ne 9)  or notdigit(strip(INSTITUTION_ZIP_CODE)) > 0)) and (INSTITUTION_COUNTRY_CODE ='US' and INSTITUTION_ZIP_CODE > ' ') then output;

/*S247: Financial institution ZIP Code is not equal to five or nine digits or contains non-numeric values, and financial institution country is equal to US.*/
error_code="S247";
target_field_name="INSTITUTION_ZIP_CODE";
if (((length(INSTITUTION_ZIP_CODE) ne 5 and length(INSTITUTION_ZIP_CODE) ne 9)  or notdigit(strip(INSTITUTION_ZIP_CODE)) > 0)) and (INSTITUTION_COUNTRY_CODE ='US' and INSTITUTION_ZIP_CODE > ' ') then output;

/*S248: Financial institution country is blank.*/
error_code="S248";
target_field_name="INSTITUTION_COUNTRY_CODE";
if (INSTITUTION_COUNTRY_CODE="")  and (INSTITUTION_COUNTRY_UNK_FLG ne 'X') then output;

/*S249: Financial institution country is not a valid country code.*/
error_code="S249";
target_field_name="INSTITUTION_COUNTRY_CODE";
if (put(INSTITUTION_COUNTRY_CODE,$RT_COUNTRY.) ne 'VALID') and (INSTITUTION_COUNTRY_CODE ne '') then output;

/*S250: The loss reported for the financial institution contains non-numeric values or is in an invalid format.*/
error_code="S250";
target_field_name="INSTITUTION_REPORT_LOSS_AMOUNT";
if (INSTITUTION_REPORT_LOSS_AMOUNT > 0 and index(put(INSTITUTION_REPORT_LOSS_AMOUNT,Z15.) ,'E') > 0) and (INSTITUTION_REPORT_LOSS_AMOUNT >  .) then output;
%mend;

%MACRO VLDT_BRANCH;

/*C201: Financial institution primary federal regulator is blank.*/
error_code="C201";
target_field_name="BRANCH_PRIM_FED_REG_CODE";
if BRANCH_PRIM_FED_REG_CODE=""  then output;

/*C202: Financial institution primary federal regulator contains an invalid code.*/
error_code="C202";
target_field_name="BRANCH_PRIM_FED_REG_CODE";
if (index("ABCDEFG",strip(BRANCH_PRIM_FED_REG_CODE))=0) and (BRANCH_PRIM_FED_REG_CODE ne ' ') then output;

/*C203: Financial institution legal name is blank.*/
error_code="C203";
target_field_name="BRANCH_NAME";
if BRANCH_NAME=""  then output;

/*C204: Financial institution EIN is blank.*/
error_code="C204";
target_field_name="BRANCH_TAX_ID";
if BRANCH_TAX_ID=""  then output;

/*C205: Financial institution EIN is an invalid number string such as all zeros, all nines, or 123456789, or contains non-numeric values.*/
error_code="C205";
target_field_name="BRANCH_TAX_ID";
if (length(BRANCH_TAX_ID) ne 9 or BRANCH_TAX_ID='123456789' or  BRANCH_TAX_ID='000000000' or  BRANCH_TAX_ID='999999999') and (BRANCH_TAX_ID ne ' ') then output;

/*C206: Financial institution street address is blank.*/
error_code="C206";
target_field_name="BRANCH_ADDRESS";
if BRANCH_ADDRESS=""  then output;

/*C207: Financial institution city is blank.*/
error_code="C207";
target_field_name="BRANCH_CITY_NAME";
if BRANCH_CITY_NAME=""  then output;

/*C208: Financial institution state is not a valid state code.*/
error_code="C208";
target_field_name="BRANCH_STATE_CODE";
if (put('US_'||strip(BRANCH_STATE_CODE),$RT_STATE_PROVINCE.) ne 'VALID') and (BRANCH_STATE_CODE ne ' ') then output;

/*C209: Financial institution state is blank.*/
error_code="C209";
target_field_name="BRANCH_STATE_CODE";
if BRANCH_STATE_CODE=""  then output;

/*C210: Financial institution ZIP Code is blank.*/
error_code="C210";
target_field_name="BRANCH_ZIP_CODE";
if BRANCH_ZIP_CODE=""  then output;

/*C211: Financial institution ZIP Code is a nine digit code ending in four zeros/nines.*/
error_code="C211";
target_field_name="BRANCH_ZIP_CODE";
if (substrn(BRANCH_ZIP_CODE,6,4)= '0000' or substrn(BRANCH_ZIP_CODE,6,4)= '9999') and (BRANCH_ZIP_CODE ne ' ' and length(BRANCH_ZIP_CODE)=9) then output;

/*C212: Financial institution ZIP Code is not equal to five or nine digits, or contains non-numeric values.*/
error_code="C212";
target_field_name="BRANCH_ZIP_CODE";
if (((length(BRANCH_ZIP_CODE) ne 5 and length(BRANCH_ZIP_CODE) ne 9)  or notdigit(strip(BRANCH_ZIP_CODE)) > 0))  then output;

/*C213: Financial institution type is blank.*/
error_code="C213";
target_field_name="BRANCH_TYPE_CTR_CODE";
if BRANCH_TYPE_CTR_CODE=""  then output;

/*C214: Financial institution type contains an invalid code.*/
error_code="C214";
target_field_name="BRANCH_TYPE_CTR_CODE";
if (index("ABCDZ",strip(BRANCH_TYPE_CTR_CODE))=0) and (BRANCH_TYPE_CTR_CODE ne ' ') then output;

/*C215: Financial institution type other description is blank.*/
error_code="C215";
target_field_name="BRANCH_TYPE_CTR_OTHER";
if (BRANCH_TYPE_CTR_OTHER = ' ') and (index(BRANCH_TYPE_CTR_CODE,"Z") > 0) then output;

/*C216: Gaming institution type is blank.*/
error_code="C216";
target_field_name="BRANCH_GAMING_TYPE_CODE";
if (BRANCH_GAMING_TYPE_CODE = ' ') and (BRANCH_TYPE_CTR_CODE = 'A') then output;

/*C217: Gaming institution type contains an invalid code.*/
error_code="C217";
target_field_name="BRANCH_GAMING_TYPE_CODE";
if (index('ABCZ',strip(BRANCH_GAMING_TYPE_CODE))=0) and (BRANCH_GAMING_TYPE_CODE ne ' ') and (BRANCH_TYPE_CTR_CODE = 'A') then output;

/*C218: Gaming institution type other description is blank.*/
error_code="C218";
target_field_name="BRANCH_GAMING_TYPE_OTHER";
if (BRANCH_GAMING_TYPE_OTHER = ' ') and (index(BRANCH_GAMING_TYPE_CODE,"Z") > 0) then output;

/*C219: Financial institution identification type contains an invalid code.*/
error_code="C219";
target_field_name="BRANCH_ID_TYPE_CODE";
if (index('ABCDE',strip(BRANCH_ID_TYPE_CODE))=0) and (BRANCH_ID_TYPE_CODE ne ' ') then output;

/*C220: Financial institution identification number is blank when one of boxes 39a-39e has been checked.*/
error_code="C220";
target_field_name="BRANCH_ID";
if (BRANCH_ID = ' ') and (BRANCH_ID_TYPE_CODE ne  '') then output;
%mend;
