/* MAINDOC
+------------------------------------------------------------------------------+
| NAME:    rc_fincen_config_update_6.sas
| PRODUCT: SAS Regulatory Console
| SYSTEM:  Windows, Unix
| DESC:    Program to update institution data for FinCEN reporting in hotfix 11.
+------------------------------------------------------------------------------+
| USAGE:   Run this program using UTF-8 SAS.
+-------------+----------------------------------------------------------------+
| COMMENTS    | This program is executed by the regulatory console deployment scripts.
+-------------+----------+----------+------------------------------------------+
MAINDOCEND */

/*-------------------------------------------------------------------
 * Copyright (c) 2020 by SAS Institute Inc., Cary, NC 27513 USA
 *  ---All Rights Reserved.
 *-------------------------------------------------------------------*/

%macro rc_updt_fincen_rssd;

    /* Add institution_rssd_id for DOEPX  */
   
    proc contents data=RC_CFG.FINCEN_INSTITUTION(%fcf_get_ds_opts(lib_name=RC_CFG, ds_name=FINCEN_INSTITUTION))
                   out=rc_cfg_tab_cols(keep=name)
                  noprint;
     run;
    %let upgraded=N;
	proc sql noprint;
	     select 'Y' into :upgraded
		 from rc_cfg_tab_cols
         where upcase(name) eq 'INSTITUTION_RSSD_ID'
         ;		 
     quit;
    
 
    %if &upgraded=N %then
    %do;
       /* Upgrade table structure of RC_CFG.FINCEN_INSTITUTION */
       proc sql;
       alter table rc_cfg.fincen_institution(%fcf_get_ds_opts(lib_name=rc_cfg, ds_name=fincen_institution))
       add INSTITUTION_RSSD_ID char(20) label='RSSD ID'
       ; 
       quit;
    %end;

%mend;
 
%rc_updt_fincen_rssd;
 
proc datasets lib=work nowarn nolist;
     delete rc_cfg_tab_cols;
quit; 
