%MACRO VLDT_DOEP_1A;

/**** SKIP *****/

/*T01: Transmitter name is blank.*/

/**** SKIP *****/

/*T02: Transmitter street address is blank.*/

/**** SKIP *****/

/*T03: Transmitter city is blank*/

/**** SKIP *****/

/*T04: Transmitter state is blank.*/

/**** SKIP *****/

/*T05: Transmitter ZIP Code is blank.*/

/**** SKIP *****/

/*T06: Transmitter telephone number is blank.*/

/**** SKIP *****/

/*T07: Transmitter contact name is blank.*/

/**** SKIP *****/

/*T08: Transmitter TIN is blank.*/

/**** SKIP *****/

/*T09: Coverage beginning date is blank or invalid.*/

/**** SKIP *****/

/*T10: Coverage ending date is blank or invalid.*/

/**** SKIP *****/

/*T12: The Transmitter Control Code is blank.*/

/**** SKIP *****/

/*T13: Transmitter country is blank.*/
%mend;


%MACRO VLDT_DOEP_2A;

/**** SKIP *****/

/*D01: Bank name is blank.*/

/**** SKIP *****/

/*D02: EIN is blank.*/

/**** SKIP *****/

/*D03: EIN is an invalid number string such as all zeros, all nines, 123456789, or not equal to nine numbers.*/

/**** SKIP *****/

/*D04: Address is blank.*/

/**** SKIP *****/

/*D05: City is blank.*/

/**** SKIP *****/

/*D06: State is blank.*/

/**** SKIP *****/

/*D07: State is not a valid state code.*/

/**** SKIP *****/

/*D08: ZIP Code is blank.*/

/**** SKIP *****/

/*D09: ZIP Code is a nine digit code ending in four zeros/nines.*/

/**** SKIP *****/

/*D10: ZIP Code is not equal to five or nine digits or contains non- numeric values.*/

/**** SKIP *****/

/*D11: Primary federal regulator is blank.*/

/**** SKIP *****/

/*D12: Primary federal regulator contains an invalid code.*/

/**** SKIP *****/

/*D13: Affiliated banks indicator contains an invalid code.*/
%mend;


%MACRO VLDT_DOEP_2B;

/*D01: Bank name is blank.*/
error_code="D01";
target_field_name="INSTITUTION_LEGAL_NAME";
if INSTITUTION_LEGAL_NAME=""  then output;

/*D02: EIN is blank.*/
error_code="D02";
target_field_name="INSTITUTION_TAX_ID";
if INSTITUTION_TAX_ID=""  then output;

/*D03: EIN is an invalid number string such as all zeros, all nines, 123456789, or not equal to nine numbers.*/
error_code="D03";
target_field_name="INSTITUTION_TAX_ID";

/*D04: Address is blank.*/
error_code="D04";
target_field_name="INSTITUTION_ADDRESS";
if INSTITUTION_ADDRESS=""  then output;

/*D05: City is blank.*/
error_code="D05";
target_field_name="INSTITUTION_CITY_NAME";
if INSTITUTION_CITY_NAME=""  then output;

/*D06: State is blank.*/
error_code="D06";
target_field_name="INSTITUTION_STATE_CODE";
if INSTITUTION_STATE_CODE=""  then output;

/*D07: State is not a valid state code.*/
error_code="D07";
target_field_name="INSTITUTION_STATE_CODE";
if (put('US_'||strip(INSTITUTION_STATE_CODE),$RT_STATE_PROVINCE.) ne 'VALID') and (INSTITUTION_STATE_CODE ne ' ') then output;

/*D08: ZIP Code is blank.*/
error_code="D08";
target_field_name="INSTITUTION_ZIP_CODE";
if INSTITUTION_ZIP_CODE=""  then output;

/*D09: ZIP Code is a nine digit code ending in four zeros/nines.*/
error_code="D09";
target_field_name="INSTITUTION_ZIP_CODE";
if (((length(INSTITUTION_ZIP_CODE) ne 5 and length(INSTITUTION_ZIP_CODE) ne 9)  or notdigit(strip(INSTITUTION_ZIP_CODE)) > 0))  then output;

/*D10: ZIP Code is not equal to five or nine digits or contains non- numeric values.*/
error_code="D10";
target_field_name="INSTITUTION_ZIP_CODE";
if (( length(INSTITUTION_ZIP_CODE) ne 5 and  length(INSTITUTION_ZIP_CODE) ne 9) or  (INSTITUTION_ZIP_CODE ne compress(INSTITUTION_ZIP_CODE,'0123456789','k'))) and (INSTITUTION_ZIP_CODE ne ' ') then output;

/*D11: Primary federal regulator is blank.*/
error_code="D11";
target_field_name="INSTITUTION_PRIM_FED_REG_CODE";
if INSTITUTION_PRIM_FED_REG_CODE=""  then output;

/*D12: Primary federal regulator contains an invalid code.*/
error_code="D12";
target_field_name="INSTITUTION_PRIM_FED_REG_CODE";
%mend;


%MACRO VLDT_DOEP_3A;

/*D04: Address is blank.*/
error_code="D04";
target_field_name="ADDRESS";
if ADDRESS=""  then output;

/*D05: City is blank.*/
error_code="D05";
target_field_name="CITY_NM";
if CITY_NM=""  then output;

/*D06: State is blank.*/
error_code="D06";
target_field_name="STATE_CODE";
if STATE_CODE=""  then output;

/*D07: State is not a valid state code.*/
error_code="D07";
target_field_name="STATE_CODE";
if (put('US_'||strip(STATE_CODE),$RT_STATE_PROVINCE.) ne 'VALID') and (STATE_CODE ne ' ') then output;

/*D08: ZIP Code is blank.*/
error_code="D08";
target_field_name="POSTAL_CODE";
if POSTAL_CODE=""  then output;

/*D09: ZIP Code is a nine digit code ending in four zeros/nines.*/
error_code="D09";
target_field_name="POSTAL_CODE";

/*D10: ZIP Code is not equal to five or nine digits or contains non- numeric values.*/
error_code="D10";
target_field_name="POSTAL_CODE";
if (( length(POSTAL_CODE) ne 5 and  length(POSTAL_CODE) ne 9) or  (POSTAL_CODE ne compress(POSTAL_CODE,'0123456789','k'))) and (POSTAL_CODE ne ' ') then output;

/*D14: Filing type is blank.*/
error_code="D14";
target_field_name="TYPE_FILING_CODE";
if TYPE_FILING_CODE=""  then output;

/*D15: Filing type contains an invalid code.*/
error_code="D15";
target_field_name="TYPE_FILING_CODE";
if (index("ABC",strip(TYPE_FILING_CODE))=0) and (TYPE_FILING_CODE ne ' ') then output;

/*D16: Effective date of exemption is blank.*/
error_code="D16";
target_field_name="EFFECTIVE_DATE";
if EFFECTIVE_DATE=.  then output;

/*D17: Effective date of exemption is not a numeric 8-position entry in MMDDCCYY format where MM = month, DD = day, CC = Century, and YY = year.*/
error_code="D17";
target_field_name="EFFECTIVE_DATE";
if (EFFECTIVE_DATE < mdy(1,1,1900) or  EFFECTIVE_DATE > today()) and (EFFECTIVE_DATE >  .) then output;

/*D18: Effective date of exemption is not less than or equal to the date of signature.*/
error_code="D18";
target_field_name="EFFECTIVE_DATE";
if (EFFECTIVE_DATE > today()) and (EFFECTIVE_DATE > .) then output;

/*D19: Effective date of exemption is not greater than or equal to January 1, 1900.*/
error_code="D19";
target_field_name="EFFECTIVE_DATE";
if (EFFECTIVE_DATE < mdy(1,1,1900)) and (EFFECTIVE_DATE > .) then output;

/*D20: Exempt person last/legal name is blank.*/
error_code="D20";
target_field_name="LAST_NM";
if LAST_NM=""  then output;

/*D21: Exempt person is entity contains an invalid code.*/
error_code="D21";
target_field_name="ENTITY_FLG";

/*D22: Exempt person first name is blank and the entity box is not checked.*/
error_code="D22";
target_field_name="FIRST_NM";
if (FIRST_NM = '') and (ENTITY_FLG='') then output;

/*D23: TIN is blank.*/
error_code="D23";
target_field_name="TAX_ID";
if TAX_ID=""  then output;

/*D24: TIN is an invalid number string such as all zeros, all nines, 123456789, or not equal to nine numbers.*/
error_code="D24";
target_field_name="TAX_ID";
if (length(TAX_ID) ne 9 or TAX_ID='123456789' or TAX_ID='000000000' or  TAX_ID='999999999') and (TAX_ID ne ' ') then output;

/*D25: TIN type is blank.*/
error_code="D25";
target_field_name="TAX_ID_TYPE_CODE";
if TAX_ID_TYPE_CODE=""  then output;

/*D26: TIN type contains an invalid code.*/
error_code="D26";
target_field_name="TAX_ID_TYPE_CODE";
if (index("ABC",strip(TAX_ID_TYPE_CODE))=0) and (TAX_ID_TYPE_CODE ne ' ') then output;

/*D27: E-mail address is in an invalid format.*/
error_code="D27";
target_field_name="EMAIL_ADDRESS";
if (prxmatch("/[^@]+@[^@]+\.[^@]+/", EMAIL_ADDRESS) = 0) and (EMAIL_ADDRESS ne ' ') then output;

/*D28: Exempt person phone number contains non-numeric values, is in an invalid format, or is not equal to ten numbers.*/
error_code="D28";
target_field_name="PHONE_NO";
if ((PHONE_NO ne compress(PHONE_NO,'0123456789','k'))) and (PHONE_NO > ' ') then output;

/*D29: Type of exempt person contains an invalid code.*/
error_code="D29";
target_field_name="EXEMPT_TYPE_CODE";
if (index("ABCD",strip(EXEMPT_TYPE_CODE))=0) and (EXEMPT_TYPE_CODE ne ' ') then output;

/*D30: Type of exempt person is blank.*/
error_code="D30";
target_field_name="EXEMPT_TYPE_CODE";
if EXEMPT_TYPE_CODE=""  then output;

/*D31: Authorizer phone number contains non-numeric values, is in an invalid format, or is not equal to ten numbers.*/
error_code="D31";
target_field_name="CONTACT_PHONE_NUMBER";
if (CONTACT_PHONE_NUMBER ne compress(CONTACT_PHONE_NUMBER,'0123456789','k')) and (CONTACT_PHONE_NUMBER ne ' ') then output;

/*D32: Date of signature is not a numeric 8-position entry in MMDDCCYY format where MM = month, DD = day, CC = Century, and YY = year.*/
error_code="D32";
target_field_name="FILED_DATE";
if (FILED_DATE < mdy(1,1,1900) or  FILED_DATE > today()) and (FILED_DATE >  .) then output;

/**** SKIP *****/

/*D33: Date of signature is greater than the current date.*/

/*D34: Prior report BSA Identifier/ Document Control Number (DCN) is blank.*/
error_code="D34";
target_field_name="PRIOR_AGENCY_REF_ID";
if (PRIOR_AGENCY_REF_ID = '') and (TYPE_FILING_CODE='B' or TYPE_FILING_CODE='C') then output;

/*D35: Prior report BSA Identifier/ Document Control Number contains non-numeric values.*/
error_code="D35";
target_field_name="PRIOR_AGENCY_REF_ID";
if (PRIOR_AGENCY_REF_ID ne compress(PRIOR_AGENCY_REF_ID,'0123456789','k')) and (PRIOR_AGENCY_REF_ID ne ' ') then output;
%mend;


%MACRO VLDT_DOEP;

 
   proc sql;
    /* F16: A required 1A record is missing from the submitted file. */
    insert into doep_error ( error_record_type, error_code, target_field_name, report_key, entity_key, entity_level_code)
    select '' ,
           'F16',
           'TRANSMITTER_TAX_ID',
           report_key, 
           . ,
           "TRANSMITTER"  
    from doep_1a
    where transmitter_tax_id=''
    ;
 
    insert into doep_error ( error_record_type, error_code, target_field_name, report_key, entity_key, entity_level_code)
    /* F11: A required 2A record is missing from the submitted file. */
    select '' ,
           'F11',
           'INSTITUTION_TAX_ID',
           report_key, 
           . ,
           "INSTITUTION"  
    from doep_2a
    where institution_tax_id=''
   ;
  

%MEND;
