%MACRO VLDT_SAR_1A;

/**** SKIP *****/

/*T01: Transmitter name is blank.*/

/**** SKIP *****/

/*T02: Transmitter address is blank.*/

/**** SKIP *****/

/*T03: Transmitter city is blank.*/

/**** SKIP *****/

/*T04: Transmitter state is blank.*/

/**** SKIP *****/

/*T05: Transmitter ZIP Code or foreign postal code is blank.*/

/**** SKIP *****/

/*T06: Transmitter telephone number is blank.*/

/**** SKIP *****/

/*T07: Transmitter contact name is blank.*/

/**** SKIP *****/

/*T08: Transmitter TIN is blank.*/

/**** SKIP *****/

/*T09: Coverage beginning date is blank or invalid.*/

/**** SKIP *****/

/*T10: Coverage ending date is blank or invalid.*/

/**** SKIP *****/

/*T12: The Transmitter Control Code is blank.*/
%mend;


%MACRO VLDT_SAR_2A;

/**** SKIP *****/

/*S201: Filing institution primary federal regulator is blank.*/

/**** SKIP *****/

/*S202: Filing institution primary federal regulator contains an invalid code.*/

/**** SKIP *****/

/*S203: Filing institution name is blank.*/

/**** SKIP *****/

/*S204: Filing institution TIN is blank.*/

/**** SKIP *****/

/*S205: Filing institution TIN is an invalid number string such as all zeros, all nines, 123456789, or a U.S. TIN and not nine digits.*/

/**** SKIP *****/

/*S206: Filing institution TIN type is blank.*/

/**** SKIP *****/

/*S207: Filing institution TIN type contains an invalid code.*/

/**** SKIP *****/

/*S208: Filing institution type is blank.*/

/**** SKIP *****/

/*S209: Filing institution type contains an invalid code.*/

/**** SKIP *****/

/*S210: Filing institution type other description is blank.*/

/**** SKIP *****/

/*S211: Filing institution type for Securities/Futures contains an invalid code.*/

/**** SKIP *****/

/*S212: Filing institution type for Securities/Futures other description is blank.*/

/**** SKIP *****/

/*S213: Filing institution identification type contains an invalid code.*/

/**** SKIP *****/

/*S214: Filing institution identification number is blank.*/

/**** SKIP *****/

/*S215: Filing institution street address is blank.*/

/**** SKIP *****/

/*S216: Filing institution city is blank.*/

/**** SKIP *****/

/*S217: Filing institution state is not a valid state code and filing institution country is equal to CA, MX, or US.*/

/**** SKIP *****/

/*S218: Filing institution state is blank and the filing institution country is equal to CA, MX, or US.*/

/**** SKIP *****/

/*S219: Filing institution ZIP Code or foreign postal code is blank.*/

/**** SKIP *****/

/*S220: Filing institution ZIP Code is a nine digit code ending in four zeros/nines and the filing institution country is equal to US.*/

/**** SKIP *****/

/*S221: Filing institution ZIP Code is not equal to five or nine digits or contains non-numeric values and the filing institution country is equal to US.*/

/**** SKIP *****/

/*S222: Filing institution country is blank.*/

/**** SKIP *****/

/*S223: Filing institution country is not a valid country code.*/
%mend;


%MACRO VLDT_SAR_2B;

/*S224: Financial institution type is blank.*/
error_code="S224";
target_field_name="INSTITUTION_TYPE_CODE";
if INSTITUTION_TYPE_CODE=""  then output;

/*S225: Financial institution type contains an invalid code.*/
error_code="S225";
target_field_name="INSTITUTION_TYPE_CODE";
if (index("ABCDEFGZ",strip(INSTITUTION_TYPE_CODE))=0) and (INSTITUTION_TYPE_CODE ne ' ') then output;

/*S226: Financial institution type other description is blank.*/
error_code="S226";
target_field_name="INSTITUTION_TYPE_OTHER";
if (INSTITUTION_TYPE_OTHER = ' ') and (index(INSTITUTION_TYPE_CODE,"Z") > 0) then output;

/*S227: Financial institution primary federal regulator is blank.*/
error_code="S227";
target_field_name="INSTITUTION_PRIM_FED_REG_CODE";
if INSTITUTION_PRIM_FED_REG_CODE=""  then output;

/*S228: Financial institution primary federal regulator contains an invalid code.*/
error_code="S228";
target_field_name="INSTITUTION_PRIM_FED_REG_CODE";
if (index("ABCDEFGHZ",strip(INSTITUTION_PRIM_FED_REG_CODE))=0) and (INSTITUTION_PRIM_FED_REG_CODE ne ' ') then output;

/*S229: Gaming institution type contains an invalid code.*/
error_code="S229";
target_field_name="INSTITUTION_GAMING_TYPE_CODE";
if (index("ABCZ",strip(INSTITUTION_GAMING_TYPE_CODE))=0) and (INSTITUTION_GAMING_TYPE_CODE ne ' ') then output;

/*S230: Gaming institution type other description is blank.*/
error_code="S230";
target_field_name="INSTITUTION_GAMING_TYPE_OTHER";
if (INSTITUTION_GAMING_TYPE_OTHER = ' ') and (index(INSTITUTION_GAMING_TYPE_CODE,"Z") > 0) then output;

/*S231: Securities/Futures institution type contains an invalid code.*/
error_code="S231";
target_field_name="INSTITUTION_SF_TYPE_CODE";
if (compress(INSTITUTION_SF_TYPE_CODE,'ABCDEFGHIJKLZ') ne ' ') and (INSTITUTION_SF_TYPE_CODE ne ' ') then output;

/*S232: Securities/Futures institution type other description is blank.*/
error_code="S232";
target_field_name="INSTITUTION_SF_TYPE_OTHER";
if (INSTITUTION_SF_TYPE_OTHER = ' ') and (index(INSTITUTION_SF_TYPE_CODE,"Z") > 0) then output;

/*S233: Financial institution identification type contains an invalid code.*/
error_code="S233";
target_field_name="INSTITUTION_ID_TYPE_CODE";
if (index("ABCDEFG",strip(INSTITUTION_ID_TYPE_CODE))=0) and (INSTITUTION_ID_TYPE_CODE ne ' ') then output;

/*S234: Financial institution identification number is blank.*/
error_code="S234";
target_field_name="INSTITUTION_ID";
if (INSTITUTION_ID="") and (INSTITUTION_ID_TYPE_CODE ne '') then output;

/*S235: The financial institution�s role in the transaction contains an invalid code.*/
error_code="S235";
target_field_name="INSTITUTION_REPORT_ROLE_CODE";
if (index("ABC",strip(INSTITUTION_REPORT_ROLE_CODE))=0) and (INSTITUTION_REPORT_ROLE_CODE ne ' ') then output;

/*S236: Financial institution legal name is blank.*/
error_code="S236";
target_field_name="INSTITUTION_LEGAL_NAME";
if (INSTITUTION_LEGAL_NAME = ' ') and (INSTITUTION_LEGAL_NAME_UNK_FLG ne 'X') then output;

/*S237: Financial institution TIN is blank.*/
error_code="S237";
target_field_name="INSTITUTION_TAX_ID";
if (INSTITUTION_TAX_ID="") and (INSTITUTION_TIN_UNK_FLG ne 'X') then output;

/*S238: Financial institution TIN is an invalid number string such as all zeros, all nines, 123456789, or a U.S. TIN and not nine digits.*/
error_code="S238";
target_field_name="INSTITUTION_TAX_ID";
if (length(INSTITUTION_TAX_ID) ne 9 or INSTITUTION_TAX_ID='123456789' or  INSTITUTION_TAX_ID='000000000' or  INSTITUTION_TAX_ID='999999999') and (INSTITUTION_TAX_ID ne ' ') then output;

/*S239: Financial institution TIN type is blank.*/
error_code="S239";
target_field_name="INSTITUTION_TAX_ID_TYPE";
if (INSTITUTION_TAX_ID_TYPE="") and (INSTITUTION_TIN_UNK_FLG ne 'X') then output;

/*S240: Financial institution TIN type contains an invalid code.*/
error_code="S240";
target_field_name="INSTITUTION_TAX_ID_TYPE";
if (index("ABC",strip(INSTITUTION_TAX_ID_TYPE))=0) and (INSTITUTION_TAX_ID_TYPE ne ' ') then output;

/*S241: Financial institution street address is blank.*/
error_code="S241";
target_field_name="INSTITUTION_ADDRESS";
if (INSTITUTION_ADDRESS = ' ') and (INSTITUTION_ADDRESS_UNK_FLG ne 'X') then output;

/*S242: Financial institution city is blank.*/
error_code="S242";
target_field_name="INSTITUTION_CITY_NAME";
if (INSTITUTION_CITY_NAME="") and (INSTITUTION_CITY_UNKN_FLG ne 'X') then output;

/*S243: Financial institution state is not a valid state code.*/
error_code="S243";
target_field_name="INSTITUTION_STATE_CODE";
if (put(strip(INSTITUTION_COUNTRY_CODE)||'_'||strip(INSTITUTION_STATE_CODE),$RT_STATE_PROVINCE.) ne 'VALID') and (INSTITUTION_STATE_CODE ne ' ' and (INSTITUTION_COUNTRY_CODE in ('CA' 'MX' 'US'))) then output;

/*S244: Financial institution state is blank and financial institution country is equal to CA, MX, or US.*/
error_code="S244";
target_field_name="INSTITUTION_STATE_CODE";
if (INSTITUTION_STATE_CODE="") and INSTITUTION_COUNTRY_CODE in ('CA' 'MX' 'US') then output;

/*S245: Financial institution ZIP Code or foreign postal code is blank.*/
error_code="S245";
target_field_name="INSTITUTION_ZIP_CODE";
if (INSTITUTION_ZIP_CODE="") and (INSTITUTION_COUNTRY_CODE in ('CA' 'MX' 'US'))  then output;

/*S246: Financial institution ZIP Code is a nine digit code ending in four zeros/nines and financial institution country is equal to US.*/
error_code="S246";
target_field_name="INSTITUTION_ZIP_CODE";
if (((length(INSTITUTION_ZIP_CODE) ne 5 and length(INSTITUTION_ZIP_CODE) ne 9)  or notdigit(strip(INSTITUTION_ZIP_CODE)) > 0)) and (INSTITUTION_COUNTRY_CODE ='US' and INSTITUTION_ZIP_CODE > ' ') then output;

/*S247: Financial institution ZIP Code is not equal to five or nine digits or contains non-numeric values, and financial institution country is equal to US.*/
error_code="S247";
target_field_name="INSTITUTION_ZIP_CODE";
if (((length(INSTITUTION_ZIP_CODE) ne 5 and length(INSTITUTION_ZIP_CODE) ne 9)  or notdigit(strip(INSTITUTION_ZIP_CODE)) > 0)) and (INSTITUTION_COUNTRY_CODE ='US' and INSTITUTION_ZIP_CODE > ' ') then output;

/*S248: Financial institution country is blank.*/
error_code="S248";
target_field_name="INSTITUTION_COUNTRY_CODE";
if (INSTITUTION_COUNTRY_CODE="")  and (INSTITUTION_COUNTRY_UNK_FLG ne 'X') then output;

/*S249: Financial institution country is not a valid country code.*/
error_code="S249";
target_field_name="INSTITUTION_COUNTRY_CODE";
if (put(INSTITUTION_COUNTRY_CODE,$RT_COUNTRY.) ne 'VALID') and (INSTITUTION_COUNTRY_CODE ne '') then output;

/*S250: The loss reported for the financial institution contains non-numeric values or is in an invalid format.*/
error_code="S250";
target_field_name="INSTITUTION_REPORT_LOSS_AMOUNT";
if (INSTITUTION_REPORT_LOSS_AMOUNT > 0 and index(put(INSTITUTION_REPORT_LOSS_AMOUNT,Z15.) ,'E') > 0) and (INSTITUTION_REPORT_LOSS_AMOUNT >  .) then output;
%mend;


%MACRO VLDT_SAR_2C;

/*S251: The branch/office's role in the transaction contains an invalid code.*/
error_code="S251";
target_field_name="BRANCH_REPORT_ROLE_CODE";
if (index("ABC",strip(BRANCH_REPORT_ROLE_CODE))=0) and (BRANCH_REPORT_ROLE_CODE ne ' ') then output;

/*S252: Branch/office street address is blank.*/
error_code="S252";
target_field_name="BRANCH_ADDRESS";
if BRANCH_ADDRESS=""  then output;

/*S256: Branch/office ZIP Code is a nine digit code ending in four zeros or four nines and branch/office country is US.*/
error_code="S256";
target_field_name="BRANCH_ZIP_CODE";
if (substrn(BRANCH_ZIP_CODE,6,4)= '0000' or substrn(BRANCH_ZIP_CODE,6,4)= '9999') and (BRANCH_ZIP_CODE ne ' ' and length(BRANCH_ZIP_CODE)=9) then output;

/*S257: Branch/office ZIP Code is not equal to five or nine digits, or contains non-numeric values and branch/office country is US.*/
error_code="S257";
target_field_name="BRANCH_ZIP_CODE";
if (((length(BRANCH_ZIP_CODE) ne 5 and length(BRANCH_ZIP_CODE) ne 9)  or notdigit(strip(BRANCH_ZIP_CODE)) > 0)) and (BRANCH_COUNTRY_CODE ='US' and BRANCH_ZIP_CODE > ' ') then output;

/*S258: Branch/office country is blank and Part III No Branch Activity (Item 65) is blank.*/
error_code="S258";
target_field_name="BRANCH_COUNTRY_CODE";
if BRANCH_COUNTRY_CODE=""  then output;

/*S259: Branch/office country is not a valid country code.*/
error_code="S259";
target_field_name="BRANCH_COUNTRY_CODE";
if (put(BRANCH_COUNTRY_CODE,$RT_COUNTRY.) ne 'VALID') and (BRANCH_COUNTRY_CODE ne ' ') then output;
%mend;


%MACRO VLDT_SAR_3A;

/*S301: Filing type is blank.*/
error_code="S301";
target_field_name="TYPE_FILING_CODE";
if (TYPE_FILING_CODE = '') and (CONTINUING_ACTIVITY_RPT_FLG='') then output;

/*S302: Filing type contains an invalid code.*/
error_code="S302";
target_field_name="TYPE_FILING_CODE";
if ((TYPE_FILING_CODE='A' and (CONTINUING_ACTIVITY_RPT_FLG > '' or JOINT_RPT_FLG > ''))  or (index('AB',TYPE_FILING_CODE)=0)) and (TYPE_FILING_CODE > ' ') then output;

/*S303: The amount involved in the suspicious activity report is blank.*/
error_code="S303";
target_field_name="INVOLVED_AMOUNT";
if ((INVOLVED_AMOUNT = . )) and (INVOLVED_AMOUNT_CODE = ' ') then output;

/*S304: The amount involved in the suspicious activity report contains non-numeric values or is in an invalid format.*/
error_code="S304";
target_field_name="INVOLVED_AMOUNT";
if ((. < INVOLVED_AMOUNT <= 0 ) or  (INVOLVED_AMOUNT ne . and INVOLVED_AMOUNT_CODE ne ' '))  then output;

/*S305: The amount involved in the suspicious activity report is greater than the cumulative amount reported.*/
error_code="S305";
target_field_name="INVOLVED_AMOUNT";
if (INVOLVED_AMOUNT > cumulative_amount) and (INVOLVED_AMOUNT > . and cumulative_amount > .) then output;

/*S306: The date or beginning date of the suspicious activity is blank.*/
error_code="S306";
target_field_name="SAR_BEGIN_DATE";
if SAR_BEGIN_DATE=.  then output;

/*S307: The date or beginning date of the suspicious activity is greater than the date filed.*/
error_code="S307";
target_field_name="SAR_END_DATE";
if (SAR_END_DATE > today()) and (SAR_END_DATE > .) then output;

/*S308: The date or beginning date of the suspicious activity is not greater than or equal to January 1, 1950.*/
error_code="S308";
target_field_name="SAR_END_DATE";
if (SAR_END_DATE < mdy(1,1,1950)) and (SAR_END_DATE > .) then output;

/*S309: The date or beginning date of the suspicious activity is not a numeric 8-position field in MMDDCCYY format where MM=month, DD=day, CC=century, YY=year.*/
error_code="S309";
target_field_name="SAR_BEGIN_DATE";
if (SAR_BEGIN_DATE < mdy(1,1,1900) or  SAR_BEGIN_DATE > today()) and (SAR_BEGIN_DATE >  .) then output;

/*S310: The ending date of the suspicious activity is greater than the date filed.*/
error_code="S310";
target_field_name="SAR_END_DATE";
if (SAR_END_DATE > today()) and (SAR_END_DATE > .) then output;

/*S311: The ending date of the suspicious activity is not a numeric 8-position field in MMDDCCYY format where MM=month, DD=day, CC=century, YY=year.*/
error_code="S311";
target_field_name="SAR_END_DATE";
if (SAR_END_DATE < mdy(1,1,1900) or  SAR_END_DATE > today()) and (SAR_END_DATE >  .) then output;

/*S312: The cumulative amount of the suspicious activity is blank when the report is a continuing report and an amount has been recorded in the amount involved.*/
error_code="S312";
target_field_name="CUMULATIVE_AMOUNT";
if (CUMULATIVE_AMOUNT <= 0) and (continuing_activity_rpt_flg='C') then output;

/*S313: The cumulative amount of the suspicious activity contains non-numeric values or is in an invalid format.*/
error_code="S313";
target_field_name="CUMULATIVE_AMOUNT";
if (CUMULATIVE_AMOUNT > 0 and index(put(CUMULATIVE_AMOUNT,Z15.) ,'E') > 0) and (CUMULATIVE_AMOUNT >  .) then output;

/*S315: The suspicious activity "Structuring" contains one or more invalid codes.*/
error_code="S315";
target_field_name="SAR_STRUCT_TYPE";
if (compress(SAR_STRUCT_TYPE,'ABCDEFZ') ne ' ') and (SAR_STRUCT_TYPE ne ' ') then output;

/*S316: The suspicious activity "Structuring" other description is blank.*/
error_code="S316";
target_field_name="SAR_STRUCT_OTHER";
if (SAR_STRUCT_OTHER = ' ') and (index(SAR_STRUCT,"Z") > 0) then output;

/*S317: The suspicious activity "Terrorist Financing" contains one or more invalid codes.*/
error_code="S317";
target_field_name="SAR_TERRORIST_TYPE";
if (compress(SAR_TERRORIST_TYPE,'AZ') ne ' ') and (SAR_TERRORIST_TYPE ne ' ') then output;

/*S318: The suspicious activity "Terrorist Financing" other description is blank.*/
error_code="S318";
target_field_name="SAR_TERRORIST_TYPE_OTHER";
if (SAR_TERRORIST_TYPE_OTHER = ' ') and (index(SAR_TERRORIST_TYPE,"Z") > 0) then output;

/*S319: The suspicious activity "Fraud" contains one or more invalid codes.*/
error_code="S319";
target_field_name="SAR_FRAUD_TYPE";
if (compress(SAR_FRAUD_TYPE,'ABCDEFGHIJZ') ne ' ') and (SAR_FRAUD_TYPE ne ' ') then output;

/*S320: The suspicious activity "Fraud" other description is blank.*/
error_code="S320";
target_field_name="SAR_FRAUD_TYPE_OTHER";
if (SAR_FRAUD_TYPE_OTHER = ' ') and (index(SAR_FRAUD_TYPE,"Z") > 0) then output;

/*S321: The suspicious activity "Casinos" contains one or more invalid codes.*/
error_code="S321";
target_field_name="SAR_CASINOS_TYPE";
if (compress(SAR_CASINOS_TYPE,'ABCDZ') ne ' ') and (SAR_CASINOS_TYPE ne ' ') then output;

/*S322: The suspicious activity "Casinos" other description is blank.*/
error_code="S322";
target_field_name="SAR_CASINOS_TYPE_OTHER";
if (SAR_CASINOS_TYPE_OTHER = ' ') and (index(SAR_CASINOS_TYPE,"Z") > 0) then output;

/*S323: The suspicious activity "Money laundering" contains one or more invalid codes.*/
error_code="S323";
target_field_name="SAR_ML_TYPE";
if (compress(SAR_ML_TYPE,'ABCDEFGHIJKLZ') ne ' ') and (SAR_ML_TYPE ne ' ') then output;

/*S324: The suspicious activity "Money laundering" other description is blank.*/
error_code="S324";
target_field_name="SAR_ML_TYPE_OTHER";
if (SAR_ML_TYPE_OTHER = ' ') and (index(SAR_ML_TYPE,"Z") > 0) then output;

/*S325: The suspicious activity "Identification/Documentation" contains one or more invalid codes.*/
error_code="S325";
target_field_name="SAR_ID_TYPE";
if (compress(SAR_ID_TYPE,'ABCDEZ') ne ' ') and (SAR_ID_TYPE ne ' ') then output;

/*S326: The suspicious activity "Identification/Documentation" other description is blank.*/
error_code="S326";
target_field_name="SAR_ID_TYPE_OTHER";
if (SAR_ID_TYPE_OTHER = ' ') and (index(SAR_ID_TYPE,"Z") > 0) then output;

/*S327: The suspicious activity "Other suspicious activity" contains one or more invalid codes.*/
error_code="S327";
target_field_name="SAR_OTHER_TYPE";
if (compress(SAR_OTHER_TYPE,'ABCDEFGHIJKLMNOPQRZ') ne ' ') and (SAR_OTHER_TYPE ne ' ') then output;

/*S328: The suspicious activity "Other suspicious activity" other description is blank.*/
error_code="S328";
target_field_name="SAR_OTHER_TYPE_OTHER";
if (SAR_OTHER_TYPE_OTHER = ' ') and (index(SAR_OTHER_TYPE,"Z") > 0) then output;

/*S329: The suspicious activity "Insurance" contains one or more invalid codes.*/
error_code="S329";
target_field_name="SAR_INSURANCE_TYPE";
if (compress(SAR_INSURANCE_TYPE,'ABCDEFZ') ne ' ') and (SAR_INSURANCE_TYPE ne ' ') then output;

/*S330: The suspicious activity "Insurance" other description is blank.*/
error_code="S330";
target_field_name="SAR_INSURANCE_TYPE_OTHER";
if (SAR_INSURANCE_TYPE_OTHER = ' ') and (index(SAR_INSURANCE_TYPE,"Z") > 0) then output;

/*S331: The suspicious activity "Securities/Futures/Options" contains one or more invalid codes.*/
error_code="S331";
target_field_name="SAR_SF_TYPE";
if (compress(SAR_SF_TYPE,'ABCDZ') ne ' ') and (SAR_SF_TYPE ne ' ') then output;

/*S332: The suspicious activity "Securities/Futures/Options" other description is blank.*/
error_code="S332";
target_field_name="SAR_SF_TYPE_OTHER";
if (SAR_SF_TYPE_OTHER = ' ') and (index(SAR_SF_TYPE,"Z") > 0) then output;

/*S333: The suspicious activity "Mortgage Fraud" contains one or more invalid codes.*/
error_code="S333";
target_field_name="SAR_MORTGAGE_FRAUD_TYPE";
if (compress(SAR_MORTGAGE_FRAUD_TYPE,'ABCDZ') ne ' ') and (SAR_MORTGAGE_FRAUD_TYPE ne ' ') then output;

/*S334: The suspicious activity "Mortgage Fraud" other description is blank.*/
error_code="S334";
target_field_name="SAR_MORTGAGE_FRAUD_TYPE_OTHER";
if (SAR_MORTGAGE_FRAUD_TYPE_OTHER = ' ') and (index(SAR_MORTGAGE_FRAUD_TYPE,"Z") > 0) then output;

/*S335: The suspicious activity type for items 29 through 38 is blank when at least one item must contain an alpha character entry.*/
error_code="S335";
target_field_name="SAR_STRUCT_TYPE";
if (SAR_OTHER_TYPE=' ' and  SAR_INSURANCE_TYPE=' ' and  SAR_SF_TYPE=' ' and  SAR_MORTGAGE_FRAUD_TYPE=' ' and  SAR_PRODUCT_TYPE=' ' and  SAR_INSTRUMENT_TYPE=' ') and (SAR_STRUCT_TYPE= ' ' and SAR_TERRORIST_TYPE=' ' and  SAR_FRAUD_TYPE= '' and  SAR_CASINOS_TYPE=' ' and  SAR_ML_TYPE=' ' and  SAR_ID_TYPE=' ') then output;

/*S336: The product type(s) involved in the suspicious activity contains one or more invalid codes.*/
error_code="S336";
target_field_name="SAR_PRODUCT_TYPE";
if (compress(SAR_PRODUCT_TYPE,'ABCDEFGHIJKLMNOPQRSZ') ne ' ') and (SAR_PRODUCT_TYPE ne ' ') then output;

/*S337: The product type(s) involved in the suspicious activity other description is blank.*/
error_code="S337";
target_field_name="SAR_PRODUCT_TYPE_OTHER";
if (SAR_PRODUCT_TYPE_OTHER = ' ') and (index(SAR_PRODUCT_TYPE,"Z") > 0) then output;

/*S338: The instrument type(s)/payment mechanism(s) involved in the suspicious activity contains one or more invalid codes.*/
error_code="S338";
target_field_name="SAR_INSTRUMENT_TYPE";
if (compress(SAR_INSTRUMENT_TYPE,'ABCDEFGHIZ') ne ' ') and (SAR_INSTRUMENT_TYPE ne ' ') then output;

/*S339: The instrument type(s)/payment mechanism(s) involved in the suspicious activity other description is blank.*/
error_code="S339";
target_field_name="SAR_INSTRUMENT_TYPE_OTHER";
if (SAR_INSTRUMENT_TYPE_OTHER = ' ') and (index(SAR_INSTRUMENT_TYPE,"Z") > 0) then output;

/*S340: Law Enforcement telephone number contains non-numeric values or is in an invalid format.*/
error_code="S340";
target_field_name="LE_CONTACT_TELEPHONE";
if (LE_CONTACT_TELEPHONE ne compress(LE_CONTACT_TELEPHONE,'0123456789','k')) and (LE_CONTACT_TELEPHONE ne ' ') then output;

/*S341: Law Enforcement contact date is not a numeric 8-position field in MMDDCCYY format where MM=month, DD=day, CC=century, YY=year.*/
error_code="S341";
target_field_name="LE_CONTACT_DATE";
if (LE_CONTACT_DATE < mdy(1,1,1900) or  LE_CONTACT_DATE > today()) and (LE_CONTACT_DATE >  .) then output;

/*S342: Law Enforcement contact date is greater than date filed.*/
error_code="S342";
target_field_name="LE_CONTACT_DATE";
if (LE_CONTACT_DATE > today()) and (LE_CONTACT_DATE ne ' ') then output;

/*S343: Designated contact office is blank.*/
error_code="S343";
target_field_name="SAR_CONTACT_OFFICE";
if SAR_CONTACT_OFFICE=""  then output;

/*S344: Designated contact telephone number is blank.*/
error_code="S344";
target_field_name="SAR_PHONE_NUMBER";
if SAR_PHONE_NUMBER=""  then output;

/*S345: Designated contact telephone number contains non-numeric values or is in an invalid format.*/
error_code="S345";
target_field_name="SAR_PHONE_NUMBER";
if (SAR_PHONE_NUMBER ne compress(SAR_PHONE_NUMBER,'0123456789','k')) and (SAR_PHONE_NUMBER ne ' ') then output;

/*S346: Date filed is blank.*/
error_code="S346";
target_field_name="FILED_DATE";
if FILED_DATE=.  then output;

/*S347: Date filed is not a numeric 8-position field in MMDDCCYY format where MM=month, DD=day, CC=century, YY=year.*/
error_code="S347";
target_field_name="FILED_DATE";
if (FILED_DATE < mdy(1,1,1900) or  FILED_DATE > today()) and (FILED_DATE >  .) then output;

/**** SKIP *****/

/*S348: Date filed is greater than the current date or is less than the date transmitted.*/

/*Z301: Prior report Document Control Number or BSA Identifier is blank.*/
error_code="Z301";
target_field_name="PRIOR_AGENCY_REF_ID";
if (PRIOR_AGENCY_REF_ID = '') and (TYPE_FILING_CODE='B' or CONTINUING_ACTIVITY_RPT_FLG='C') then output;
%mend;


%MACRO VLDT_SAR_4A;

/*S401: Subject "if entity" contains an invalid code.*/
error_code="S401";
target_field_name="ENTITY_FLG";
if (ENTITY_FLG ne 'A') and (ENTITY_FLG ne '') then output;

/*S402: Subject "all critical subject information unavailable" contains an invalid code.*/
error_code="S402";
target_field_name="ALL_CRITICAL_SUBJ_INFO_UNK_FLG";
if (ALL_CRITICAL_SUBJ_INFO_UNK_FLG ne 'B') and (ALL_CRITICAL_SUBJ_INFO_UNK_FLG ne '') then output;

/*S403: Subject last/legal name is blank.*/
error_code="S403";
target_field_name="LAST_NM";
if (LAST_NM = ' ') and (LAST_NM_UNK_FLG ne 'X' and ALL_CRITICAL_SUBJ_INFO_UNK_FLG = '') then output;

/*S404: Subject first name is blank.*/
error_code="S404";
target_field_name="FIRST_NM";
if (FIRST_NM = ' ') and (FIRST_NM_UNK_FLG ne 'X' and ALL_CRITICAL_SUBJ_INFO_UNK_FLG = '') then output;

/*S405: Subject gender contains an invalid code.*/
error_code="S405";
target_field_name="GENDER";
if (index("ABC",strip(GENDER))=0) and (GENDER ne ' ') then output;

/*S415: Subject TIN is blank.*/
error_code="S415";
target_field_name="TAX_ID";
if (TAX_ID = ' ') and (TAX_ID_UNK_FLG ne 'X' and ALL_CRITICAL_SUBJ_INFO_UNK_FLG = '') then output;

/*S416: Subject TIN is an invalid number string such as all zeros, all nines, 123456789, or a U.S. TIN and not nine digits.*/
error_code="S416";
target_field_name="TAX_ID";
if (length(TAX_ID) ne 9 or TAX_ID='123456789' or TAX_ID='000000000' or  TAX_ID='999999999') and (TAX_ID ne ' ') then output;

/*S417: Subject TIN type is blank.*/
error_code="S417";
target_field_name="TAX_ID_TYPE_CODE";
if (TAX_ID_TYPE_CODE = ' ') and (TAX_ID_UNK_FLG ne 'X' and ALL_CRITICAL_SUBJ_INFO_UNK_FLG = '') then output;

/*S418: Subject TIN type contains an invalid code.*/
error_code="S418";
target_field_name="TAX_ID_TYPE_CODE";
if (index("ABC",strip(TAX_ID_TYPE_CODE))=0) and (TAX_ID_TYPE_CODE ne ' ') then output;

/*S424: Subject date of birth is blank.*/
error_code="S424";
target_field_name="BIRTH_DATE";
if (BIRTH_DATE = ' ') and (BIRTH_DATE_UNK_FLG ne 'X' and ALL_CRITICAL_SUBJ_INFO_UNK_FLG = '') then output;

/*S425: Subject date of birth is less than January 1, 1900.*/
error_code="S425";
target_field_name="BIRTH_DATE";
if (substrn(BIRTH_DATE,5,4)  < '1900') and (BIRTH_DATE > ' ') then output;

/*S426: Subject date of birth contains non-numeric values or is in an invalid format.*/
error_code="S426";
target_field_name="BIRTH_DATE";
if (length(BIRTH_DATE) ne 8 or notdigit(strip(BIRTH_DATE))) and (BIRTH_DATE > ' ') then output;

/*S432: Subject corroborative statement to filer contains an invalid code.*/
error_code="S432";
target_field_name="CORROBORATIVE_STATEMENT_FILER";
if (index("AB",strip(CORROBORATIVE_STATEMENT_FILER))=0) and (CORROBORATIVE_STATEMENT_FILER ne ' ') then output;
%mend;


%MACRO VLDT_SAR_4B;

/*S406: Subject street address is blank.*/
error_code="S406";
target_field_name="ADDRESS";
if (ADDRESS = ' ') and (ADDRESS_UNK_FLG ne 'X') then output;

/*S407: Subject city is blank.*/
error_code="S407";
target_field_name="CITY_NAME";
if CITY_NAME=""  then output;

/*S408: Subject state is not a valid state code and subject country is equal to CA, MX, or US.*/
error_code="S408";
target_field_name="STATE_CODE";
if (put(strip(COUNTRY_CODE)||'_'||strip(STATE_CODE),$RT_STATE_PROVINCE.) ne 'VALID') and (STATE_CODE ne ' ' and (COUNTRY_CODE in ('CA' 'MX' 'US'))) then output;

/*S409: Subject state is blank and subject country is equal to CA, MX, or US.*/
error_code="S409";
target_field_name="STATE_CODE";
if STATE_CODE=""  then output;

/*S410: Subject ZIP Code or foreign postal code is blank.*/
error_code="S410";
target_field_name="POSTAL_CODE";
if (POSTAL_CODE = ' ') and (POSTAL_CODE_UNK_FLG ne 'X') then output;

/*S411: Subject ZIP Code is a nine digit code ending in four zeros/nines and subject country is equal to US.*/
error_code="S411";
target_field_name="POSTAL_CODE";
if (POSTAL_CODE ne compress(POSTAL_CODE,'0123456789','k')  or substr(POSTAL_CODE,6,4)='0000'  or  substr(POSTAL_CODE,6,4)='9999') and (length(POSTAL_CODE)=9 and country_code='US') then output;

/*S412: Subject ZIP Code is not equal to five or nine digits or contains non-numeric values, and subject country is equal to US.*/
error_code="S412";
target_field_name="POSTAL_CODE";
if (( length(POSTAL_CODE) ne 5 and  length(POSTAL_CODE) ne 9) or  (POSTAL_CODE ne compress(POSTAL_CODE,'0123456789','k'))) and (POSTAL_CODE ne ' ' and country_code='US') then output;

/*S413: Subject country is blank.*/
error_code="S413";
target_field_name="COUNTRY_CODE";
if COUNTRY_CODE=""  then output;

/*S414: Subject country is not a valid country code.*/
error_code="S414";
target_field_name="COUNTRY_CODE";
if (put(COUNTRY_CODE,$RT_COUNTRY.) ne 'VALID') and (COUNTRY_CODE ne ' ') then output;
%mend;


%MACRO VLDT_SAR_4C;

/*S419: Subject identification is blank.*/
error_code="S419";
target_field_name="ID_NUMBER";
if ID_NUMBER=""  then output;

/*S420: Subject identification type contains an invalid code.*/
error_code="S420";
target_field_name="ID_TYPE_CODE";
if (index("ABCZ",strip(ID_TYPE_CODE))=0) and (ID_TYPE_CODE ne ' ') then output;

/*S421: Subject identification other description is blank.*/
error_code="S421";
target_field_name="ID_TYPE_OTHER";
if (ID_TYPE_OTHER = ' ') and (index(ID_TYPE_CODE,"Z") > 0) then output;

/*S422: Subject identification issuing state is not a valid state code and subject country is equal to CA, MX, or US.*/
error_code="S422";
target_field_name="ID_AUTHORITY_STATE_CODE";
if (put(strip(ID_AUTHORITY_COUNTRY_CODE)||'_'||strip(ID_AUTHORITY_STATE_CODE),$RT_STATE_PROVINCE.) ne 'VALID') and (ID_AUTHORITY_STATE_CODE ne ' ' and (ID_AUTHORITY_COUNTRY_CODE in ('CA' 'MX' 'US'))) then output;

/*S423: Subject identification issuing country is not a valid country code.*/
error_code="S423";
target_field_name="ID_AUTHORITY_COUNTRY_CODE";
if (put(ID_AUTHORITY_COUNTRY_CODE,$RT_COUNTRY.) ne 'VALID') and (ID_AUTHORITY_COUNTRY_CODE ne ' ') then output;
%mend;


%MACRO VLDT_SAR_4E;

/*S427: Subject telephone type contains an invalid code.*/
error_code="S427";
target_field_name="PHONE_TYPE_CODE";
if (index("ABCDZ",strip(PHONE_TYPE_CODE))=0) and (PHONE_TYPE_CODE ne ' ') then output;

/*S428: Subject telephone number is blank and subject telephone type contains an entry.*/
error_code="S428";
target_field_name="PHONE_NUMBER";
if PHONE_NUMBER=""  then output;

/*S429: Subject telephone number contains non-numeric values or is in an invalid format.*/
error_code="S429";
target_field_name="PHONE_NUMBER";
if ((PHONE_NUMBER ne compress(PHONE_NUMBER,'0123456789','k'))) and (PHONE_NUMBER > ' ') then output;
%mend;


%MACRO VLDT_SAR_4F;

/*S430: Subject e-mail address is in an invalid format.*/
error_code="S430";
target_field_name="EMAIL_ADDRESS";
if (prxmatch("/[^@]+@[^@]+\.[^@]+/", EMAIL_ADDRESS) = 0) and (EMAIL_ADDRESS ne ' ') then output;
%mend;


%MACRO VLDT_SAR_4G;

/**** SKIP *****/

/*S431: Subject Website URL is in an invalid format.*/
%mend;


%MACRO VLDT_SAR_4H;

/*S434: The type of relationship of the subject to the institution listed in Part III or Part IV contains an invalid code.*/
error_code="S434";
target_field_name="SUBJECT_RELATION_TYPE";
if (compress(SUBJECT_RELATION_TYPE,'BCDEFGHIJKLZ') ne ' ') and (SUBJECT_RELATION_TYPE ne ' ') then output;

/*S435: The relationship of the subject to the institution listed in Part III or Part IV other description is blank.*/
error_code="S435";
target_field_name="SUBJECT_RELATION_TYPE_OTHER";
if (SUBJECT_RELATION_TYPE_OTHER = ' ') and (index(SUBJECT_RELATION_TYPE,"Z") > 0) then output;

/*S436: The status of the subjects relationship to the institution listed in Part III or Part IV contains an invalid code.*/
error_code="S436";
target_field_name="SUBJECT_RELATION_STATUS_CODE";
if (index("ABCD",strip(SUBJECT_RELATION_STATUS_CODE))=0) and (SUBJECT_RELATION_STATUS_CODE ne ' ') then output;

/*S437: The action date related to the status of the subjects relationship to the institution listed in Part III or Part IV is blank and Item 22b, 22c, or 22d is checked.*/
error_code="S437";
target_field_name="SUBJECT_RELATION_STATUS_DATE";
if (SUBJECT_RELATION_STATUS_DATE = .) and (SUBJECT_RELATION_STATUS_CODE > ' ') then output;

/*S438: The action date related to the status of the subjects relationship to the institution listed in Part III or Part IV contains non-numeric values or is in an invalid format.*/
error_code="S438";
target_field_name="SUBJECT_RELATION_STATUS_DATE";
if (SUBJECT_RELATION_STATUS_DATE < mdy(1,1,1900) or  SUBJECT_RELATION_STATUS_DATE > today()) and (SUBJECT_RELATION_STATUS_DATE >  .) then output;

/*S439: The action date related to the status of the subjects relationship to the institution listed in Part III or Part IV is greater than the date filed.*/
error_code="S439";
target_field_name="SUBJECT_RELATION_STATUS_DATE";
if (SUBJECT_RELATION_STATUS_DATE > today()) and (SUBJECT_RELATION_STATUS_DATE > .) then output;
%mend;


%MACRO VLDT_SAR_5A;

/*S501: The Narrative Description contains one or more blank records.*/
error_code="S501";
target_field_name="SAR_NARRATIVE_DESC";
if SAR_NARRATIVE_DESC=""  then output;
%mend;


%MACRO VLDT_SAR;

  proc sql noprint;
       delete 
       from sar_error
       where report_key=&report_key
             and error_code in ('S407' 'S409' 'S413' 'S419') 
             and entity_level_code in (select input_code 
                                       from seg_kc.fsk_rc_form_code_mapping 
                                       where form_config_key=&form_config_key and
                                             format_name='PTY')
             and entity_key in (select distinct entity_key 
                                from SAR_4A 
                                where ALL_CRITICAL_SUBJ_INFO_UNK_FLG = 'B')
            ;
   
      /* F16: A required 1A record is missing from the submitted file. */
      insert into sar_error ( error_record_type, error_code, target_field_name, report_key, entity_key, entity_level_code)
      select '' ,
             'F16',
             'TRANSMITTER_TAX_ID',
             report_key, 
             . ,
             "TRANSMITTER"  
      from sar_1a
      where transmitter_tax_id=''
      ;
   
      insert into sar_error ( error_record_type, error_code, target_field_name, report_key, entity_key, entity_level_code)
      /* F11: A required 2A record is missing from the submitted file. */
      select '' ,
             'F11',
             'INSTITUTION_TAX_ID',
             report_key, 
             . ,
             "INSTITUTION"  
      from sar_2A
      where institution_tax_id=''
      ;
   
      /* F12: A required 2B record is missing from the submitted file. */     
       select '' ,
                   'F12',
                   'INSTITUTION_NUMBER',
                   report_key, 
                   . ,
                   "INSTITUTION"  
            from sar_2B
            where institution_number=''
      ;
      
     /* F14: A required 4A record is missing from the submitted file. */
        insert into sar_error ( error_record_type, error_code, target_field_name, report_key, entity_key, entity_level_code)
        select '' ,
               'F14',
               'PARTY_NUMBER',
               report_key, 
               . ,
               "PARTY"  
        from sar_9A
        where subject_count=0
  ;
  
  /* Validate relationship of 2B and 2C */ 
  /* Perform this validation only when there are multiple institutions defined for SAR in FSK_RC_REPORT_ENTITY_INFO  */
 
  select count(distinct entity_number)  into :institution_count
  from seg_kc.fsk_rc_report_entity_info
  where entity_type_name = 'FINCEN_INSTITUTION_301'         
  ;

  %if &institution_count > 0 and %sysfunc(exist(SAR_2C)) %then
  %do;
       insert into sar_error ( error_record_type, error_code, target_field_name, report_key, entity_key, entity_level_code)
       select  '2C' ,
               'Z201',
               'BRANCH_NUMBER',
               report_key, 
               entity_key ,
               "BRANCH" 
       from SAR_2C
       where entity_key not in 
            (select distinct branch_key 
             from rc_cfg.fincen_branch(%fcf_get_ds_opts(lib_name=rc_cfg, ds_name=fincen_branch)) as branch, 
                  SAR_2B as inst
             where input(branch.parent_entity_number,best.) = input(inst.institution_number,best.)
            )
       ;
  %end; 
      
  quit; 
       

%MEND;
