/*==============================================================================
|                               SAS SAMPLE FILE
|
| NAME:    party_phone_prep.sas
| PRODUCT: SAS Compliance Solutions
| SYSTEM:  UNIX/WINDOWS
================================================================================


PREP FILE DESCRIPTION
---------------------
Creates party_phone prep data set


PREP FILE NOTES
---------------
None


PREP DATA SET(S) CREATED
------------------------
MST_PREP.PARTY_PHONE


PREP DATA SET(S) SORT ORDER
----------------------------

| Data Set                         Field                           Sort Order
|--------------------------------|-------------------------------|--------------
|PARTY_PHONE                     |PHONE_NUMBER_1                 |1
|PARTY_PHONE                     |STREET_STATE_CODE              |2


PREP DATA SET(S) VOLUME
-----------------------
1. Contingent on the maximum scenario duration of the scenarios registered to
this prep data set.


PREP DATA SET(S) NOTES
----------------------
None


================================================================================
SCENARIO(S) SUPPORTED:

- SAS10012
==============================================================================*/

/*-------------------------------------------------------------------
 * Copyright (c) 2012-2013 by SAS Institute Inc., Cary, NC 27513 USA
 *  ---All Rights Reserved.
 *-------------------------------------------------------------------*/

 proc sql;

   create table mst_prep.party_phone as

   select
      a.party_number,
      a.phone_number_1,
      a.street_state_code,
      a.entity_segment_id

   from
      seg_kc.fsc_party_dim a

   where
      phone_number_1 is not null and
      change_current_ind='Y'

   order by phone_number_1, street_state_code;

 quit;
