/*==============================================================================
|                               SAS SAMPLE FILE
|
| NAME:    party_profile_prep.sas
| PRODUCT: SAS Compliance Solutions
| SYSTEM:  UNIX/WINDOWS
================================================================================


PREP FILE DESCRIPTION
---------------------
Creates party_profile prep data set


PREP FILE NOTES
---------------
None


PREP DATA SET(S) CREATED
------------------------
MST_PREP.PARTY_PROFILE


PREP DATA SET(S) SORT ORDER
----------------------------

| Data Set                         Field                           Sort Order
|--------------------------------|-------------------------------|--------------
|PARTY_PROFILE                   |PARTY_NUMBER                   |1


PREP DATA SET(S) VOLUME
-----------------------
1. Contingent on the maximum scenario duration of the scenarios registered to
this prep data set.


PREP DATA SET(S) NOTES
----------------------
1. Although MONTH_KEY is not necessary in either the final prep data set or the
header definition, the final sort order presumes profile records appear ordered
by MONTH_KEY (ascending).


================================================================================
SCENARIO(S) SUPPORTED:

- SAS10023
- SAS10039
==============================================================================*/

/*-------------------------------------------------------------------
 * Copyright (c) 2012-2013 by SAS Institute Inc., Cary, NC 27513 USA
 *  ---All Rights Reserved.
 *-------------------------------------------------------------------*/

 proc sql;

    create table mst_prep.party_profile as

    select
       a.party_number,
       a.aggregate_assets_amount,
       a.total_wire_credits_amount,
       a.total_wire_debits_amount,
       b.entity_segment_id

    from
       seg_kc.fsc_party_profile_fact a
       left join
       db_core.fsc_party_dim b
       on a.party_number=b.party_number
       and b.change_current_ind='Y'

    order by party_number, month_key;

 quit;
