/* MAINDOC
+------------------------------------------------------------------------------+
| NAME:    rc_efile_fincen_sum_doep.sas
| PRODUCT: SAS Regulatory Console
| SYSTEM:  Windows, Unix
| DESC:    This macro generate the summary records (9<x>) specific to doep.
 |          
+------------------------------------------------------------------------------+
| USAGE:   form_config_key = form key 
|          form_type_code  = form type code (defined in FSK_RC_FORM_CONFIG)
|
+------------------------------------------------------------------------------+
MAINDOCEND */

/*-------------------------------------------------------------------
 * Copyright (c) 2016 by SAS Institute Inc., Cary, NC 27513 USA
 *  ---All Rights Reserved.
 *-------------------------------------------------------------------*/
 

%macro rc_efile_fincen_sum_doep(form_config_key=,
                               form_type_code=
                               );

    /***********************************************************************/
    /* Use report_key Change the user field of 3A to report key, not entity key           */
    /* because entity key is the subject key.                              */
    /***********************************************************************/

    proc sql ;
         update &form_type_code._3A
         set user_field=put(mod(report_key,10000000000),z10.)  
    ;
    quit;
    /***********************************************************************/
    /* Count number of reports by efile (9B)                               */
    /* set affiliated bank count to 0 since only only one bank is support. */
    /***********************************************************************/
     proc freq data=seq_report ;
     table efile_key /noprint out=report_cnt;
     run;           
    

    data &form_type_code._9B;
        if 0 then set rc_db.&form_type_code._9B(%fcf_get_ds_opts(lib_name=rc_db, ds_name=&form_type_code._9B));
        set report_cnt (keep=efile_key count ); 
        report_count=count;
        report_seq_number=99999; 
        entity_seq_number=99999;
        record_type='9B';  
        drop count;
        affiliated_bank_count=0;
    run;
    %fcf_rcset(&syserr);
    %if &trans_rc eq 3 or &trans_rc ge 5 %then %do;
         %goto MACRO_END;
    %end;
   
 
 

    /* 9Z is almost same as 9B because there is only 1 filer. */
    data &form_type_code._9Z;
         if 0 then set rc_db.&form_type_code._9Z(%fcf_get_ds_opts(lib_name=rc_db, ds_name=&form_type_code._9Z));
         set &form_type_code._9B;
         report_seq_number=99999;
         entity_seq_number=99999;
         filer_count=1;          
         record_type='9Z';
    run;
    %fcf_rcset(&syserr);
    %if &trans_rc eq 3 or &trans_rc ge 5 %then %do;
         %goto MACRO_END;
    %end;


%MACRO_END:
  

    %if &trans_rc eq 3 or &trans_rc ge 5 %then 
       %fcf_execute_macro(fcf_error);
    %else 
       %fcf_execute_macro(fcf_success);
    
  

%mend;

