/* MAINDOC
+------------------------------------------------------------------------------+
| NAME:    rc_efile_get_convesrion.sas
| PRODUCT: SAS Regulatory Console
| SYSTEM:  Windows, Unix
| DESC:    Transform the report data for e-filing (detail record level)
|          
+------------------------------------------------------------------------------+
| USAGE:    
|          form_type_code  = form type code (defined in FSK_RC_FORM_CONFIG)
+------------------------------------------------------------------------------+
MAINDOCEND */

/*-------------------------------------------------------------------
 * Copyright (c) 2018 by SAS Institute Inc., Cary, NC 27513 USA
 *  ---All Rights Reserved.
 *-------------------------------------------------------------------*/

%macro rc_efile_get_conversion( form_type_code=
                             );     

  /***********************************************/
  /* Create SAS formats for code conversion      */ 
  /***********************************************/

   proc format cntlin=rc_cfg.&form_type_code._code_conversion (rename=(format_name=fmtname
                                                          format_type=type
                                                          input_code=start
                                                          output_code=label)
                                                   where=(label ne '')
                                                      
                                                  );
   run;

   
   %fcf_rcset(&syserr);
                       
   %if &trans_rc eq 3 or &trans_rc ge 5 %then %do;
       %let _fcfmsg_=ERROR: RC: Unable to load code conversion into SAS format.;
       %fcf_put_error;
       %goto MACRO_END;
   %end;
    
    

%MACRO_END:

    %if &trans_rc eq 3 or &trans_rc ge 5 %then 
       %fcf_execute_macro(fcf_error);
    %else 
       %fcf_execute_macro(fcf_success);
    


%mend;
 
