/* MAINDOC
+------------------------------------------------------------------------------+
| NAME:    rc_format.sas
| PRODUCT: SAS Regulatory Console
| SYSTEM:  Windows, Unix
| DESC:    Loading temporary formats
|
+------------------------------------------------------------------------------+
| USAGE:   %rc_format;
+------------------------------------------------------------------------------+
MAINDOCEND */

/*-------------------------------------------------------------------
 * Copyright (c) 2016 by SAS Institute Inc., Cary, NC 27513 USA
 *  ---All Rights Reserved.
 *-------------------------------------------------------------------*/
%macro rc_format;
proc format;
  value positiveNumToX
    1-high='X'
    other=' '
;
   value $fincen_error_type 
      'F' ='Fatal'
      'P' ='Primary'
      'S' = 'Secondary'
       ;
    run;
 
 proc sql;
         create table _loc_fmt as 
         (select 'RT_COUNTRY' as fmtname ,
                  lov_type_code as start , 
                  'VALID' as label , 
                  'C' as type 
          from seg_kc.fsk_lov
          where lov_type_name='COUNTRY_ISO' and lov_language_desc='en'
         ) 
         union 
         (select 'RT_STATE_PROVINCE' as fmtname ,
             substr(lov_type_name,7,2)||'_'||strip(lov_type_code) as start , 
             'VALID' as label , 
             'C' as type 
            from seg_kc.fsk_lov
          where lov_type_name like 'STATE_%'  and lov_language_desc='en'
         )
         order by fmtname, start
    ;
    quit; 
    proc format cntlin=_loc_fmt;
    run;

    proc sql;
     create table _lov_format as
     select distinct
              a.lov_type_name as fmtname
            , a.lov_type_code  as start
            , a.lov_type_desc as label
            , 'C' as type 
     from seg_kc.fsk_lov as a
           
     where lov_type_name in ('FCF_REPORT_STATUS' 'FCF_EFILE_STATUS') 
           and lov_language_desc='en'
             
     order by fmtname
     ;

quit;
proc format cntlin=_lov_format;
run; 

%mend;
