/* MAINDOC
+------------------------------------------------------------------------------+
| NAME:    rc_nobs
| PRODUCT: SAS Regulatory Console
| SYSTEM:  Windows, Unix
| DESC:    get observations in a table
+------------------------------------------------------------------------------+
| USAGE:  %rc_nobs (WORK.X)
/+------------------------------------------------------------------------------+
MAINDOCEND */

/*-------------------------------------------------------------------
 * Copyright (c) 2016 by SAS Institute Inc., Cary, NC 27513 USA
 *  ---All Rights Reserved.
 *-------------------------------------------------------------------*/

%macro rc_nobs (  dsn               /* partially or fully qualified SAS file */
                , nobstype = nlobs  /* nobs, nlobs, nlobsf                   */
               )    /des='get obs count for a table';

   %local n_obs;

   %let dsid = %sysfunc (open (&dsn(%fcf_get_ds_opts(ds_name=&dsn))));
   %if &dsid = 0 %then %goto mExit;
   %let n_obs = %sysfunc (attrn (&dsid, &nobstype));
   %let rc   = %sysfunc (close (&dsid));

   &n_obs

   %mExit:

%mend rc_nobs;
